package clarion.acs.gs;
import clarion.acs.net.*;
import clarion.system.*;
import clarion.nacs.*;

public class GSNet extends AcsNet {

  int gsOption;
  GoalStructure gs;

  public GSNet( int nIdx, Global g )
  {
     super( nIdx, g );
     gsOption = global.getGsOption();
     if( gsOption == global.GS_LIST )
         gs = new GoalList( global );
     else
         gs = new GoalStack( global );
  }

  // reasoning for determining an action to perform given current input.
  public void reasoning()
  {
     // get active net comps.
     if( global.getGoalDecisionMode() == Global.ACTION_BY_TL ){
         for( int i = 0; i < COMP_NUM; i++ ){
              if( netCompFlags[ i ] ){
                  netComps[ i ].setStates( state, exState, gsState, wmState );
                  netComps[ i ].reasoning();
              }
         }
         // select which part: BL, RER, IRL or FR to decide action.
         chosenComp = Global.FR;
         // decide an action.
         decideAction( chosenComp );
         // set the chosen action.
         deliverAction();
     }
     else
         super.reasoning();
  }

  public void perform()
  {
     //System.out.println( "GSNet.java, performed action = " + chosenAction[0] );

     boolean updateFlag = false;
     if( chosenAction[0] < gs.getSize() )    // a set action.
         updateFlag = gs.actionSet( chosenAction[0] );
     else if( chosenAction[0] < 2 * gs.getSize() )   // a reset action.
              updateFlag = gs.actionReset( chosenAction[0] - gs.getSize() );
          else if( chosenAction[0] == 2 * gs.getSize() )   // do-nothing action.
                   updateFlag = gs.actionNoGoal();
     // update current state.
     if( updateFlag ){
         if( gsOption == global.GS_STACK || ((GoalList)gs).goalCompete() )
             gs.updateState( gsState );
     }
  }

}