package clarion.acs.net;
import clarion.acs.net.auxiliary.*;
import clarion.system.*;
import clarion.common.*;
import clarion.nacs.*;
import clarion.acs.gs.*;
import clarion.acs.wm.*;

public class FixRule extends TLRule {
   protected int groupId;     // decide which FR subset is used.

   public FixRule( int groupIdx, int netIdx, int setIdx, Global global )
   {
       super( netIdx, Global.FR, setIdx, global );
       this.groupId = groupIdx;

       //System.out.println("groupIdx = " + groupId );

       conditions = taskClarion.getFrCondition( groupId, netIdx, setIdx );
       suggestedAction = taskClarion.getFrAction( groupId, netIdx, setIdx );

       //System.out.println( "action = " + suggestedAction[0] );

       if( suggestedAction == null )
           suggestedAction = new short[ OUTPUT_DIM_NUM ];
   }

   public void setGroupId( int id )
   {
      groupId = id;
   }

   public boolean decideAction( short[] state, short[] exState, short[] gsState, short[] wmState )
   {
       boolean matchFlag = false;
       if( conditions != null ){
           matchFlag = super.decideAction( state, exState, gsState, wmState );
       }
       else{
           //System.out.println( global.getClarion().getSensoryInput() );
           //System.out.println( global.getGS().getActiveItem() );
           //System.out.println( global.getWM().getItems() );

           GoalChunk goalItem = global.getGsOption()!=Global.GS_NON ? global.getGS().getActiveItem():null;
           GKSChunk[] wmItems = global.isWmOn() ? global.getWM().getItems():null;

           ruleSupport = taskClarion.decideFrAction( groupId, netIdx, setIdx,
                         global.getClarion().getSensoryInput(), goalItem, wmItems, suggestedAction );
           if( Math.abs(ruleSupport-1.0) < 0.01 )
               matchFlag = true;
       }

       return matchFlag;
   }

/*************************** OVERRIED METHODS *********************************/
  public String toString()
  {
       return "net = " + netIdx + ", fix rule: " + setIdx + "\n";
  }
}