package clarion.acs.net;
import java.util.TreeMap;
import clarion.acs.net.auxiliary.*;
import clarion.system.*;
import clarion.tools.*;

public class FixRuleSet extends TLRuleSet {
   protected int groupId;           // decide which FR subset is used.
   protected boolean UTL_FLAGs[];   // utility flag of each FR rule.
   // used for RT.
   protected int actionBLAoptions[];

   public FixRuleSet( int netIdx, Global global )
   {
       super( netIdx, Global.FR, global );
       groupId = global.getAgentGroupId();
       RULE_NUM = global.getFixRuleNum( netIdx );
       ruleList = new FixRule[ RULE_NUM ];
       for( int i = 0; i < RULE_NUM; i++ )
            ruleList[ i ] = new FixRule( groupId, netIdx, i, global );
       ruleUtls = new double[ RULE_NUM ];
       recommendRules = new short[ RULE_NUM ];
       actionBLAoptions = new int[ RULE_NUM ];
       for( int i = 0; i < RULE_NUM; i++ ){
            if( !global.isRuleBlaOn( netIdx, global.FR, i ) ){
                actionBLAoptions[ i ] = global.EMPTY;
                continue;
            }
            actionBLAoptions[ i ] = global.getAcsChunkBlaOption( netIdx, global.FR, i );
       }
   }
}