package clarion.acs.net.auxiliary;
import clarion.system.*;
import clarion.common.*;
/**
 *  this class is used for recording the action chunk usage.
 */
public class ActionUsageInfo {

   static final int MAX_USAGE_NUM = 1000;
   // used for RT.
   int   usageNum;
   int[] usages = new int[ MAX_USAGE_NUM ];
   double c, d, iBLA, BLA;

   public ActionUsageInfo( int initTime, double[] params )
   {
      usageNum = 1;
      usages[0] = initTime;
      c = params[Global.BLA_C];
      d = params[Global.BLA_D];
      iBLA = params[Global.BLA_I];
   }

   public int getUsageNum()
   {
      return usageNum;
   }

   public double getBla()
   {
      return BLA;
   }

   public void increaseUsage( int currentTime )
   {
      if( currentTime <= usages[usageNum-1] )
          return;
      usages[usageNum++] = currentTime;
   }

   public void calcBla( int curTime )
   {
       double sum = iBLA;
       for( int i = 0; i < usageNum; i++ ) {
            int timeLaps = curTime - usages[ i ];
            if( timeLaps <= 0 ){
                //System.out.println( "error usage recording in RuleAttributes.java" );
                break;
            }
            sum += c * Math.pow( (double)timeLaps, -d );
       }
       BLA = sum;
       if( BLA < 0.01 )
           BLA = 0.01;
   }
}