package clarion.acs.net.auxiliary;

/**
 * the class implements the key to elements in a collection.
 */
public class KeyToValue implements Comparable {
     int DIM_NUM;
     int multipliers[];
     short[] keys;

     public KeyToValue( short[] action, int[] multipliers )
     {
          DIM_NUM = action.length;
          keys = new short[ DIM_NUM ];
          for( int i = 0; i < DIM_NUM; i++ )
               keys[i] = action[i];
          this.multipliers = multipliers;
     }

     public int getDimNum()
     {
        return DIM_NUM;
     }

     public short[] getKeys()
     {
        return keys;
     }

     public int hashCode()
     {
        int code = 0;
        for( int i = 0; i < keys.length; i++ )
             code += keys[i] * multipliers[i];
        return code;
     }

     public boolean equals( Object obj )
     {
        if( obj == null || !( obj instanceof KeyToValue ) || getDimNum() != ((KeyToValue)obj).getDimNum() )
            return false;
        short[] otherKeys = ((KeyToValue)obj).getKeys();
        for( int i = 0; i < DIM_NUM; i++ )
             if( keys[i] != otherKeys[i] )
                 return false;
        return true;
     }

     public int compareTo(Object obj) throws ClassCastException
     {
        KeyToValue otherKey = null;
        try{
           otherKey = (KeyToValue)obj;
        }
        catch( ClassCastException e ){
               System.out.println( e );
        }
        return this.hashCode() - otherKey.hashCode();
     }
}
