// class LinkedNode used for managing the rule nodes.
package clarion.acs.net.auxiliary;
import clarion.system.*;
import clarion.acs.net.*;

public class LinkedNode {

   private RerRule element;
   private LinkedNode sible;
   private LinkedNode child;

   public LinkedNode( int netIdx, Global g )
   {
         element = new RerRule( netIdx, g );
         sible = null;
         child = null;
   }

   public LinkedNode( int netIdx, Global g, short[] state, short[] action, boolean mFlag )
   {
         element = new RerRule( netIdx, g, state, action, mFlag );

         sible = null;
         child = null;
   }

   public LinkedNode( int netIdx, Global g, short[] state, short[] action, boolean mFlag, int vDimNum )
   {
         element = new RerRuleEx( netIdx, g, state, action, mFlag, vDimNum );
         sible = null;
         child = null;
   }

   public LinkedNode( RerRule rule )
   {
         element = rule;
         sible = null;
         child = null;
   }

   public RerRule getElement()
   {
         return element;
   }

   public LinkedNode getSible()
   {
         return sible;
   }

   public LinkedNode getChild()
   {
         return child;
   }

   public void setElement( RerRule rule )
   {
         element = rule;
   }

   public void setSible( LinkedNode s )
   {
         sible = s;
   }

   public void setChild( LinkedNode c )
   {
         child = c;
   }
 }