/********************* GET INSTRUCTIONS TEXT  ********************************/
package clarion.common;
import main.ClarionMain;

public class InstrText {

  public final static int ROWS = 20, COLS = 55;
  private String rightReserveInfo =
    "( Copyright, CLARION group, UMC. Do not distribute or duplicate. All rights reserved. )";
  private String[] taskInstructions = {
          "               Instructions:               \n" +
          "                                                              \n" +
          "1. The upper-right text area allows you to input a  number    \n" +
          "   indicating how many blocks you want to train. You  should  \n" +
          "   input an integer ranging from 1 to 1000, otherwise a dialog\n" +
          "   box will be shown indicating an input error. By default,   \n" +
          "   the block number is 20.                                    \n" +
          "2. The mid-right text area is to show the file name you chose \n" +
          "   or created from your hard disk to save the training data . \n" +
          "3. The button ENTER will be enabled if both of above are done \n" +
          "   correctly, and when pushed, lets you enter into the experiment\n" +
          "4. The button SELECT FILE, when pushed,lets you select or create \n" +
          "   a file as explained in  2.                                    \n" +
          "5. When the button EXIT is pushed, the entire program will exit. \n" +
          "6. The button \"by human \" indicates the task is to be controlled" +
          "   by human subjects. The button \"by Clarion\" indicates the task" +
          "   is to be controlled by CLARION. The button \"by ACT-R\" indicates" +
          "   the task is to be controlled by ACT-R.                        \n" +
          "7. When the button \" CLARION SETTING\" is pushed, it will enter \n" +
          "   CLARION model environment which is similar to the first screen.\n" +
          "8. In the training screen, first you should decide whether you \n" +
          "   want to show the parameter settings or not by pushing the   \n" +
          "   button SHOW SETTING, an option frame will be shown to let   \n" +
          "   you make a decision.                                        \n" +
          "9. The button EQUATIONS lets you select a kind of equation to  \n" +
          "   be trained, there are three kinds of equations: linear,     \n" +
          "   power and U-shape.                                          \n" +
          "10. The button PARAMETERS lets you select a pair of parameters \n" +
          "   for the equation you've selected.                           \n" +
          "11. The button BEGIN will be enabled if both equition type and \n" +
          "   parameters are selected, and when pushed, the\"Next Input\" \n" +
          "   list will be enabled and now you can select an input.      \n" +
          "12. The button BEGIN, when pushed, an initial pair of input and \n" +
          "   output will be generated randomly and shown on the screen.   \n" +
          "13. The button USE TIMER, when pushed, an option frame will be  \n" +
          "   shown to let you enable the timer or not.                    \n" +
          "14. The button TIME SETTING will be enabled when button USE TIMER\n" +
          "   is set to ON, and when pushed, an option frame will be shown  \n" +
          "   to let you set a time limit to each trial for the subjects.   \n" +
          "15. The button NOISE SETTING, when pushed, lets you set the ratio\n" +
          "   of each kinds of noises which will be considered  when        \n" +
          "   calculating the output p1.                                    \n" +
          "16. The button TARGET SETTING, when pushed, lets you set the     \n" +
          "   target level.                                                 \n" +
          "17.In the \"Next Input\"  list shown on the left side of the  \n" +
          "   window,, you can use a mouse to select a value from it and \n" +
          "   the  value will be shown on the \"trial 1\" in the part of \n" +
          "   window showing the current input and the corresponding     \n" +
          "   output will be produced  and shown above the  \"trial 1 in \n" +
          "   in the part of window showing the current output.          \n" +
          "18. You can select one by one and corresponding data will be   \n" +
          "   shown on  the  proper areas just the same as step 17 says  \n" +
          "   until you have 10 trials.                                  \n" +
          "19. When finishing one block ( 10 trials ), a dialog will  be  \n" +
          "   shown  to inform you  enter the  next  block. some parts of \n" +
          "   windows will be cleared and wait for your next block of    \n" +
          "   training.                                                  \n" +
          "20. when the number of block you have tried reaches the number \n" +
          "   you expected, a dialog box will be  shown to inform you that  \n" +
          "   current session is terminated and the training data are saved \n" +
          "   to the file which you ever created or selected before. and    \n" +
          "   ask you if go to next section of training.                    \n" +
          "21. when you push the 'exit' button in this screen, all training \n" +
          "   data will be saved and the program will exit from the current \n" +
          "   screen and go back to the prevous screen.                  \n" +
          "22. The 'x' button located in top-right corner of the windows, \n" +
          "   belongs to the Java platform and its function is to close   \n" +
          "   the window. When pushed, all the training data will be saved \n" +
          "   if exist, and the entire program will exit.                \n" +
          "23. All the training data include the initial randomly generated \n" +
          "   data.                                                      \n" +
          "24. The data file is in a text format and can be read by word or \n" +
          "   wordpad in windows and vi in unix and linux and other text \n" +
          "   viewers can also read it. Notepad has some problem viewing \n" +
          "   it.                                                        \n",
          "LC task instructions",
          "TH task instructions",
          "CI task instructions",
          "DS task instructions",
          "AGL task instructions"
  };

  public String getRightReserveInfo()
  {
     return rightReserveInfo;
  }

  public String getTaskInstructions( String taskName )
  {
     for( int i = 0; i < ClarionMain.CLARION_TASK_TEXT.length; i++ )
          if( ClarionMain.CLARION_TASK_TEXT[i].equals( taskName ) )
              return taskInstructions[i];
     return taskName + " Instructions";
  }
}