// this class contains all the global constants
// and functions to give world responses and feedback
package clarion.common;

public class World {

   public final static int EQU_TYPE_NUM = 3;
   public final static int RULE_MIN_APP = 3;
   public final static int INPUT_MEAN_LEVEL = 5;
   public final static int OUTPUT_TARGET_LEVEL = 5;

   public final static double MAX_ACTIVATION_VAL = 1.0;
   public final static double MAX_ERROR_VAL = 0.9;

   public static final int HUMAN_MODE = 0;
   public static final int CLARION_MODE = 1;
   public static final int ACTR_MODE = 2;
   public static final int PC_MODE_NUM = 3;

   public static final int PC_TASK = 0;
   public static final int LC_TASK = 1;
   public static final int TH_TASK = 2;
   public static final int CI_TASK = 3;
   public static final int DS_TASK = 4;
   public static final int NEW_TASK = 5;
   public static final int CLARION_TASK_NUM = 6;

   // CLARION MODEL MAIN PARAMETERS
   /*
   public static final String[] OPT_ACS_BASIC_TEXTS = {
    "Options for ACS components: "
   }; */

   public static final int MAIN_OPTION_NUM = 23;
   public static final String[] MAIN_OPTION_TEXT =
      {
         " Used working structure: ",
         " Bottom-level representatin options(ACTION NETWORK): ",
         " Bottom-level learning options: ",
         " Rule display opntions: ",
         " Rule display frequency: ",
         " Charateristics of input dimensions of rules: ",
         " Rule generalization/specialization options: ",
         " Rule merge options: ",
         " Rule learning options: ",
         " RER rule density parameter: ",
         " RER extraction probability parameter: ",
         " RER rule extraction direction: ",
         " RER Rule positivity criterion: ",
         " IRL Rule positivity criterion: ",
         " RER IG measures for rule learning: ",
         " IRL IG measures for rule learning: ",
         " Rule representation: ",
         " Rule base-level activation options: ",
         " Rule utility options: ",
         " Working memory activation options: ",
         " Cross-level combination: ",
         " If 'fixed', choose one: ",
         " If 'variable', choose one: ",
     };

   public static final String[][] MAIN_OPT_ITEM_TEXT =
   {
     {"goal", "WM", " EM", "SM"},
     {"WM", "goal", "external"},
     {"Q-learing", " simplied Q-learning", "supervised BP learing"},
     {"no display", "only matching input", "matching input and action" },
     {"no display", " every step", "every 10 step"},
     {"ordinal", "non-ordinal"},
     {"contiguous value range", "non-contiguouse value range"},
     {"no merge at all", "ervery step", "every 10 step"},
     {"RER RULE", "IRL RULE", "FIXED RULE"},
     {"50", "100", "200" },
     {"0.5", "0.8", "1.0" },
     {"specific-to-general", "general-to-specific" },
     {"if r + maxQ( y, b ) - Q( x, a ) > thresholdRER"},
     {"if r + maxQ( y, b ) - Q( x, a ) > thresholdIRL"},
     {"IG( C, all )" },
     {"IG( C )" },
     {"rule strength", "rule utility", "partial matching" },
     {"fixed base level", "recency-based base level"},
     {"constants", "functions"},
     {"fixed" , "recency-based"},
     {"fixed", "variable" },
     {"stochastic combination","percentage combination"},
     {"stochastic combination","percentage combination"}
   };
   public static final int[] CHECK_BOX_IDX = {  0, 8, 16 };
   public static final int[] MAIN_OPT_ITEM_NUM =
   {
     4, 3, 3, 3, 3,
     2, 2, 3, 3, 3,
     3, 2, 1, 1, 1,
     1, 3, 2, 2, 2,
     2, 2, 2
   };

   public static final int WORK_STRUC = 0;
   public static final int BL_REP_OPT = 1;
   public static final int BL_LEARN_OPT = 2;
   public static final int RULE_DISP_OPT = 3;
   public static final int RULE_DISP_FREQ = 4;
   public static final int CHAR_INPUT_RULE = 5;
   public static final int RULE_GEN_SPEC = 6;
   public static final int RULE_MERGE = 7;
   public static final int RULE_LEARN_OPT = 8;
   public static final int RER_DENSITY_OPT = 9;
   public static final int RER_EXT_PROB = 10;
   public static final int RER_EXT_DIR = 11;
   public static final int RER_POS_CRT = 12;
   public static final int IRL_POS_CRT = 13;
   public static final int RER_IG_OPT = 14;
   public static final int IRL_IG_OPT = 15;
   public static final int RULE_REP_OPT = 16;
   public static final int RULE_BLA_OPT = 17;
   public static final int RULE_UTL_OPT = 18;
   public static final int WM_ACT_OPT = 19;
   public static final int CROSS_COMB_OPT = 20;
   public static final int FIX_COMB_OPT = 21;
   public static final int VAR_COMB_OPT = 22;

   public static int[][] MODEL_PARA_ARRAY = new int[ MAIN_OPTION_NUM ][];
   public static final int[][][] DEF_MODEL_PARA_ARRAY =
   {
     {      // FOR PC TASK
       {1,0,0,0},{1,0,0},{1,0,0}, {1,0,0},{1,0,0},
       {1,0},    {1,0},  {1,0,0}, {1,0,0},{1,0,0},
       {1,0,0},  {1,0},  {1},     {1},   {1},
       {1},      {1,0,0},{1,0},   {1,0}, {1,0},
       {1,0},    {1,0},  {1,0}
     },
     {      // FOR LC TASK
       {1,0,0,0},{1,0,0},{1,0,0}, {1,0,0},{1,0,0},
       {1,0},    {1,0},  {1,0,0}, {1,0,0},{1,0,0},
       {1,0,0},  {1,0},  {1},     {1},   {1},
       {1},      {1,0,0},{0,1},   {0,1}, {1,0},
       {0,1},    {0,1},  {0,1}
     },
     {      // FOR TH TASK
       {1,0,0,0},{1,0,0},{1,0,0}, {1,0,0},{1,0,0},
       {1,0},    {1,0},  {1,0,0}, {1,0,0},{1,0,0},
       {1,0,0},  {1,0},  {1},     {1},   {1},
       {1},      {1,0,0},{1,0},   {1,0}, {1,0},
       {1,0},    {1,0},  {1,0}
     },
     {      // FOR CI TASK
       {1,0,0,0},{1,0,0},{1,0,0}, {1,0,0},{1,0,0},
       {1,0},    {1,0},  {1,0,0}, {1,0,0},{1,0,0},
       {1,0,0},  {1,0},  {1},     {1},   {1},
       {1},      {1,0,0},{1,0},   {1,0}, {1,0},
       {1,0},    {1,0},  {1,0}
     },
     {      // FOR DC TASK
       {1,0,0,0},{1,0,0},{1,0,0}, {1,0,0},{1,0,0},
       {1,0},    {1,0},  {1,0,0}, {1,0,0},{1,0,0},
       {1,0,0},  {1,0},  {1},     {1},   {1},
       {1},      {1,0,0},{1,0},   {1,0}, {1,0},
       {1,0},    {1,0},  {1,0}
     },
     {      // FOR NEW TASK
       {1,0,0,0},{1,0,0},{1,0,0}, {1,0,0},{1,0,0},
       {1,0},    {1,0},  {1,0,0}, {1,0,0},{1,0,0},
       {1,0,0},  {1,0},  {1},     {1},   {1},
       {1},      {1,0,0},{1,0},   {1,0}, {1,0},
       {1,0},    {1,0},  {1,0}
     }
   };

   public static final int  BLPT = 0;
   public static final int  TLPT = 1;
   public static final int  BLDT = 2;
   public static final int  TLDT = 3;
   public static final int  BLAT = 4;
   public static final int  TLAT = 5;
   public static final int STRUCTURAL_PARA_NUM = 6;
   public static final String[] STRUCTURAL_PARA_TEXT =
     {
         " BLPT ", " TLPT ", " BLDT ", " TLDT ", " BLAT ", " TLAT "
     };
   public static double[] STRUCTURAL_PARA_ARRAY =
                          new double[ STRUCTURAL_PARA_NUM ];

   // TASK-SPECIFIC PARAMETERS
   public static final int TASK_PARA_NUM = 25;
   public static final String[] TASK_PARA_TEXT =
   {
      "Number of BP networks: ",     "Number of input dimenstions: ",
      "Number of input units(BP): ", "Number of hidden units(BP): ",
      "Number of output units(BP): ",
      "NET_LRATE",                    "NET_MOMENTUM",
      "Q_DISCOUNT_RATE",              "TEMPERATURE",
      "HIGH_RER_THRESHOLD",           "LOW_RER_THRESHOLD",
      "HIGH_RER_THRESHOLD1",          "HIGH_RER_THRESHOLD2",
      "LOW_RER_THRESHOLD1",           "LOW_RER_THRESHOLD2",
      "HIGH_IRL_THRESHOLD",           "LOW_IRL_THRESHOLD",
      "Weight of bottom level",       "Weight of RER rule",
      "Weight of IRL rule",           "Weight of fixed rule",
      "Probability of bottom level",  "Probability of RER rule",
      "Probability of IRL rule",      "Probability of fixed rule"
   };

   public static final int NET_NUM = 0;
   public static final int NET_DIM_NUM = 1;
   public static final int NET_INPUT_NUM = 2;
   public static final int NET_HIDDEN_NUM = 3;
   public static final int NET_OUTPUT_NUM = 4;
   public static final int NET_LRATE = 5;
   public static final int NET_MOMENTUM = 6;
   public static final int Q_DISCOUNT_RATE = 7;
   public static final int TEMPERATURE = 8;
   public static final int HIGH_RER_THRESHOLD = 9;
   public static final int LOW_RER_THRESHOLD = 10;
   public static final int HIGH_RER_THRESHOLD1 = 11;
   public static final int HIGH_RER_THRESHOLD2 = 12;
   public static final int LOW_RER_THRESHOLD1 = 13;
   public static final int LOW_RER_THRESHOLD2 = 14;
   public static final int HIGH_IRL_THRESHOLD = 15;
   public static final int LOW_IRL_THRESHOLD = 16;
   public static final int WBL = 17;
   public static final int WRER = 18;
   public static final int WIRL = 19;
   public static final int WFIX = 20;
   public static final int PBL = 21;
   public static final int PRER = 22;
   public static final int PIRL = 23;
   public static final int PFIX = 24;
   public static double[] TASK_PARA_ARRAY = new double[ TASK_PARA_NUM ];
   public static final double[][] DEF_TASK_PARA_ARRAY =
   {
       {  // for PC TASK
           1,    6,    72,   40,  12,
           0.1,  0.2,  0.95,
           0.115,
           1.0,   0.0, 2.0,  1.0,  -0.01,  -0.1,
           0.35,  0.2,
           0.5,  0.15, 0.15, 0.2,
           0.5,  0.15, 0.15, 0.2
       },
       {  // for LC TASK
           1,    3,    78,   30,  26,
           0.9,  0.4,  0.9,
           0.01,
           1.0,   0.0, 2.0,  1.0,  -0.01,  -0.1,
           0.35,  0.2,

           //0.24, 0.0, 0.0, 0.2,       // for LC simu1.
           //0.33, 0.3, 0.0, 0.3,       // for LC simu1'.
           //0.1, 0.1, 0.0, 0.0,        // for LC simu1''.
           //0.1, 0.0, 0.0, 0.0,        // for LC simu1'''.
           //0.1, 0.0, 0.0, 0.2,        // for LC simu2.
           //0.2, 0.1, 0.0, 0.6,        // for LC simu2'.
           //0.1, 0.1, 0.0, 0.0,        // for LC simu2''.
           //0.1, 0.0, 0.0, 0.0,        // for LC simu1'''.
           //0.4, 0.0, 0.0, 0.2,       // for LC simu1  without BBT.
           0.1, 0.0, 0.0, 0.2,          // for LC simu2  without BBT.
           //0.2, 0.4, 0.0, 0.6,        // for LC simu2' without BBT.

           //0.24, 0.0, 0.0, 0.2,       // for LC simu1.
           //0.33, 0.3, 0.0, 0.3,       // for LC simu1'.
           //0.1, 0.1, 0.0, 0.0,        // for LC simu1''.
           //0.1, 0.0, 0.0, 0.0,        // for LC simu1'''.
           //0.1, 0.0, 0.0, 0.2,        // for LC simu2.
           //0.2, 0.1, 0.0, 0.6,        // for LC simu2'.
           //0.1, 0.1, 0.0, 0.0,        // for LC simu2''.
           //0.1, 0.0, 0.0, 0.0,        // for LC simu1'''.
           //0.4, 0.0, 0.0, 0.2,       // for LC simu1  without BBT.
           0.1, 0.0, 0.0, 0.2,        // for LC simu2  without BBT.
           //0.2, 0.4, 0.0, 0.6,        // for LC simu2' without BBT.
       },
       {  // for TH TASK
           1,     18,   108,  80,  6,
           0.03,  0.03,  0.95,
           0.1,
           0.1,  0.08, 3.0,  1.0,  2.0,  0.5,
           0.35,  0.2,
           0.5,  0.15, 0.15, 0.2,
           0.5,  0.15, 0.15, 0.2
       },
       {  // for CI TASK
           1,     18,   108,  60,  6,
           0.3,   0.1,  0.95,
           0.1,
           0.05,  0.03, 3.6,  1.0,  2.0,  0.5,
           0.35,  0.2,
           //0.18,  0.0, 0.0, 0.82,
           //0.18,  0.0, 0.0, 0.82  // used for exp1.
           //0.04,  0.0, 0.0, 0.96,
           //0.04,  0.0, 0.0, 0.96    // used for exp2.
           //0.01,  0.0, 0.0, 0.99,
           //0.01,  0.0, 0.0, 0.99    // used for exp4.
           //0.02,  0.0, 0.0, 0.98,
           //0.02,  0.0, 0.0, 0.98    // used for exp5.
           0.2,  0.0, 0.0, 0.8,
           0.2,  0.0, 0.0, 0.8        // used for exp5.
           //0.1,  0.0, 0.0, 0.9,
           //0.1,  0.0, 0.0, 0.9        // used for exp5.
       },
       {  // for Discovery TASK
           1,     20,   320,  100,  320,
           0.3,   0.1,  0.95,
           0.1,
           0.05,  0.03, 3.6,  1.0,  2.0,  0.5,
           0.35,  0.2,
           0.2,  0.0, 0.0, 0.8,
           0.2,  0.0, 0.0, 0.8
       },
       {  // for New TASK
           1,     20,   320,  100,  320,
           0.3,   0.1,  0.95,
           0.1,
           0.05,  0.03, 3.6,  1.0,  2.0,  0.5,
           0.35,  0.2,
           0.2,  0.0, 0.0, 0.8,
           0.2,  0.0, 0.0, 0.8
       }
   };
}
