package clarion.mcs;
import clarion.system.*;
import clarion.acs.*;
import clarion.nacs.*;
import clarion.common.*;

public class Drives {

 final int DRIVE_NUM = 8;
 double foodDeficit, foodStimulus;
 double waterDeficit, waterStimulus;
 double dangerStimulus, dangerCertainty;
 double nightProximity, exhaustion;
 double mateStimulus;
 double belongingDeficit, esteemDeficit, selfActualDeficit;

 public int getLength()
 {
    return DRIVE_NUM;
 }

 public double getFoodStrength()
 {
    return 0.95 * Math.max( foodDeficit, foodDeficit * foodStimulus );
 }

 public double getWaterStrength()
 {
    return 0.95 * Math.max( waterDeficit, waterDeficit * waterStimulus );
 }

 public double getAvoidDangerStrength()
 {
    return 0.98 * dangerStimulus * dangerCertainty;
 }

 public double getSleepStrength()
 {
    return 0.95 * Math.max( nightProximity, exhaustion );
 }

 public double getReproduceStrength()
 {
    return 0.3 * ( 0.6 + mateStimulus );
 }

 public double getBelongingStrength()
 {
    return 0.2 + 0.5 * belongingDeficit;
 }

 public double getEsteemStrength()
 {
    return 0.15 + 0.45 * esteemDeficit;
 }

 public double getSelfActualStrength()
 {
    return 0.1 + 0.4 * selfActualDeficit;
 }

}
