package clarion.nacs;
import clarion.common.*;

public class ProbBPNet {

   protected double alpha;
   protected int INPUT_NUM, OUTPUT_NUM;
   protected double inputs[], outputs[];
   protected double desiredOutputs[], weights[][];

   public ProbBPNet( int num1, int num2, double lr )
   {
      INPUT_NUM = num1;
      OUTPUT_NUM = num2;
      alpha = lr;
      inputs = new double[ INPUT_NUM ];
      outputs = new double[ OUTPUT_NUM ];
      desiredOutputs = new double[ OUTPUT_NUM ];
      weights = new double[ INPUT_NUM ][ OUTPUT_NUM ];
      initWeights();
   }

   public double getOutput( int idx )
   {
      return outputs[ idx ];
   }

   public void getOutputs( double[] arr )
   {
      for( int i = 0; i < arr.length; i++ )
           arr[ i ] = outputs[ i ];
   }

   public void setInputs( int[] arr )
   {
      for( int i = 0; i < arr.length; i++ )
           inputs[ i ] = arr[ i ];
   }

   public void setInputs( double[] arr )
   {
      for( int i = 0; i < arr.length; i++ )
           inputs[ i ] = arr[ i ];
   }

   public void setDesiredOutputs( int[] arr )
   {
      for( int i = 0; i < arr.length; i++ )
           desiredOutputs[ i ] = arr[ i ];
   }

   public void setDesiredOutputs( double[] arr )
   {
      for( int i = 0; i < arr.length; i++ )
           desiredOutputs[ i ] = arr[ i ];
   }

   public void forward()
   {
      for( int i = 0; i < OUTPUT_NUM; i++ )
           outputs[ i ] = 0.0;
      for( int i = 0; i < INPUT_NUM; i++ )
        for( int j = 0; j < OUTPUT_NUM; j++ )
             outputs[ j ] += inputs[ i ] * weights[ i ][ j ];
      for( int i = 0; i < OUTPUT_NUM; i++ )
           outputs[ i ] = 1.0 / ( 1.0 + java.lang.Math.exp( -outputs[ i ] ) );
   }

   public void backward()
   {
      //System.out.println( "stateIdx = " + stateIdx + ", actionIdx = " + actionIdx
      //                    + ", weight before = " + weights[stateIdx][actionIdx] );
      for( int i = 0; i < INPUT_NUM; i++ )
        for( int j = 0; j < OUTPUT_NUM; j++ )
        {
             double deltaW = alpha * ( desiredOutputs[ j ] - outputs[ j ] ) * inputs[ i ];
             weights[ i ][ j ] += deltaW;
        }
      //System.out.println( "weight after = " + weights[stateIdx][actionIdx] );
   }

   public void initWeights()
   {
      double HINITWEIGHT = 0.01;
      double LINITWEIGHT = -0.01;
      for( int i = 0; i < INPUT_NUM; i++ )
        for( int j = 0; j < OUTPUT_NUM; j++ )
        {
             double sign, value;
             if ( java.lang.Math.random() < 0.5 )
                  sign = LINITWEIGHT;
             else
                  sign = HINITWEIGHT;
             value = java.lang.Math.random();
             weights[ i ][ j ] =  value * sign;
        }
   }
}