package clarion.options;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.dims.*;
import clarion.options.acs.*;
import clarion.options.nacs.*;
import clarion.options.supervise.*;
import clarion.options.rt.*;
import clarion.options.inter.*;
import clarion.options.taskspec.*;

public class GuiClarion extends GuiTemplate{

  final int BTN_SUBSYS = 0, BTN_DIM = 1, BTN_ACS = 2, BTN_NACS = 3;
  final int BTN_SUPER = 4, BTN_RT = 5, BTN_INTER = 6, BTN_TS = 7;
  String buttonTexts[] = {
     "Subsystem selection",
     "Input and Output dimensions",
     "Action-Centered Subsystem  Options",
     "Non-Action-Centered Subsystem Option",
     "Supervisory Subsystems Option",
     "Response Time Determination Option",
     "Interface Options",
     "Task specific Options"
  };
  GuiTemplate[] guiSubSys;
  SelectionTemplate[] selOptions;

  public GuiClarion( int num, Global[] globals )
  {
     super( num, "CLARION PARAMETER SETTINGS", globals );
     setButtonTexts( buttonTexts );
  }

  public void loadSubSys()
  {
     transfer.load();
     guiSubSys = new GuiTemplate[ 4 ];
     guiSubSys[ 0 ] = new GuiDims( 2 );
     guiSubSys[ 1 ] = new GuiACS( 4 );
     guiSubSys[ 2 ] = new GuiNACS( 5 );
     guiSubSys[ 3 ] = new GuiSupervisory( 3 );
     for( int i = 0; i < 4; i++ )
          guiSubSys[i].init( this );
     selOptions = new SelectionTemplate[ 4 ];
     selOptions[ 0 ] = new SelectionSubSys( this, 400, 200, transfer );
     selOptions[ 1 ] = new SelectionRT( this, 660, 900, transfer );
     selOptions[ 2 ] = new SelectionInter( this, 440, 320, transfer );
     selOptions[ 3 ] = new SelectionTaskSpec( this, 330, 300, transfer );
     // update button status.
     optButtons[BTN_NACS].setEnabled( transfer.isNacsOn() );
     optButtons[BTN_SUPER].setEnabled( transfer.isSupervisoryOn() );
     optButtons[BTN_RT].setEnabled( transfer.isRtOn() );
  }

  public void returnFrom()
  {
     if( activeButtonIdx == 0 ){
         optButtons[BTN_NACS].setEnabled( transfer.isNacsOn() );
         optButtons[BTN_SUPER].setEnabled( transfer.isSupervisoryOn() );
         optButtons[BTN_RT].setEnabled( transfer.isRtOn() );
     }
  }

  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < OPT_NUM; i++ ){
          final int focus = i;
          final int idx;
          switch( i ){
            case 1:
            case 2:
            case 3:
            case 4:
                  idx = i-1;
                  optButtons[i].addActionListener(  new  ActionListener() {
                             public void actionPerformed( ActionEvent e ){
                                activeButtonIdx = focus;
                                guiSubSys[ idx ].setEnabled( true );
                                guiSubSys[ idx ].setVisible( true );
                                mainFrame.setEnabled( false );
                                mainFrame.setVisible( false );
                             }
                         } );
                   break;
            case 0:
            case 5:
            case 6:
            case 7:
                  idx = (i==0) ? i : i-4;
                  optButtons[i].addActionListener( new  ActionListener() {
                             public void actionPerformed( ActionEvent e ){
                                activeButtonIdx = focus;
                                selOptions[ idx ].setEnabled( true );
                                selOptions[ idx ].setVisible( true );
                                mainFrame.setEnabled( false );
                                mainFrame.setVisible( false );
                             }
                         } );
          }
     }
  }
}
