package clarion.options;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.*;
import clarion.system.*;
import clarion.tools.*;

public class GuiTemplate extends JFrame {

  protected final String majorEntryText = "CLARION PARAMETER SETTINGS";
  protected final String note =
            "   ( type ENTER key after typing in any information, applied to all GUI screens )";
  protected String newTaskNames[];
  protected String newSettingNames[];

  protected static int currentTaskNum, currentSettingNum;
  protected static String loadTaskName, loadSettingName;
  protected static int runningAgentNum;
  protected static int curAgentIdx;
  protected static Global[] globals;
  protected static boolean confirmFlag;
  protected int OPT_NUM;
  protected String capLabelText, optionButtonTexts[];
  protected JLabel capLabel;
  protected JFrame mainFrame, thisFrame;
  protected JPanel optionPanel, operatePanel;
  protected JButton loadTaskButton, loadSettingButton, saveButton;
  protected static JButton confirmButton;
  protected JButton nextButton, returnButton, optButtons[];
  protected JTextField loadTaskField, loadSettingField, saveField;
  protected JPopupMenu loadTaskMenu, loadSettingMenu;
  protected JMenuItem loadTaskItem[], loadSettingItem[];
  protected int activeButtonIdx;
  protected static SettingTransfer transfer;

  public GuiTemplate( int optNum, String labelText )
  {
     OPT_NUM = optNum;
     capLabelText = labelText;
     thisFrame = this;
     optButtons = new JButton[ OPT_NUM ];
     for( int i = 0; i < OPT_NUM; i++ )
         optButtons[ i ] = new JButton();
  }

  public GuiTemplate( int optNum, String labelText, Global[] globals )
  {
     OPT_NUM = optNum;
     capLabelText = labelText;
     this.globals = globals;
     thisFrame = this;
     optButtons = new JButton[ OPT_NUM ];
     for( int i = 0; i < OPT_NUM; i++ )
         optButtons[ i ] = new JButton();
     //if( majorEntryText.equals( capLabelText ) ){
         transfer = new SettingTransfer( globals[0] );
         newTaskNames = transfer.searchCurrentTasks();
         currentTaskNum = newTaskNames.length;
         newSettingNames = transfer.searchCurrentSettings();
         currentSettingNum = newSettingNames.length;
         loadTaskName = Global.getTaskName();
         loadSettingName = "loaded setting name";
         for( int i = 0; i < OPT_NUM; i++ )
              optButtons[ i ].setEnabled( false );
     //}
  }

  public boolean isConfirmed()
  {
     return confirmFlag;
  }

  public JFrame getFrame()
  {
     return this;
  }

  public String getLabelText()
  {
     return capLabelText;
  }

  public String[] getButtonTexts()
  {
     return optionButtonTexts;
  }

  public void setCurAgentIdx( int agentIdx )
  {
     curAgentIdx = agentIdx;
     transfer.setGlobal( globals[curAgentIdx] );
  }

  public void setRunningAgentNum( int num )
  {
     this.runningAgentNum = num;
  }

  public void setGlobals( Global[] globals )
  {
     this.globals = globals;
  }

  public void setLabelText( String str )
  {
     capLabelText = str;
  }

  public void setConfirmStatus( boolean changeFlag )
  {
     if( changeFlag ){
         confirmButton.setEnabled( true );
         confirmFlag = false;
     }
  }

  public void setButtonTexts( String[] strings )
  {
     optionButtonTexts = strings;
  }

  public void setTaskName( String name )
  {
     loadTaskName = name;
  }

  public void setMainFrame( JFrame frame )
  {
     mainFrame = frame;
  }

  public void init( JFrame frame )
  {
    mainFrame = frame;
    if( majorEntryText.equals( capLabelText ) )
        setSize( 940, 480 );
    else
        setSize( 640, 480 );
    if( majorEntryText.equals( capLabelText ) )
        capLabel = new JLabel( capLabelText + note + "  Current agent = " + curAgentIdx );
    else
        capLabel = new JLabel( capLabelText );
    capLabel.setHorizontalAlignment( SwingConstants.CENTER );
    capLabel.setVerticalAlignment( SwingConstants.BOTTOM );
    getContentPane().add( capLabel, BorderLayout.NORTH );
    optionPanel = new JPanel();
    optionPanel.setLayout( new FlowLayout( FlowLayout.CENTER, 300, 15 ) );
    getContentPane().add( optionPanel, BorderLayout.CENTER );
    operatePanel = new JPanel();
    operatePanel.setLayout( new FlowLayout( FlowLayout.CENTER, 10, 15 ) );
    getContentPane().add( operatePanel, BorderLayout.SOUTH );
    for( int i = 0; i < OPT_NUM; i++ ){
         optButtons[ i ].setText( optionButtonTexts[ i ] );
         optionPanel.add( optButtons[ i ] );
    }

    // task information.
    if( majorEntryText.equals( capLabelText ) ){
        loadTaskButton = new JButton( "Setting Directory" );
        loadTaskField =  new JTextField( loadTaskName, 3 );
        operatePanel.add( loadTaskButton );
        operatePanel.add( loadTaskField );
        loadSettingButton = new JButton ( "Setting Group" );
        loadSettingField =  new JTextField( loadSettingName, 9 );
        operatePanel.add( loadSettingButton );
        operatePanel.add( loadSettingField );
        confirmButton = new JButton( "CONFIRM" );
        confirmButton.setEnabled( false );
        confirmButton.addActionListener(
               new  ActionListener() {
                    public void actionPerformed( ActionEvent e )
                    {
                       if( JOptionPane.showConfirmDialog( null, "Confirm your settings?",
                           "WARNING", JOptionPane.YES_NO_OPTION ) == JOptionPane.YES_OPTION ){
                           loadSettingName = loadSettingField.getText().trim();
                           globals[curAgentIdx].setOptionName( loadSettingName );
                           returnButton.setEnabled( true );
                           confirmButton.setEnabled( false );
                           nextButton.setEnabled( curAgentIdx < runningAgentNum-1 );
                           confirmFlag = true;
                           transfer.setSaveCode( 0 );
                           transfer.save();
                           SelectionTemplate.setChangeFlag( false );
                       }
                    }
              } );
        operatePanel.add( confirmButton );
        saveButton = new JButton( "SAVE TO FILES" );
        saveButton.setEnabled( false );
        saveButton.addActionListener(
               new  ActionListener() {
                    public void actionPerformed( ActionEvent e )
                    {
                       if( JOptionPane.showConfirmDialog( null, "Save as a new setting?",
                           "WARNING", JOptionPane.YES_NO_OPTION ) == JOptionPane.YES_OPTION ){
                           loadSettingName = saveField.getText().trim();
                           globals[curAgentIdx].setOptionName( loadSettingName );
                           transfer.setSaveCode( 1 );
                           transfer.save();
                       }
                    }
              } );
        operatePanel.add( saveButton );
        saveField = new JTextField( "input a new setting name", 9 );
        operatePanel.add( saveField );
        // next button.
        nextButton = new JButton( "NEXT" );
        nextButton.setEnabled( curAgentIdx < runningAgentNum-1 );
        nextButton.addActionListener(  new  ActionListener() {
                         public void actionPerformed( ActionEvent e )
                         {
                            curAgentIdx++;
                            transfer.setGlobal( globals[curAgentIdx] );
                            capLabel.setText( capLabelText + note + "  Current agent = " + curAgentIdx );
                            for( int i = 0; i < OPT_NUM; i++ )
                                 optButtons[i].setEnabled( false );
                         }
                     } );
        operatePanel.add( nextButton );
        addLoadButtonListeners();
        addFieldListeners();
    }
    // return button.
    returnButton = new JButton( "RETURN" );
    if( majorEntryText.equals( capLabelText ) )
        returnButton.setEnabled( false );
    returnButton.addActionListener(  new  ActionListener() {
                     public void actionPerformed( ActionEvent e )
                     {
                         setEnabled( false );
                         setVisible( false );
                         mainFrame.setEnabled( true );
                         mainFrame.setVisible( true );
                         if( !majorEntryText.equals( capLabelText ) )
                             ((GuiTemplate)mainFrame).returnFrom();
                     }
                 } );
    operatePanel.add( returnButton );
    addActionListeners( mainFrame );
    addWindowListener(
          new WindowAdapter(){
             public void windowClosing( WindowEvent e ){
                 if( confirmFlag ){
                    setVisible( false );
                    setEnabled( false );
                    mainFrame.setVisible( true );
                    mainFrame.setEnabled( true );
                    if( !majorEntryText.equals( capLabelText ) )
                        ((GuiTemplate)mainFrame).returnFrom();
                 }
                 else
                    JOptionPane.showMessageDialog( null, "Please confirm the option setting", "WARNING",
                                                  JOptionPane.WARNING_MESSAGE );
            }
    }  );
  }

  public void addActionListeners( JFrame mFrame )
  {
  }

  public void returnFrom()
  {
     if( thisFrame instanceof GuiClarion ){
         returnButton.setEnabled( !confirmButton.isEnabled() );
     }
  }

  public void updateGui()
  {
  }

/****************************** PRIVATE METHODS ********************************/
  private void addLoadButtonListeners()
  {
    // load a task.
    loadTaskButton.addActionListener( new ActionListener() {
       public void actionPerformed( ActionEvent e ) {
           newTaskNames = transfer.searchCurrentTasks();
           currentTaskNum = newTaskNames.length;
           loadTaskMenu = new JPopupMenu( "EXISTING TASKS" );
           loadTaskItem = new JMenuItem[ currentTaskNum ];
           for( int i = 0; i < currentTaskNum; i++ ){
                loadTaskItem[ i ] = new JMenuItem( newTaskNames[i] );
                loadTaskItem[i].setFont( new Font( "Serif", Font.PLAIN, 14 ) );
                final int focus = i;
                loadTaskItem[ focus ].addActionListener( new ActionListener(){
                   public void actionPerformed( ActionEvent e){
                       loadSettingButton.setEnabled( true );
                       if( !newTaskNames[focus].equals( loadTaskName ) &&
                           JOptionPane.showConfirmDialog( null, "Do you want to load a task?",
                               "WARNING", JOptionPane.YES_NO_OPTION ) == JOptionPane.YES_OPTION ) {
                           loadTaskName = newTaskNames[focus];
                           loadTaskField.setText( loadTaskName );
                           Global.setTaskName( loadTaskName );
                           loadSettingName = "";
                           loadSettingField.setText( loadSettingName );
                           for( int i = 0; i < OPT_NUM; i++ )
                                optButtons[i].setEnabled( false );
                           confirmButton.setEnabled( false );
                           returnButton.setEnabled( false );
                           confirmFlag = false;
                      }
                  }
                } );
                loadTaskMenu.add( loadTaskItem[ i ] );
           }
           loadTaskMenu.show( loadTaskButton, 10, 10 );
       }
    } );
    // load a setting group.
    loadSettingButton.addActionListener( new ActionListener() {
       public void actionPerformed( ActionEvent e ) {
           newSettingNames = transfer.searchCurrentSettings();
           currentSettingNum = newSettingNames.length;
           loadSettingMenu = new JPopupMenu( "EXISTING SETTINGS" );
           loadSettingItem = new JMenuItem[ currentSettingNum ];
           for( int i = 0; i < currentSettingNum; i++ ){
                loadSettingItem[ i ] = new JMenuItem( newSettingNames[i] );
                loadSettingItem[i].setFont( new Font( "Serif", Font.PLAIN, 14 ) );
                final int focus = i;
                loadSettingItem[ focus ].addActionListener( new ActionListener(){
                   public void actionPerformed( ActionEvent e){
                     if( !newSettingNames[focus].equals( loadSettingName ) &&
                         JOptionPane.showConfirmDialog( null, "Do you want to load a new setting?",
                             "WARNING", JOptionPane.YES_NO_OPTION ) == JOptionPane.YES_OPTION ) {
                         loadSettingName = newSettingNames[focus];
                         loadSettingField.setText( loadSettingName );
                         globals[curAgentIdx].setOptionName( loadSettingName );
                         for( int i = 0; i < OPT_NUM; i++ )
                              optButtons[i].setEnabled( true );
                         confirmButton.setEnabled( true );
                         ((GuiClarion)thisFrame).loadSubSys();
                      }
                  }
                } );
                loadSettingMenu.add( loadSettingItem[ i ] );
           }
           loadSettingMenu.show( operatePanel, 300, 10 );
       }
    } );
  }

  private void addFieldListeners()
  {
    // load a task.
    loadTaskField.addActionListener( new ActionListener() {
       public void actionPerformed( ActionEvent e ) {
           String name = loadTaskField.getText().trim();
           if( loadTaskName.equals( name ) )
               return;
           if( name.length() > 0 && JOptionPane.showConfirmDialog( null, "Do you want to load a task?",
               "WARNING", JOptionPane.YES_NO_OPTION ) == JOptionPane.YES_OPTION ) {
               loadTaskName = name;
               Global.setTaskName( loadTaskName );
               loadSettingName = "";
               loadSettingField.setText( loadSettingName );
               for( int i = 0; i < OPT_NUM; i++ )
                    optButtons[i].setEnabled( false );
               confirmButton.setEnabled( false );
               returnButton.setEnabled( false );
               loadSettingButton.setEnabled( false );
               confirmFlag = false;
            }
            else{
               if( name.length() == 0 )
                   JOptionPane.showMessageDialog( null, "Invalid task name, reset!", "WARNING",
                                                  JOptionPane.WARNING_MESSAGE );
               loadTaskField.setText( loadTaskName );
            }
       }
    });
    // load a task setting.
    loadSettingField.addActionListener( new ActionListener() {
       public void actionPerformed( ActionEvent e ) {
           String name = loadSettingField.getText().trim();
           if( name.length() > 0 && JOptionPane.showConfirmDialog( null, "Do you want to load a new setting?",
                "WARNING", JOptionPane.YES_NO_OPTION ) == JOptionPane.YES_OPTION ){
               loadSettingName = name;
               globals[curAgentIdx].setOptionName( loadSettingName );
               for( int i = 0; i < OPT_NUM; i++ )
                    optButtons[i].setEnabled( true );
               loadSettingButton.setEnabled( true );
               confirmButton.setEnabled( true );
               ((GuiClarion)thisFrame).loadSubSys();
           }
           else{
               if( name.length() == 0 )
                   JOptionPane.showMessageDialog( null, "Invalid setting name, reset!", "WARNING",
                                                  JOptionPane.WARNING_MESSAGE );
               loadSettingField.setText( loadSettingName );
           }
       }
    });
    // save setting.
    saveField.addActionListener( new ActionListener() {
       public void actionPerformed( ActionEvent e ) {
           String name = saveField.getText().trim();
           if( name.length() > 0 ){
               loadSettingName = name;
               globals[curAgentIdx].setOptionName( loadSettingName );
               saveButton.setEnabled( true );
           }
           else{
               JOptionPane.showMessageDialog( null, "Invalid setting name, reset!", "WARNING",
                                             JOptionPane.WARNING_MESSAGE );
               saveButton.setEnabled( false );
               saveField.setText( loadSettingName );
           }
       }
    });
  }
}