package clarion.options;

public class Option {

  String optLabel;  // the option label.
  int choiceNum;           // # of items in the option.
  int defaultChoice;       // the default choice.
  int userChoice;          // user choice.
  OptionItem optItems[];   // option items.

  public Option( String optLabel, int choiceNum, int defaultChoice, int userChoice )
  {
      this.optLabel = optLabel;
      this.choiceNum = choiceNum;
      this.defaultChoice = defaultChoice;
      this.userChoice = userChoice;
  }

  public String getOptLabel()
  {
     return optLabel;
  }

  public int getChoiceNum()
  {
     return choiceNum;
  }

  public int getDefaultChoice()
  {
     return defaultChoice;
  }

  public int getUserChoice()
  {
     return userChoice;
  }

  public OptionItem getOptionItem( int choice )
  {
     return optItems[ choice ];
  }

  public void setChoiceNum( int num )
  {
     choiceNum = num;
  }

  public void setDefaultChoice( int choice )
  {
     defaultChoice = choice;
  }

  public void setUserChoice( int choice )
  {
     userChoice = choice;
  }

  public void setOptionItems( OptionItem[] items )
  {
     try{
       optItems = new OptionItem[items.length];
       for( int i = 0; i < items.length; i++ ){
            optItems[i] = (OptionItem)(items[i].clone());
       }
     }
     catch( Exception e ){
        System.out.println(  e + ", clone OptionItem error in Option.java!" );
     }
  }

  public String toString()
  {
     String str = "Option label : " + optLabel + "\n";
     str += "Option choice number : " + choiceNum + "\n";
     str += "Default choice : " + defaultChoice + "\n";
     str += "User choice : " + userChoice + "\n";
     for( int i = 0; i < choiceNum; i++ )
          str += optItems[i];
     return str;
  }

  public Object clone()
  {
     Option obj = new Option( optLabel, choiceNum, defaultChoice, userChoice );
     obj.setOptionItems( optItems );
     return obj;
  }
}