package clarion.options;

public class OptionItem  implements Cloneable {

  int curParamNum;
  String label;
  Parameter[] params;

  public OptionItem( String label, Parameter[] params )
  {
     this.label = label;
     if( params != null ){
         try{
            curParamNum = params.length;
            this.params = new Parameter[ curParamNum ];
            for( int i = 0; i < curParamNum; i++ )
                 this.params[i] = (Parameter)(params[i].clone());
         }
         catch( Exception e ){
            System.out.println( "clone error 111 in OptionItem.java!" );
         }
     }
  }

  public OptionItem( String label, int num, Parameter[] params )
  {
     this.label = label;
     if( params != null ){
         try{
            curParamNum = num;
            this.params = new Parameter[ curParamNum ];
            for( int i = 0; i < curParamNum; i++ )
                 this.params[i] = (Parameter)(params[i].clone());
         }
         catch( Exception e ){
            System.out.println( "clone error 222 in OptionItem.java!" );
         }
     }
  }

  public String getLabel()
  {
     return label;
  }

  public int getCount()
  {
     return curParamNum;
  }

  public Parameter[] getParameters()
  {
     return params;
  }

  public Parameter getParameter( int idx )
  {
     return params[ idx ];
  }

  public boolean hasParameters()
  {
     //return ( params != null );
     return curParamNum > 0;
  }

  public void setCount( int num )
  {
     if( curParamNum == 0 )
         return;
     if( num <= curParamNum ){
         curParamNum = num;
         return;
     }
     Parameter[] temp = new Parameter[curParamNum];
     try{
        for( int i = 0; i < curParamNum; i++ )
             temp[i] = (Parameter)(params[i].clone());
        params = new Parameter[ num ];
        for( int i = 0; i < num; i++ )
             params[i] = (Parameter)(temp[ Math.min(i,curParamNum-1) ].clone());
        curParamNum = num;
     }
     catch( Exception e ){
        System.out.println( "clone parameter error in OptionItem.java!" );
     }
  }

  public String toString()
  {
     String str = "Item label : " + label + "\n";
     str += "Parameter number : " + curParamNum + "\n";
     for( int i = 0; i < curParamNum; i++ )
          str += params[i];
     return str;
  }

  public Object clone()// throws CloneNotSupportedException
  {
      OptionItem item = null;
      try{
          if( params == null )
              item = new OptionItem( label, 0, null );
          else{
              Parameter[] paras = new Parameter[ params.length ];
              for( int i = 0; i < params.length; i++ )
                   paras[ i ] = (Parameter)(params[ i ].clone());
              item = new OptionItem( label, curParamNum, paras );
         }
      }
      catch( Exception e ){
             System.out.println( e + ", clone error in OptionItem.java" );
      }
      return item;
  }
}