package clarion.options;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionSubSys extends SelectionTemplate{
  final int ON = 0, OFF = 1;
  final int SUB_NACS = 0, SUB_SUPER = 1, SUB_RT = 2;

  JLabel capLabel = new JLabel();
  JPanel panel = new JPanel();
  // nacs
  JLabel nacsLabel = new JLabel();
  JRadioButton[]  nacsButtons = new JRadioButton[ 2 ]; {
     for( int i = 0; i < 2; i++ )
          nacsButtons[i] = new JRadioButton();
  }
  // super
  JLabel superLabel = new JLabel();
  JRadioButton[]  superButtons = new JRadioButton[ 2 ]; {
     for( int i = 0; i < 2; i++ )
          superButtons[i] = new JRadioButton();
  }
  // rt
  JLabel rtLabel = new JLabel();
  JRadioButton[]  rtButtons = new JRadioButton[ 2 ]; {
     for( int i = 0; i < 2; i++ )
          rtButtons[i] = new JRadioButton();
  }
  // return button
  JButton returnButton = new JButton();

  public SelectionSubSys( JFrame superFrame, int width, int height, SettingTransfer transfer )
  {
    super( superFrame, width, height, transfer );
    initGui();
  }

  public void initGui()
  {
    options = transfer.getOptions( Global.SUBSYS, 0, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout( null );
    // caption.
    initLabel( capLabel, "OPTIONS OF CLARION SUBSYSTEMS", new Font("Dialog",1,14),
               SwingConstants.CENTER, new Rectangle(20, 0, 320, 26) );
    initPanel( panel, BORDER, null, new Rectangle(10, 30, 360, 100) );
    // SUB_NACS option.
    Rectangle[] nacsRects = { new Rectangle(200, 8, 50, 17), new Rectangle(250, 8, 50, 17)};
    initButtonBlock( panel, nacsLabel, "Non-Action-Centered System", new Rectangle(10, 8, 190, 17),
                    nacsButtons, onOffTexts, nacsRects, options[SUB_NACS] );
    // SUB_SUPER option.
    Rectangle[] superRects = { new Rectangle(200, 38, 50, 17),new Rectangle(250, 38, 50, 17)};
    initButtonBlock( panel, superLabel, "Supervisory Subsystem", new Rectangle(10, 38, 190, 17),
                     superButtons, onOffTexts, superRects, options[SUB_SUPER] );
    // RT option.
    Rectangle[] rtRects = { new Rectangle(150, 68, 50, 17), new Rectangle(200, 68, 50, 17)};
    initButtonBlock( panel, rtLabel, "Response Time", new Rectangle(10, 68, 270, 17),
                    rtButtons, onOffTexts, rtRects, options[SUB_RT] );
    // return button.
    initReturnButton( returnButton, "RETURN", new Rectangle(260, 136, 88, 28) );
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(panel, null);
    this.getContentPane().add(returnButton, null);
  }
}