package clarion.options;
import java.io.*;
import javax.swing.*;
import java.util.*;
import java.lang.reflect.Method;
import clarion.system.*;
import clarion.tools.*;

public class SettingTransfer{
  protected final int SAVE_TO_GLOBAL = 0, SAVE_TO_FILE = 1;
  protected final int CLARION_COMP_NUM = 8;
  protected final int ACS = 0, NACS = 1, SUPER = 2, RT = 3, DISPLAY = 4, DIMS = 5, TS = 6, SUBSYS = 7;
  protected final int ACS_COMP_NUM = 4;
  protected final int ACS_COMP = 0, ACS_NET = 1, ACS_WM = 2, ACS_GS = 3;
  protected final int ACS_NET_OPT_NUM = 4;
  protected final int EX_NET = 0, WM_NET = 1, GS_NET = 2, ACS_COR = 3;
  protected final int NACS_COMP_NUM = 5;
  protected final int NACS_COMP = 0, NACS_GKS = 1, NACS_AMN = 2, NACS_AEM = 3, NACS_COR = 4;
  protected final int SUPER_COMP_NUM = 3;
  protected final int SUPER_COMP = 0, SUPER_MS = 1, SUPER_MCS = 2;
  protected final int RT_COMP_NUM = 1;
  protected final int DISPLAY_COMP_NUM = 1;
  protected final int ACS_NET_COMP_NUM = 5;
  protected final int IDN = 0, RER = 1, IRL = 2, FR = 3, COMP = 4;
  protected final int ON = 0, OFF = 1;
  protected final int TL = Global.TL, BL = Global.BL;
  protected Global global;
  protected int saveCode;  // save to global or file
  // the files for loading or saving the user option-selecting data.
  protected String loadedFileName, savedFileName;
  protected Option userOptions[][][][][][][], sysOptions[][][][][][][];
  protected RandomAccessFile loadedFile, savedFile;
  protected static String sysPath = Global.getOptionDir() + "\\DEFAULT";
  protected static File sysDir = new File( sysPath );
  protected String sysSettingPath = sysPath + "\\subjectGroup0";
  protected File sysSettingDir = new File( sysSettingPath );
  protected String subsysPath;
  String[] acsNetCompNames = { "IDN", "RER", "IRL", "FR" };
  String[] acsNetFileNames = { "idn", "rer", "irl", "fr", "components" };

  public SettingTransfer( Global g )
  {
     global = g;
  }

  public void setGlobal( Global g )
  {
     global = g;
  }

  /*
  public int searchCurrentTasks( String[] names )
  {
     String path = global.getOptionDir();
     File file = new File( path );
     int len = file.list().length;
     for( int i = 0; i < len; i++ )
          names[i] = file.list()[i];
     return len;
  }
  */
  public String[] searchCurrentTasks()
  {
     String path = global.getOptionDir();
     File file = new File( path );
     int len = file.list().length;
     String[] names = new String[ len ];
     for( int i = 0; i < len; i++ )
          names[i] = file.list()[i];
     return names;
  }

  public String[] searchCurrentSettings()
  {
     String path = global.getOptionDir() + "\\" + global.getTaskName();
     File file = new File( path );
     int len = file.list().length;
     String[] names = new String[ len ];
     for( int i = 0; i < len; i++ )
          names[i] = file.list()[i];
     return names;
  }

  public Option[] getOptions( int dim1, int dim2, int dim3, int dim4, int dim5, int dim6 )
  {
     return userOptions[dim1][dim2][dim3][dim4][dim5][dim6];
  }

  public Option getOptions( int dim1, int dim2, int dim3, int dim4, int dim5, int dim6, int dim7 )
  {
     return userOptions[dim1][dim2][dim3][dim4][dim5][dim6][dim7];
  }

  public int getFeatureNum( int type )
  {
     return userOptions[DIMS][0][0][0][0][0][1].getOptionItem(0).getParameter(type).getIntValue();
  }

  public String getFeatureName( int type, int idx )
  {
     return userOptions[DIMS][0][0][0][0][0][2].getOptionItem(0).getParameter(type).getStringValues()[idx];
  }

  public int searchFeatureName( int type, String name )
  {
     String[] names = userOptions[DIMS][0][0][0][0][0][2].getOptionItem(0).getParameter(type).getStringValues();
     for( int i = 0; i < names.length; i++ )
          if( names[i].equals( name ) )
              return i;
     return -1;
  }

  public boolean isNacsOn()
  {
     return userOptions[SUBSYS][0][0][0][0][0][0].getUserChoice() == ON;
  }

  public boolean isSupervisoryOn()
  {
     return userOptions[SUBSYS][0][0][0][0][0][1].getUserChoice() == ON;
  }

  public boolean isRtOn()
  {
     return userOptions[SUBSYS][0][0][0][0][0][2].getUserChoice() == ON;
  }

  public int getGsOption()
  {
     return userOptions[ACS][ACS_COMP][0][0][0][0][0].getUserChoice();
  }

  public boolean getWmOption()
  {
     return userOptions[ACS][ACS_COMP][0][0][0][0][1].getUserChoice()==ON;
  }

  public int getAcsExNetNum()
  {
     return userOptions[ACS][ACS_COMP][0][0][0][0][2].getOptionItem(0).getParameter(0).getIntValue();
  }

  public boolean isGsIdnOn()
  {
     return userOptions[ACS][ACS_COMP][0][0][0][0][3].getUserChoice()==ON;
  }

  public boolean isWmIdnOn()
  {
     return userOptions[ACS][ACS_COMP][0][0][0][0][4].getUserChoice()==ON;
  }

  public boolean isAcsCompOn( int netType, int netIdx, int type )
  {
     return userOptions[ACS][ACS_NET][netType][netIdx][COMP][0][type].getUserChoice()==ON;
  }

  public int getAcsCompFileNum( int netType, int netIdx, int type )
  {
     return userOptions[ACS][ACS_NET][netType][netIdx][COMP][0][type].getOptionItem(0).getParameter(ON).getIntValue();
  }

  public boolean isGksOn()
  {
     return userOptions[NACS][NACS_COMP][0][0][0][0][0].getUserChoice()==ON;
  }

  public int getAmnNum()
  {
     return userOptions[NACS][NACS_COMP][0][0][0][0][1].getOptionItem(0).getParameter(0).getIntValue();
  }

  public boolean isEmOn()
  {
     return userOptions[NACS][NACS_COMP][0][0][0][0][2].getUserChoice()==ON;
  }

  public boolean isAemOn()
  {
     return userOptions[NACS][NACS_COMP][0][0][0][0][3].getUserChoice()==ON;
  }

  public int getAmnType( int netIdx )
  {
     return userOptions[NACS][NACS_AMN][netIdx][0][0][0][0].getUserChoice();
  }

  public int getGksReasoningType()
  {
     return userOptions[NACS][NACS_COR][0][0][0][0][1].getUserChoice();
  }

  public boolean isMsOn()
  {
     return userOptions[SUPER][SUPER_COMP][0][0][0][0][0].getUserChoice() == ON;
  }

  public boolean isMcsOn()
  {
     return userOptions[SUPER][SUPER_COMP][0][0][0][0][1].getUserChoice() == ON;
  }

  public void setSaveCode( int code )
  {
     saveCode = code;
  }

  public void load()
  {
     String taskPath = global.getOptionDir() + "\\" + global.getTaskName();
     File taskDir = new File( taskPath );
     String taskSettingPath = taskPath + "\\" + global.getOptionName();
     File taskSettingDir = new File( taskSettingPath );
     if( !taskDir.exists() ){   // a new task.
         System.out.println( "A new task, copy from DEFAULT opitons." );
         taskDir.mkdir();
         taskSettingDir.mkdir();
         copyFileStructure( sysSettingDir, taskSettingDir );
     }
     else if( !taskSettingDir.exists() ){  // a new settting.
              System.out.println( "A new task settings, copy from an existing setting opitons." );
              taskSettingDir.mkdir();
              String[] settingNames = searchCurrentSettings();
              String existTaskSettingPath = taskPath + "\\" + settingNames[0];
              File existTaskSettingDir = new File( existTaskSettingPath );
              copyFileStructure( existTaskSettingDir, taskSettingDir );
     }
     // load subsystem options.
     sysOptions = new Option[ CLARION_COMP_NUM ][][][][][][];
     userOptions = new Option[ CLARION_COMP_NUM ][][][][][][];

     //System.out.println( "before load subsys" );

     loadSubsysSettings();
     loadFeatureSettings();
     loadAcsSettings();

     //System.out.println( "before load nacs" );

     loadNacsSettings();

     //System.out.println( "before load super" );

     loadSupervisorySettings();

     //System.out.println( "before load RT" );

     loadRTSettings();
     loadDisplaySettings();
     loadTaskSpecSettings();

     //System.out.println( "end loading" );
  }

  public void loadSubsysSettings()
  {
     loadedFileName = "subsys.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\";
     sysOptions[SUBSYS] = new Option[1][1][1][1][1][];
     sysOptions[SUBSYS][0][0][0][0][0] = loadOptions( path );
     path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\";
     userOptions[SUBSYS] = new Option[1][1][1][1][1][];
     userOptions[SUBSYS][0][0][0][0][0] = loadOptions( path );
  }

  public void loadFeatureSettings()
  {
     loadedFileName = "dims.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\dims\\";
     sysOptions[DIMS] = new Option[1][1][1][1][1][];
     sysOptions[DIMS][0][0][0][0][0] = loadOptions( path );
     //path = global.getOptionDir() + "\\" + global.getTaskName()
     //              + "\\" + global.getOptionName() + "\\dims\\";
     subsysPath = this.searchFile( "dims" );
     userOptions[DIMS] = new Option[1][1][1][1][1][];
     userOptions[DIMS][0][0][0][0][0] = loadOptions( subsysPath );
  }

  public void loadAcsSettings()
  {
     sysOptions[ACS] = new Option[ ACS_COMP_NUM ][][][][][];
     sysOptions[ACS][ACS_NET] = new Option[ ACS_NET_OPT_NUM ][][][][];
     userOptions[ACS] = new Option[ ACS_COMP_NUM ][][][][][];
     userOptions[ACS][ACS_NET] = new Option[ ACS_NET_OPT_NUM ][][][][];
     subsysPath = this.searchFile( "acs" );
     loadAcsCompSettings();
     for( int i = 0; i < ACS_NET_OPT_NUM-1; i++ )
          loadAcsNetSettings( i );
     loadAcsCorSettings();
     loadAcsGSSettings();
     loadAcsWMSettings();
  }

  public void loadNacsSettings()
  {
     // load NACS subsystem options.
     sysOptions[NACS] = new Option[ NACS_COMP_NUM ][][][][][];
     userOptions[NACS] = new Option[ NACS_COMP_NUM ][][][][][];
     subsysPath = this.searchFile( "nacs" );
     loadNacsCompSettings();
     loadNacsAmnSettings();
     loadNacsGksSettings();
     loadNacsAemSettings();
     loadNacsCoordinateSettings();
  }

  public void loadSupervisorySettings()
  {
     // load NACS subsystem options.
     sysOptions[SUPER] = new Option[ SUPER_COMP_NUM ][][][][][];
     userOptions[SUPER] = new Option[ SUPER_COMP_NUM ][][][][][];
     subsysPath = this.searchFile( "super" );
     loadSuperCompSettings();
     loadMsSettings();
     loadMcsSettings();
  }

  public void loadRTSettings()
  {
     loadedFileName = "rt.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\rt\\";
     sysOptions[RT] = new Option[1][1][1][1][1][];
     sysOptions[RT][0][0][0][0][0] = loadOptions( path );
     subsysPath = this.searchFile( "rt" );
     userOptions[RT] = new Option[1][1][1][1][1][];
     userOptions[RT][0][0][0][0][0] = loadOptions( subsysPath );
  }

  public void loadTaskSpecSettings()
  {
     loadedFileName = "taskspec.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\taskspec\\";
     sysOptions[TS] = new Option[1][1][1][1][1][];
     sysOptions[TS][0][0][0][0][0] = loadOptions( path );
     //path = global.getOptionDir() + "\\" + global.getTaskName()
     //             + "\\" + global.getOptionName() + "\\taskspec\\";
     subsysPath = this.searchFile( "taskspec" );
     userOptions[TS] = new Option[1][1][1][1][1][];
     userOptions[TS][0][0][0][0][0] = loadOptions( subsysPath );
  }

  public void loadDisplaySettings()
  {
     loadedFileName = "display.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\display\\";
     sysOptions[DISPLAY] = new Option[1][1][1][1][1][];
     sysOptions[DISPLAY][0][0][0][0][0] = loadOptions( path );
     //path = global.getOptionDir() + "\\" + global.getTaskName()
     //             + "\\" + global.getOptionName() + "\\display\\";
     subsysPath = this.searchFile( "display" );
     userOptions[DISPLAY] = new Option[1][1][1][1][1][];
     userOptions[DISPLAY][0][0][0][0][0] = loadOptions( subsysPath );
  }

  public void save()
  {
     if( saveCode == SAVE_TO_FILE ){
         // create a new user setting directory.
         String path = global.getOptionDir() + "\\" + global.getTaskName();
         File taskDir = new File( path );
         File[] subjectGroups = taskDir.listFiles();
         File newUserDir = new File( path + "\\" + global.getOptionName() );
         newUserDir.mkdir();
     }
     // save subsystem-selection settings.
     saveSubsysSettings();
     // save current settings.
     saveFeatureSettings();
     saveAcsSettings();
     if( this.isNacsOn() )
         saveNacsSettings();
     if( this.isSupervisoryOn() )
         saveSupervisorySettings();
     if( this.isRtOn() )
         saveRTSettings();
     saveDisplaySettings();
     saveTaskSpecSettings();
  }

  public void saveSubsysSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalSubsys();
         return;
     }
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\";
     savedFileName = "subsys.txt";
     // save subsys setting.
     saveOptions( path, userOptions[SUBSYS][0][0][0][0][0] );
  }

  public void saveFeatureSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalFeatures();
         return;
     }
     // create DIM setting directory.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\dims";
     new File( path ).mkdir();
     savedFileName = "\\dims.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save DIM setting.
     saveOptions( path, userOptions[DIMS][0][0][0][0][0] );
  }

  public void saveAcsSettings()
  {
     if( saveCode == SAVE_TO_FILE ){
         // create ACS setting directory.
         String path = global.getOptionDir() + "\\" + global.getTaskName()
                          + "\\" + global.getOptionName() + "\\acs";
         new File( path ).mkdir();
         path = global.getOptionDir() + "\\" + global.getTaskName() + "\\" + global.getOptionName()
                                             + "\\acs\\nets\\";
         new File( path ).mkdir();
     }
     // save ACS component settings.
     saveAcsCompSettings();
     // save ACS net setitngs.
     int netNum = getAcsExNetNum();
     if( getWmOption() )
         netNum++;
     if( getGsOption() != global.GS_NON )
         netNum++;
     if( saveCode == SAVE_TO_GLOBAL ){
         global.setAcsNetNum( netNum );
         global.initAcsNets();
     }
     saveAcsNetSettings( EX_NET );

     //System.out.println( "after acs net settings" );
     //System.out.println( "irl set num = " + global.getIrlRuleNums(0).length );

     if( getGsOption() != global.GS_NON ){
         saveAcsGSSettings();
         if( isGsIdnOn() )
             saveAcsNetSettings( GS_NET );
     }
     if( getWmOption() ){
         saveAcsWMSettings();
         if( isWmIdnOn() )
             saveAcsNetSettings( WM_NET );
     }
     // save coordinating.
     saveAcsCoordinate();
  }

  public void saveNacsSettings()
  {
     // create NACS setting directory.
     if( saveCode == SAVE_TO_FILE ){
         String path = global.getOptionDir() + "\\" + global.getTaskName()
                               + "\\" + global.getOptionName() + "\\nacs";
         File nacsDir = new File( path );
         nacsDir.mkdir();
     }
     saveNacsCompSettings();
     saveNacsAmnSettings();
     saveNacsGksSettings();
     if( this.isAemOn() )
         saveNacsAemSettings();
     saveNacsCoordinateSettings();
  }

  public void saveSupervisorySettings()
  {
     // create supervisory setting directory.
     if( saveCode == SAVE_TO_FILE ){
         String path = global.getOptionDir() + "\\" + global.getTaskName()
                               + "\\" + global.getOptionName() + "\\super";
         File superDir = new File( path );
         superDir.mkdir();
     }
     saveSuperCompSettings();
     if( this.isMsOn() )
         saveMsSettings();
     if( this.isMcsOn() )
         saveMcsSettings();
  }

  public void saveRTSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalRT();
         return;
     }
     // create RT setting directory.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\rt";
     new File( path ).mkdir();
     savedFileName = "\\rt.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save RT setting.
     saveOptions( path, userOptions[RT][0][0][0][0][0] );
  }

  public void saveTaskSpecSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalTaskSpec();
         return;
     }
     // create RT setting directory.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\taskspec";
     new File( path ).mkdir();
     savedFileName = "\\taskspec.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save RT setting.
     saveOptions( path, userOptions[TS][0][0][0][0][0] );
  }

  public void saveDisplaySettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalDisplay();
         return;
     }
     // create Display setting directory.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\display";
     new File( path ).mkdir();
     savedFileName = "\\display.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save task-specific setting.
     saveOptions( path, userOptions[DISPLAY][0][0][0][0][0] );
  }

/************************* PRIVATE METHODS ************************************/
  private void loadAcsCompSettings()
  {
     loadedFileName = "components.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\acs\\";
     sysOptions[ACS][ACS_COMP] = new Option[1][1][1][1][];
     sysOptions[ACS][ACS_COMP][0][0][0][0] = loadOptions( path );
     path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\acs\\";
     userOptions[ACS][ACS_COMP] = new Option[1][1][1][1][];
     userOptions[ACS][ACS_COMP][0][0][0][0] = loadOptions( path );
  }

  private void loadAcsCorSettings()
  {
     loadedFileName = "coordinate.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\acs\\nets\\";
     sysOptions[ACS][ACS_NET][ACS_COR] = new Option[1][1][1][];
     sysOptions[ACS][ACS_NET][ACS_COR][0][0][0] = loadOptions( path );
     path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\acs\\nets\\";
     userOptions[ACS][ACS_NET][ACS_COR] = new Option[1][1][1][];
     userOptions[ACS][ACS_NET][ACS_COR][0][0][0] = loadOptions( path );
  }

  private void loadAcsNetSettings( int netType )
  {
     // fill in system options.
     String[] subNetName = { "ex", "wm", "gs" };
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\acs\\nets\\" + subNetName[netType];
     int netNum = new File( path ).list().length;
     int MAX_NET_NUM = 1;
     if( netType == EX_NET )
         MAX_NET_NUM = Global.MAX_EX_NET_NUM;
     sysOptions[ACS][ACS_NET][netType] = new Option[netNum][ACS_NET_COMP_NUM][][];
     for( int i = 0; i < netNum; i++ )
        for( int j = 0; j < ACS_NET_COMP_NUM; j++ ){
             if( j == COMP ){
                 loadedFileName = acsNetFileNames[ j ] + ".txt";
                 sysOptions[ACS][ACS_NET][netType][i][j] = new Option[1][];
                 sysOptions[ACS][ACS_NET][netType][i][j][0] = loadOptions( path +
                            "\\net" + i + "\\" );
                 continue;
             }
             File[] files = new File( path + "\\net" + i + "\\" + acsNetCompNames[j] ).listFiles();
             sysOptions[ACS][ACS_NET][netType][i][j] = new Option[files.length][];
             for( int k = 0; k < files.length; k++ ){
                  loadedFileName = acsNetFileNames[ j ] + k + ".txt";
                  sysOptions[ACS][ACS_NET][netType][i][j][k] = loadOptions( path + "\\net" + i +
                      "\\" + acsNetCompNames[j] + "\\" );
             }
        }
     // fill in user options.
     userOptions[ACS][ACS_NET][netType] = new Option[MAX_NET_NUM][ACS_NET_COMP_NUM][][];
     path = global.getOptionDir() + "\\" + global.getTaskName() + "\\" +
            global.getOptionName() + "\\acs\\nets\\" + subNetName[netType];
     if( !new File( path ).exists() )
     { // the type of net doesn't exist, copy from system opitons.
       //System.out.println( "the net type doesn't exist, copy from DEFAULT opitons." );
       for( int i = 0; i < MAX_NET_NUM; i++ ){
         userOptions[ACS][ACS_NET][netType][i] = new Option[sysOptions[ACS][ACS_NET][netType][0].length][][];
         for( int j = 0; j < ACS_NET_COMP_NUM; j++ ){
           userOptions[ACS][ACS_NET][netType][i][j] = new Option[sysOptions[ACS][ACS_NET][netType][0][j].length][];
           for( int k = 0; k < sysOptions[ACS][ACS_NET][netType][0][j].length; k++ ){
             userOptions[ACS][ACS_NET][netType][i][j][k] = new Option[sysOptions[ACS][ACS_NET][netType][0][j][k].length];
             for( int m = 0; m < sysOptions[ACS][ACS_NET][netType][0][j][k].length; m++ )
                  userOptions[ACS][ACS_NET][netType][i][j][k][m] =
                        (Option)(sysOptions[ACS][ACS_NET][netType][0][j][k][m].clone());
             }
         }
       }
       return;
     }
     // the type of net exists.
     for( int i = 0; i < MAX_NET_NUM; i++ ){
          if( i < netNum ){
              File netDir = new File( path + "\\net" + i );
              File[] compDirs = netDir.listFiles();
              for( int j = 0; j < Global.ACS_NET_COMP_NUM; j++ ){
                  if( j == COMP ){
                      // the userOptions for components.
                      userOptions[ACS][ACS_NET][netType][i][j] = new Option[1][];
                      loadedFileName = acsNetFileNames[ j ] + ".txt";
                      userOptions[ACS][ACS_NET][netType][i][j][0] = loadOptions( path +
                            "\\net" + i + "\\" );
                      continue;
                  }
                  int maxFileNum = Global.MAX_RULE_NUMS[j];
                  int fileNum = 1;
                  userOptions[ACS][ACS_NET][netType][i][j] = new Option[maxFileNum][];
                  boolean compOn = false;
                  for( int k = 0; k < compDirs.length; k++ )
                       if(acsNetCompNames[j].equals(compDirs[k].getName())){
                          fileNum = compDirs[k].listFiles().length;
                          compOn = true;
                          break;
                       }
                  if( compOn )
                  {  // existing component.
                     for( int m = 0; m < maxFileNum; m++ ){
                          if( m < fileNum ){
                              loadedFileName = acsNetFileNames[ j ] + m + ".txt";
                              userOptions[ACS][ACS_NET][netType][i][j][m] = loadOptions( path +
                                 "\\net" + i + "\\" + acsNetCompNames[j] + "\\" );
                          }
                          else{
                              loadedFileName = acsNetFileNames[ j ] + 0 + ".txt";
                              userOptions[ACS][ACS_NET][netType][i][j][m] = loadOptions( path +
                                 "\\net" + i + "\\" + acsNetCompNames[j] + "\\" );
                          }
                     }
                 }
                 else{ // the component doesn't exist, copy from corresponding system options.
                     //System.out.println( "the component doesn't exist, copy from corresponding DEFAULT options." );
                     fileNum = sysOptions[ACS][ACS_NET][netType][0][j].length;
                     for( int m = 0; m < maxFileNum; m++ )
                          if( m < fileNum ){
                              int optNum = sysOptions[ACS][ACS_NET][netType][0][j][m].length;
                              userOptions[ACS][ACS_NET][netType][i][j][m] = new Option[optNum];
                              for( int n = 0; n < optNum; n++ )
                                   userOptions[ACS][ACS_NET][netType][i][j][m][n] =
                                      (Option)(sysOptions[ACS][ACS_NET][netType][0][j][m][n].clone());
                          }
                          else{
                             int optNum = sysOptions[ACS][ACS_NET][netType][0][j][0].length;
                             userOptions[ACS][ACS_NET][netType][i][j][m] = new Option[optNum];
                             for( int n = 0; n < optNum; n++ )
                                  userOptions[ACS][ACS_NET][netType][i][j][m][n] =
                                     (Option)(sysOptions[ACS][ACS_NET][netType][0][j][0][n].clone());
                          }
                 }
             }
          }
          else{  // copy from other networks.
             userOptions[ACS][ACS_NET][netType][i] = new Option[userOptions[ACS][ACS_NET][netType][0].length][][];
             for( int j = 0; j < ACS_NET_COMP_NUM; j++ ){
               userOptions[ACS][ACS_NET][netType][i][j] = new Option[userOptions[ACS][ACS_NET][netType][0][j].length][];
               for( int k = 0; k < userOptions[ACS][ACS_NET][netType][0][j].length; k++ ){
                 userOptions[ACS][ACS_NET][netType][i][j][k] = new Option[userOptions[ACS][ACS_NET][netType][0][j][k].length];
                 for( int m = 0; m < userOptions[ACS][ACS_NET][netType][0][j][k].length; m++ )
                      userOptions[ACS][ACS_NET][netType][i][j][k][m] =
                            (Option)(userOptions[ACS][ACS_NET][netType][0][j][k][m].clone());
                 }
            }
          }
     }
  }

  private void loadAcsGSSettings()
  {
     loadedFileName = "goalstruct.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\acs\\";
     sysOptions[ACS][ACS_GS] = new Option[1][1][1][1][];
     sysOptions[ACS][ACS_GS][0][0][0][0] = loadOptions( path );

     /*
     path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\acs\\";
     if( new File( path + loadedFileName ).exists() ){
         userOptions[ACS][ACS_GS] = new Option[1][1][1][1][];
         userOptions[ACS][ACS_GS][0][0][0][0] = loadOptions( path );
     }
     else{
         //System.out.println( "the Goal Structure doesn't exist, copy from corresponding DEFAULT options." );
         int len = sysOptions[ACS][ACS_GS][0][0][0][0].length;
         userOptions[ACS][ACS_GS] = new Option[1][1][1][1][len];
         for( int i = 0; i < len; i++ )
              userOptions[ACS][ACS_GS][0][0][0][0][i] = (Option)sysOptions[ACS][ACS_GS][0][0][0][0][i].clone();
     }
     */
     userOptions[ACS][ACS_GS] = new Option[1][1][1][1][];
     path = searchFile( "acs", loadedFileName );
     userOptions[ACS][ACS_GS][0][0][0][0] = loadOptions( path );

     //System.out.println( "path = " + path );

  }

  private void loadAcsWMSettings()
  {
     loadedFileName = "workmem.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\acs\\";
     sysOptions[ACS][ACS_WM] = new Option[1][1][1][1][];
     sysOptions[ACS][ACS_WM][0][0][0][0] = loadOptions( path );
     userOptions[ACS][ACS_WM] = new Option[1][1][1][1][];
     path = searchFile( "acs", loadedFileName );
     userOptions[ACS][ACS_WM][0][0][0][0] = loadOptions( path );
  }

  private void loadNacsCompSettings()
  {
     loadedFileName = "components.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\nacs\\";
     sysOptions[NACS][NACS_COMP] = new Option[1][1][1][1][];
     sysOptions[NACS][NACS_COMP][0][0][0][0] = loadOptions( path );
     //path = global.getOptionDir() + "\\" + global.getTaskName()
     //              + "\\" + global.getOptionName() + "\\nacs\\";
     userOptions[NACS][NACS_COMP] = new Option[1][1][1][1][];
     userOptions[NACS][NACS_COMP][0][0][0][0] = loadOptions( subsysPath );
  }

  private void loadNacsGksSettings()
  {
     loadedFileName = "gks.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\nacs\\";
     sysOptions[NACS][NACS_GKS] = new Option[1][1][1][1][];
     sysOptions[NACS][NACS_GKS][0][0][0][0] = loadOptions( path );
     //path = global.getOptionDir() + "\\" + global.getTaskName()
     //              + "\\" + global.getOptionName() + "\\nacs\\";
     userOptions[NACS][NACS_GKS] = new Option[1][1][1][1][];
     userOptions[NACS][NACS_GKS][0][0][0][0] = loadOptions( subsysPath );
  }

  private void loadNacsAmnSettings()
  {
     loadedFileName = "amn.txt";
     // fill in system options
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\nacs\\amns";
     int netNum = new File( path ).list().length;
     sysOptions[NACS][NACS_AMN] = new Option[netNum][1][1][1][];
     for( int i = 0; i < netNum; i++ )
          sysOptions[NACS][NACS_AMN][i][0][0][0] = loadOptions( path + "\\amn" + i + "\\" );
     // fill in user options
     path = subsysPath + "amns";
     netNum = new File( path ).list().length;
     userOptions[NACS][NACS_AMN] = new Option[Global.MAX_AMN_NUM][1][1][1][];
     for( int i = 0; i < Global.MAX_AMN_NUM; i++ ){
          if( i < netNum )
              userOptions[NACS][NACS_AMN][i][0][0][0] = loadOptions( path + "\\amn" + i + "\\" );
          else{
              userOptions[NACS][NACS_AMN][i] = new Option[1][1][1][userOptions[NACS][NACS_AMN][0][0][0][0].length];
              for( int j = 0; j < userOptions[NACS][NACS_AMN][0][0][0][0].length; j++ )
                   userOptions[NACS][NACS_AMN][i][0][0][0][j] =
                       (Option)(userOptions[NACS][NACS_AMN][0][0][0][0][j].clone());
          }
     }
  }

  private void loadNacsAemSettings()
  {
     loadedFileName = "aem.txt";
     // load AEM settings.
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\nacs\\";
     sysOptions[NACS][NACS_AEM] = new Option[1][1][1][1][];
     sysOptions[NACS][NACS_AEM][0][0][0][0] = loadOptions( path );
     path = searchFile( "nacs", loadedFileName );
     userOptions[NACS][NACS_AEM] = new Option[1][1][1][1][];
     userOptions[NACS][NACS_AEM][0][0][0][0] = loadOptions( path );

     //System.out.println( "path = " + path );

  }

  private void loadNacsCoordinateSettings()
  {
     loadedFileName = "coordinate.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\nacs\\";
     sysOptions[NACS][NACS_COR] = new Option[1][1][1][1][];
     sysOptions[NACS][NACS_COR][0][0][0][0] = loadOptions( path );
     //path = global.getOptionDir() + "\\" + global.getTaskName()
     //              + "\\" + global.getOptionName() + "\\nacs\\";
     userOptions[NACS][NACS_COR] = new Option[1][1][1][1][];
     userOptions[NACS][NACS_COR][0][0][0][0] = loadOptions( subsysPath );
  }

  private void loadSuperCompSettings()
  {
     loadedFileName = "components.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\super\\";
     sysOptions[SUPER][SUPER_COMP] = new Option[1][1][1][1][];
     sysOptions[SUPER][SUPER_COMP][0][0][0][0] = loadOptions( path );
     userOptions[SUPER][SUPER_COMP] = new Option[1][1][1][1][];
     userOptions[SUPER][SUPER_COMP][0][0][0][0] = loadOptions( subsysPath );
  }

  private void loadMsSettings()
  {
     loadedFileName = "ms.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\super\\";
     sysOptions[SUPER][SUPER_MS] = new Option[1][1][1][1][];
     sysOptions[SUPER][SUPER_MS][0][0][0][0] = loadOptions( path );
     path = searchFile( "super", loadedFileName );
     userOptions[SUPER][SUPER_MS] = new Option[1][1][1][1][];
     userOptions[SUPER][SUPER_MS][0][0][0][0] = loadOptions( path );
  }

  private void loadMcsSettings()
  {
     loadedFileName = "mcs.txt";
     String path = global.getOptionDir() + "\\DEFAULT\\subjectGroup0\\super\\";
     sysOptions[SUPER][SUPER_MCS] = new Option[1][1][1][1][];
     sysOptions[SUPER][SUPER_MCS][0][0][0][0] = loadOptions( path );
     path = searchFile( "super", loadedFileName );
     userOptions[SUPER][SUPER_MCS] = new Option[1][1][1][1][];
     userOptions[SUPER][SUPER_MCS][0][0][0][0] = loadOptions( path );
  }

  private Option[] loadOptions( String path )
  {
     try {
           loadedFile = new RandomAccessFile( path + loadedFileName, "rw" );
     }
     catch ( IOException e ) {
             System.out.println( path + loadedFileName );
             JOptionPane.showMessageDialog( null, "File Operation Error in loading",
                  "Invalid File Name", JOptionPane.ERROR_MESSAGE );
     }
     String numMark = "The number of options : ";
     String[] optionMarks = {
        "Option label : ",  "Option choice number : ", "Default choice : ", "User choice : "
     };
     String[] paramMarks = {
        "Parameter number : ", "Parameter major type : ", "Parameter minor type : ",
        "Parameter label : ", "Parameter value : "
     };
     Option[] opts = null;
     try{
       loadedFile.seek( 0 );
       // option number.
       String str = loadedFile.readLine();
       int optionNum = Integer.parseInt(str.substring(numMark.length(),str.length()).trim());
       opts = new Option[ optionNum ];
       for( int i = 0; i < optionNum; i++ ){
            // option label.
            str = loadedFile.readLine();
            String optLabel = str.substring(optionMarks[0].length(),str.length());
            // choice number.
            str = loadedFile.readLine();
            int choiceNum = Integer.parseInt( str.substring(optionMarks[1].length(),
                                          str.length()).trim());
            // default choice.
            str = loadedFile.readLine();
            int defaultChoice = Integer.parseInt( str.substring(optionMarks[2].length(),
                                                  str.length()).trim());
            // user choice.
            str = loadedFile.readLine();
            int subjectGroupChoice = Integer.parseInt( str.substring(optionMarks[3].length(),
                                               str.length()).trim());
            opts[i] = new Option( optLabel, choiceNum, defaultChoice, subjectGroupChoice );
            // option items.
            OptionItem[] optItems = new OptionItem[ choiceNum ];
            for( int j = 0; j < choiceNum; j++ ){
                 // item label.
                 String itemLabel = loadedFile.readLine().substring( "Item label : ".length() );
                 // item parameter number.
                 str = loadedFile.readLine();
                 int paramNum = Integer.parseInt( str.substring( paramMarks[0].length(),
                                                  str.length()).trim());
                 Parameter[] optParams = new Parameter[ paramNum ];
                 // item parameters.
                 for( int k = 0; k < paramNum; k++ ){
                      str = loadedFile.readLine();
                      int paraMajorType = Integer.parseInt(
                          str.substring(paramMarks[1].length(),str.length()).trim() );
                      str = loadedFile.readLine();
                      int paraMinorType = Integer.parseInt(
                          str.substring(paramMarks[2].length(),str.length()).trim() );
                      str = loadedFile.readLine();
                      String paramName = str.substring( paramMarks[3].length(),
                                         str.length());
                      str = loadedFile.readLine();
                      if( paraMajorType == Global.PRIM_TYPE ){
                          String paramValue = str.substring(
                                 paramMarks[4].length(), str.length() );
                          optParams[k] = new Parameter( paraMajorType, paraMinorType,
                                             paramName, paramValue );
                      }
                      else{
                          String line = str.substring(
                                 paramMarks[4].length(),str.length());
                          StringTokenizer st = new StringTokenizer( line, Global.VALUE_DELIM );
                          int count = 0;
                          String[] tokens = new String[ line.length() ];
                          while( st.hasMoreTokens() )
                                 tokens[count++] = st.nextToken();
                          String[] paramValues = new String[ count ];
                          for( int m = 0; m < count; m++ )
                               paramValues[ m ] = tokens[ m ];

                          //System.out.println( "len = " + paramValues.length );

                          optParams[k] = new Parameter( paraMajorType, paraMinorType,
                                             paramName, paramValues );
                     }
                 }
                 optItems[j] = new OptionItem( itemLabel, optParams );
            }
            opts[i].setOptionItems( optItems );
       }
     }
     catch( Exception e ){
       System.out.println( e );
     }
     return opts;
  }

  private void saveAcsCompSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalAcsComponents();
         return;
     }
     // create ACS component setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\acs\\";
     savedFileName = "components.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save ACS component setting.
     saveOptions( path, userOptions[ACS][ACS_COMP][0][0][0][0] );
  }

  private void saveAcsCoordinate()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalAcsCoordinate();
         return;
     }
     // create ACS component setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\acs\\nets\\";
     savedFileName = "coordinate.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save ACS component setting.
     saveOptions( path, userOptions[ACS][ACS_NET][ACS_COR][0][0][0] );
  }

  private void saveAcsNetSettings( int netType )
  {
     String[] subNetName = { "ex", "wm", "gs" };
     String path = global.getOptionDir() + "\\" + global.getTaskName() + "\\" + global.getOptionName()
                    + "\\acs\\nets\\" + subNetName[netType] +"\\";
     if( saveCode == SAVE_TO_FILE ){
         // create a directory \\acs\\nets
         new File( path ).mkdir();
     }
     int netNum = 1;
     if( netType == EX_NET )
         netNum = this.getAcsExNetNum();
     try{
       for( int i = 0; i < netNum; i++ ){
            if( saveCode == SAVE_TO_FILE ){
                File netDir = new File( path + "\\net" + i );
                // create dir \\acs\\nets\\neti
                netDir.mkdir();
            }
            for( int j = 0; j < ACS_NET_COMP_NUM; j++ ){
                 if( j == COMP ){
                    if( saveCode == SAVE_TO_FILE ){
                        savedFileName = acsNetFileNames[j] + ".txt";
                        saveOptions( path + "\\net" + i + "\\", userOptions[ACS][ACS_NET][netType][i][j][0] );
                     }
                     else {
                        initGlobalAcsNet( netType, i, j, 0, 1 );
                        //System.out.println( "ater net basics" );
                     }
                 }
                 else if( isAcsCompOn( netType, i, j ) ){ // if the component exists
                        if( saveCode == SAVE_TO_FILE ){
                            File compDir = new File( path + "\\net" + i + "\\" + acsNetCompNames[j] );
                            // create dir: \\acs\\nets\\neti\\IDN, RER,IRL,or FR.
                            boolean bVal = compDir.mkdir();
                         }
                         int fileNum = getAcsCompFileNum( netType, i, j );
                         // convert netIdx.
                         int netIdx = 0;
                         if( netType == this.EX_NET )
                             netIdx = i;
                         if( netType == this.GS_NET )
                             netIdx = global.getGsNetIdx();
                         if( netType == this.WM_NET )
                             netIdx = global.getWmNetIdx();
                         if( saveCode == SAVE_TO_GLOBAL )
                             global.initAcsRules( netIdx, j, fileNum );
                         for( int k = 0; k < fileNum; k++ ){
                              if( saveCode == SAVE_TO_FILE ){
                                  savedFileName = acsNetFileNames[j] + k + ".txt";
                                  saveOptions( path + "\\net" + i + "\\" + acsNetCompNames[j] +"\\",
                                               userOptions[ACS][ACS_NET][netType][i][j][k] );
                              }
                              else {
                                  initGlobalAcsNet( netType, i, j, k, fileNum );
                                  //if( j == IRL )
                                  //    System.out.println( "irl rule set # = " + fileNum );
                              }
                         }
                 }
                 //if( j >= IRL )
                 //    System.out.println( "irl set num = " + global.getIrlRuleNums(0).length );
            }
       }
     }
     catch( Exception e ){
       System.out.println( e );
     }


  }

  private void saveAcsGSSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalAcsGS();
         return;
      }
     // create ACS GS setting file
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\acs\\";
     savedFileName = "goalstruct.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save ACS GS setting.
     saveOptions( path, userOptions[ACS][ACS_GS][0][0][0][0] );
  }

  private void saveAcsWMSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalAcsWM();
         return;
      }
     // create ACS WM setting file
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\acs\\";
     savedFileName = "workmem.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save ACS WM setting.
     saveOptions( path, userOptions[ACS][ACS_WM][0][0][0][0] );
  }

  private void saveNacsCompSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalNacsComponents();
         return;
      }
     // create NACS components setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\nacs\\";
     savedFileName = "components.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save NACS components setting.
     saveOptions( path, userOptions[NACS][NACS_COMP][0][0][0][0] );
  }

  private void saveNacsAmnSettings()
  {
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\nacs\\amns";
     if( saveCode == SAVE_TO_FILE ){
         new File( path ).mkdir();
     }
     int netNum = getAmnNum();
     // initialize global.java with netNum info.
     if( saveCode == SAVE_TO_GLOBAL ){
         global.setAmnNum( netNum );
         global.initNacsNets();
     }
     try{
       for( int i = 0; i < netNum; i++ ){
            if( saveCode == SAVE_TO_FILE ){
                File file1 = new File( path + "\\amn" + i );
                file1.mkdir();
                File file2 = new File( path + "\\amn" + i + "\\" + "amn.txt" );
                file2.createNewFile();
                savedFileName = "amn.txt";
                saveOptions( path + "\\amn" + i + "\\", userOptions[NACS][NACS_AMN][i][0][0][0] );
            }
            else
                initGlobalAmn( i );
       }
     }
     catch( Exception e ){
       System.out.println( e );
     }
  }

  private void saveNacsGksSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalGks();
         return;
     }
     // create NACS gks setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\nacs\\";
     savedFileName = "gks.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save NACS gks setting.
     saveOptions( path, userOptions[NACS][NACS_GKS][0][0][0][0] );
  }

  private void saveNacsAemSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalAem();
         return;
     }
     // create NACS aem setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\nacs\\";
     savedFileName = "aem.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save NACS gks setting.
     saveOptions( path, userOptions[NACS][NACS_AEM][0][0][0][0] );
  }

  private void saveNacsCoordinateSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalNacsCoordinate();
         return;
     }
     // create NACS coordinate setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\nacs\\";
     savedFileName = "coordinate.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save NACS coordinate setting.
     saveOptions( path, userOptions[NACS][NACS_COR][0][0][0][0] );
  }

  private void saveSuperCompSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalSuperComp();
         return;
     }
     // create supervisory setting directory.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\super";
     savedFileName = "\\supervisory.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save supervisory setting.
     saveOptions( path, userOptions[SUPER][SUPER_COMP][0][0][0][0] );
  }

  private void saveMsSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalMS();
         return;
     }
     // create NACS gks setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\super\\";
     savedFileName = "ms.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save NACS gks setting.
     saveOptions( path, userOptions[SUPER][SUPER_MS][0][0][0][0] );
  }

  private void saveMcsSettings()
  {
     if( saveCode == SAVE_TO_GLOBAL ){
         initGlobalMCS();
         return;
     }
     // create NACS gks setting file.
     String path = global.getOptionDir() + "\\" + global.getTaskName()
                   + "\\" + global.getOptionName() + "\\super\\";
     savedFileName = "mcs.txt";
     try{
        new File( path + savedFileName ).createNewFile();
     }
     catch( Exception e ){
        System.out.println( e );
     }
     // save NACS gks setting.
     saveOptions( path, userOptions[SUPER][SUPER_MCS][0][0][0][0] );
  }

  private void saveOptions( String path, Option[] opts )
  {
     try {
          //System.out.println( path + savedFileName );
          savedFile = new RandomAccessFile( path + savedFileName, "rw" );
          savedFile.seek( 0 );
          savedFile.writeBytes("The number of options : " + opts.length + "\n" );
          for( int i = 0; i < opts.length; i++ ){
               //System.out.println( opts[i].toString() );
               savedFile.writeBytes( opts[i].toString() );
          }
     }
     catch ( IOException e ) {
             JOptionPane.showMessageDialog( null, "File Operation Error in writing!",
                  "Invalid File Name", JOptionPane.ERROR_MESSAGE );
     }
  }

  public int calcAcsNetCompType( String name )
  {
     int type = COMP;
     for( int i = 0; i < acsNetCompNames.length; i++ )
          if( acsNetCompNames[ i ].equals( name ) ){
              type = i;
              break;
           }
     return type;
  }

/************************** initialize global variables ***********************/
  private void initGlobalSubsys()
  {
    final int SUB_NACS = 0, SUB_SUPER = 1, SUB_RT = 2;
    Option[] opts = userOptions[SUBSYS][0][0][0][0][0];
    global.setNacsOn( opts[SUB_NACS].getUserChoice() == ON );
    global.setSupervisorySubsysOn( opts[SUB_SUPER].getUserChoice() == ON );
    global.setRtOn( opts[SUB_RT].getUserChoice() == ON );
  }

  private void initGlobalFeatures()
  {
    final int TYPE_NUM = 0, FEAT_NUMS = 1, FEAT_NAMES = 2;
    final int START = 3, V_START = 6;
    Option[] opts = userOptions[DIMS][0][0][0][0][0];
    // feature type number
    int typeNum = opts[TYPE_NUM].getOptionItem(0).getParameter(0).getIntValue();
    global.setFeatureTypeNum( typeNum );
    // feature numbers
    short[] featNums = new short[ typeNum ];
    for( int i = 0; i < typeNum; i++ )
         featNums[i] = (short)(opts[FEAT_NUMS].getOptionItem(0).getParameter(i).getIntValue());
    global.setFeatureNums( featNums );
    // feature names.
    String[][] featNames = new String[ typeNum ][];
    for( int i = 0; i < typeNum; i++ ){
         featNames[i] = new String[ featNums[i] ];
         for( int j = 0; j < featNums[i]; j++ )
              featNames[i][j] = opts[FEAT_NAMES].getOptionItem(0).getParameter(i).getStringValues()[j];

    }
    global.setFeatureNames( featNames );
    // feature lengths.
    short[][] featLengths = new short[ typeNum ][];
    for( int i = 0; i < typeNum; i++ ){
         featLengths[i] = new short[ featNums[i] ];
         for( int j = 0; j < featNums[i]; j++ )
              featLengths[i][j]= (short)(opts[START+i].getOptionItem(0).getParameter(0).getIntValues()[j]);

    }
    global.setFeatureLengths( featLengths );
    // feature value names.
    String[][][] featValNames = new String[typeNum][][];
    for( int i = 0; i < typeNum; i++ ){
         featValNames[i] = new String[ featNums[i] ][];
         for( int j = 0; j < featNums[i]; j++ ){
              featValNames[i][j] = new String[ featLengths[i][j] ];
              for( int k = 0; k < featLengths[i][j]; k++ ){
                   featValNames[i][j][k] = opts[V_START+i].getOptionItem(0).getParameter(j).getStringValues()[k];
              }
         }

    }
    global.setFeatureValueNames( featValNames );
  }

  // 5 userOptions.
  private void initGlobalAcsComponents()
  {
     final int GS_OPT = 0, WM_OPT = 1, EX_NET_NUM = 2, GS_IDN_ON = 3, WM_IDN_ON = 4;
     Option[] opts = userOptions[ACS][ACS_COMP][0][0][0][0];
     global.setGsOption( opts[GS_OPT].getUserChoice() );
     global.setWmOption( opts[WM_OPT].getUserChoice()==ON );
     global.setExNetNum( opts[EX_NET_NUM].getOptionItem(0).getParameter(0).getIntValue() );
     global.setGsIdnOn(opts[GS_IDN_ON].getUserChoice() == ON);
     global.setWmIdnOn(opts[WM_IDN_ON].getUserChoice() == ON);
  }

  private void initGlobalAcsCoordinate()
  {
     final int ELIG = 0, REIN = 1, REIN_ALL = 2, COR_EX = 3, COR_EX_GS = 4;
     Option[] opts = userOptions[ACS][ACS_NET][ACS_COR][0][0][0];
     global.setCorMultiExtMode( opts[COR_EX].getUserChoice());
     global.setExternCorConstant(opts[COR_EX_GS].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setGoalCorConstant(opts[COR_EX_GS].getOptionItem(0).getParameter(1).getDoubleValue());
  }

  private void initGlobalAcsNet( int netType, int netIdx, int compIdx, int setIdx, int setNum )
  {
     switch( compIdx ){
       case IDN:
            initGlobalIdn( netType, netIdx );
            break;
       case RER:
            initGlobalRer( netType, netIdx );
            break;
       case IRL:
            initGlobalIrl( netType, netIdx, setIdx, setNum );
            break;
       case FR:
            initGlobalFR( netType, netIdx, setIdx, setNum );
            break;
       default:
            initGlobalAcsNetBasics( netType, netIdx );
            break;
     }
  }

  // 7 userOptions.
  private void initGlobalAcsGS()
  {
     final int GOAL = 0, SIZE_GC = 1, PARA_DIM = 2, SIZE_G = 3;
     final int TH_GS = 4, DEC_MODE = 5, BLA_OPT = 6, ITEM_DIM = 7;
     Option[] opts = userOptions[ACS][ACS_GS][0][0][0][0];
     //global.setGoalFeatureLabels( String[] values );
     //global.getGoalChunkLabels( String[] values );
     //global.setGoals( goals );
     global.setGoalChunkSize( opts[SIZE_GC].getOptionItem(0).getParameter(0).getIntValue() );
     //the length of each goal parameter dimension.
     //global.setGoalParaDimVals( opts[PARA_DIM].getOptionItem(0).getParameter(0).getIntValues() );
     // goal structure size.
     global.setGoalStructSize( opts[SIZE_G].getOptionItem(0).getParameter(0).getIntValue() );
     // threshold when checking qualification for participating in the competition of the goal list.
     global.setGoalActivationThreshold( opts[TH_GS].getOptionItem(0).getParameter(0).getDoubleValue() );
     // goal decided by TL or both of levels.
     global.setGoalDecisionMode( opts[DEC_MODE].getUserChoice() );
     // goal BLA option
     global.setGoalBlaOption( opts[BLA_OPT].getUserChoice() );
     // goal BLA.
     if( global.getGoalBlaOption() == global.CONSTANT_OPTION )
         global.setGoalBla( opts[BLA_OPT].getOptionItem(0).getParameter(0).getDoubleValue() );
     else {
         double[] params = new double[ opts[BLA_OPT].getOptionItem(1).getParameters().length ];
         for( int i = 0; i < params.length; i++ )
              params[i] = opts[BLA_OPT].getOptionItem(1).getParameter(i).getDoubleValue();
         global.setGoalBlaParas( params );
     }
     // GS item dim info including GOAL dim.
     int dimNum = opts[ITEM_DIM].getOptionItem(0).getParameter(0).getCount()/2;
     short[][] dimInfos = new short[dimNum][2];
     short[] paramValue = opts[ITEM_DIM].getOptionItem(0).getParameter(0).getIntValues();
     for( int j = 0; j < dimNum; j++ ){
          dimInfos[j][0] = paramValue[2*j];
          dimInfos[j][1] = paramValue[2*j+1];
     }
     global.setGsItemDimInfo( dimInfos );
  }

  // 6 userOptions.
  private void initGlobalAcsWM()
  {
     final int SIZE_WM = 0, TH_WM = 1, FLAG_WM = 2, ACT_DEC_MODE = 3;
     final int FLAG_DEC_MODE = 4, BLA_OPT = 5, ITEM_NUM = 6, ITEM_DIM = 7;
     Option[] opts = userOptions[ACS][ACS_WM][0][0][0][0];
     global.setWmSize( opts[SIZE_WM].getOptionItem(0).getParameter(0).getIntValue() );
     global.setWmActivationThreshold( opts[TH_WM].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setWmFlagsOn( opts[FLAG_WM].getUserChoice()==ON );
     global.setWmActionDecisionMode( opts[ACT_DEC_MODE].getUserChoice() );
     global.setWmActionFlagDecisionMode( opts[FLAG_DEC_MODE].getUserChoice() );
     global.setWmBlaOption( opts[BLA_OPT].getUserChoice() );
     // WM BLA.
     if( global.getWmBlaOption() == global.CONSTANT_OPTION )
         global.setWmBla( opts[BLA_OPT].getOptionItem(0).getParameter(0).getDoubleValue() );
     else {
         double[] params = new double[ opts[BLA_OPT].getOptionItem(1).getParameters().length ];
         for( int i = 0; i < params.length; i++ )
              params[i] = opts[BLA_OPT].getOptionItem(1).getParameter(i).getDoubleValue();
         global.setWmBlaParas( params );
     }
     // WM item # in different sections.
     global.setWmItemNums(opts[ITEM_NUM].getOptionItem(0).getParameter(0).getIntValues());
     // WM item dim info in different sections.
     int sectNum = opts[ITEM_DIM].getOptionItem(0).getCount();
     short[][][] dimInfos = new short[ sectNum ][][];
     for( int i = 0; i < sectNum; i++ ){
          int dimNum = opts[ITEM_DIM].getOptionItem(0).getParameter(i).getCount()/2;
          dimInfos[i] = new short[dimNum][2];
          short[] paramValue = opts[ITEM_DIM].getOptionItem(0).getParameter(i).getIntValues();
          for( int j = 0; j < dimNum; j++ ){
               dimInfos[i][j][0] = paramValue[2*j];
               dimInfos[i][j][1] = paramValue[2*j+1];
          }
     }
     global.setWmItemDimInfos( dimInfos );
     // WM item lengths.
     short[] wmItemLengths = CommonMethods.calcWmItemLengths( global.getWmSize(),
             global.getWmItemNums(), global.getWmItemDimInfos(), global.getFeatureLengths() );
     global.setWmItemLengths( wmItemLengths );
  }

  private void initGlobalNacsComponents()
  {
     final int GKS = 0, AMN = 1, EM = 2, AEM = 3;
     Option[] opts = userOptions[NACS][NACS_COMP][0][0][0][0];
     global.setGKSon( opts[GKS].getUserChoice()==ON );
     global.setAmnNum( opts[AMN].getOptionItem(0).getParameter(0).getIntValue() );
     global.setEMon( opts[EM].getUserChoice()==ON );
     global.setAEMon( opts[AEM].getUserChoice()==ON );
  }

  private void initGlobalGks()
  {
     final int IN_DIM_TYPE = 0, OUT_DIM_TYPE = 1, IN_DIM_IDX = 2, OUT_DIM_IDX = 3, TEMP = 4;
     final int ESC = 5, EPI = 6, UTL_ON = 7, SUP_ON = 8, PM_ON = 9, RBLA_ON = 10;
     final int CBLA_ON = 11, WEIGHT = 12, UTL = 13, RBLA = 14, CBLA = 15, ABLA = 16;
     final int NBLA = 17, EM_TH = 18, EM_PROB = 19, EM_ITEM = 20, EM_ITER = 21;
     final int SBR = 22, SBR_TH = 23, SBR_PARAM = 24, REXT_ON = 25, RENC_ON = 26;
     final int ASSIM_ON = 27, CENC_ON = 28, CEXT_ON = 29, MCS_ON = 30;
     final int CENC_PROB = 31, RENC_PROB = 32, CDEN = 33, RDEN = 34, REXT_TH = 35;
     final int CEXT_TH = 36, REXT_PROB = 37, CEXT_PROB = 38, TH_MEASURE = 39;
     Option[] opts = userOptions[NACS][NACS_GKS][0][0][0][0];
     // input dimension values.
     int type = opts[IN_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     int dimNum = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     short[] dimIdxs = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] dimVals = new short[ dimNum ];
     short[][] featInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          dimVals[i] = (short)global.getFeatureLength(type, dimIdxs[i]);
          featInfo[i][0] = (short)type;
          featInfo[i][1] = dimIdxs[i];
     }
     global.setGksInputDimVals( dimVals );
     global.setGksInputFeatureInfo( featInfo );
     // output dimension values.
     type = opts[OUT_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     dimNum = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     short[] oDimIdxs = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] oDimVals = new short[ dimNum ];
     short[][] oFeatInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          oDimVals[i] = (short)global.getFeatureLength(type, oDimIdxs[i]);
          oFeatInfo[i][0] = (short)type;
          oFeatInfo[i][1] = oDimIdxs[i];
     }
     global.setGksOutputDimVals( oDimVals );
     global.setGksOutputFeatureInfo( oFeatInfo );
     // temperature
     global.setGksOutputTemperature( opts[TEMP].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setESChunkOn( opts[ESC].getUserChoice()==ON );
     global.setEpiChunkOn( opts[EPI].getUserChoice()==ON );
     global.setAssocUtilityOn( opts[UTL_ON].getUserChoice()==ON );
     global.setAssocSupportOn( opts[SUP_ON].getUserChoice()==ON );
     global.setAssocPartMatchOn( opts[PM_ON].getUserChoice()==ON );
     global.setAssocBlaOn( opts[RBLA_ON].getUserChoice()==ON);
     global.setNacsChunkBlaOn( opts[CBLA_ON].getUserChoice()==ON );
     global.setAssocWeightMode( opts[WEIGHT].getUserChoice() );
     // utility settings.
     if( global.isAssocUtilityOn() ){
         int optIdx = opts[UTL].getUserChoice();
         global.setAssocUtilityOption( optIdx );
         if( optIdx < 2 ){ // not the user defined
             double[] utlParams = new double[ opts[UTL].getOptionItem(optIdx).getParameters().length ];
             for( int j = 0; j < utlParams.length; j++ )
                  utlParams[j] = opts[UTL].getOptionItem(optIdx).getParameter(j).getDoubleValue();
             global.setAssocUtilityParas( utlParams );
        }
     }
     // BLA settings.
     if( global.isAssocBlaOn() ){
         global.setAssocBlaOption( opts[RBLA].getUserChoice() );
         if( global.getAssocBlaOption() == global.CONSTANT_OPTION )
             global.setAssocBla( opts[RBLA].getOptionItem(0).getParameter(0).getDoubleValue() );
         else {
           double[] params = new double[ opts[RBLA].getOptionItem(1).getParameters().length ];
           for( int i = 0; i < params.length; i++ )
                params[i] = opts[RBLA].getOptionItem(1).getParameter(i).getDoubleValue();
           global.setAssocBlaParas( params );
         }
     }
     if( global.isNacsChunkBlaOn() ){
         global.setChunkBlaOption( opts[CBLA].getUserChoice() );
         if( global.getChunkBlaOption() == global.CONSTANT_OPTION )
             global.setAssocBla( opts[CBLA].getOptionItem(0).getParameter(0).getDoubleValue() );
         else {
           double[] params = new double[ opts[CBLA].getOptionItem(1).getParameters().length ];
           for( int i = 0; i < params.length; i++ )
                params[i] = opts[CBLA].getOptionItem(1).getParameter(i).getDoubleValue();
           global.setChunkBlaParas( params );
         }
     }
     // EM settings.
     if( global.isEMon() ){
         // EM BLA settings.
         short[] blaOptValues = new short[ 2 ];
         blaOptValues[0] = (short)opts[ABLA].getUserChoice();
         blaOptValues[1] = (short)opts[NBLA].getUserChoice();
         global.setEmBlaOptions( blaOptValues );
         if( global.getEmBlaOption(0) == global.CONSTANT_OPTION &&
             global.getEmBlaOption(1) == global.CONSTANT_OPTION ){
             double[] blas = new double[ 2 ];
             blas[0] = opts[ABLA].getOptionItem(0).getParameter(0).getDoubleValue();
             blas[1] = opts[NBLA].getOptionItem(0).getParameter(0).getDoubleValue();
             global.setEmBlas( blas );
         }
         else{
             double[][] blaParams = new double[2][];
             if( global.getEmBlaOption(0) != global.CONSTANT_OPTION ){
                 blaParams[0] = new double[ opts[ABLA].getOptionItem(1).getParameters().length ];
                 for( int i = 0; i < blaParams[0].length; i++ )
                      blaParams[0][i] = opts[ABLA].getOptionItem(1).getParameter(i).getDoubleValue();
             }
             if( global.getEmBlaOption(1) != global.CONSTANT_OPTION ){
                 blaParams[1] = new double[ opts[NBLA].getOptionItem(1).getParameters().length ];
                 for( int i = 0; i < blaParams[1].length; i++ )
                      blaParams[1][i] = opts[NBLA].getOptionItem(1).getParameter(i).getDoubleValue();
             }
             global.setEmBlaParas( blaParams );
         }
         // EM other settings.
         global.setThreshold_EM( opts[EM_TH].getOptionItem(0).getParameter(0).getDoubleValue() );
         //global.setEmCapacity( int value );
         global.setEmTrainProb( opts[EM_PROB].getOptionItem(0).getParameter(0).getDoubleValue() );
         global.setEmTrainItemNum( opts[EM_ITEM].getOptionItem(0).getParameter(0).getIntValue() );
         global.setEmTrainIterNum( opts[EM_ITER].getOptionItem(0).getParameter(0).getIntValue() );
     }
     global.setThreshold_sim( opts[SBR_TH].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setRBR_BalConstant( opts[SBR_PARAM].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setSBR_BalConstant( opts[SBR_PARAM].getOptionItem(0).getParameter(1).getDoubleValue() );
    /*********************** SETTINGS ABOUT GKS LEARNINGS ************************/
     global.setAssocExtractOn( opts[REXT_ON].getUserChoice()==ON );
     global.setAssocEncodeExternOn( opts[RENC_ON].getUserChoice()==ON );
     global.setAssocAssimiOn( opts[ASSIM_ON].getUserChoice()==ON );
     global.setChunkEncodeExternOn( opts[CENC_ON].getUserChoice()==ON );
     global.setChunkFromAmnOn( opts[CEXT_ON].getUserChoice()==ON );
     global.setChunkByMCSOn( opts[MCS_ON].getUserChoice()==ON );
     global.setChunkEncodeProb( opts[CENC_PROB].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setAssocEncodeProb( opts[RENC_PROB].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setChunkDensity( opts[CDEN].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setAssocDensity( opts[RDEN].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setAssocExtThreshold( opts[REXT_TH].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setChunkExtThreshold( opts[CEXT_TH].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setAssocExtProb( opts[REXT_PROB].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setChunkExtProb( opts[CEXT_PROB].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setActivationMeasure( opts[TH_MEASURE].getUserChoice() );
  }

  private void initGlobalAmn( int amnIdx )
  {
     final int AMN_TYPE = 0, IN_DIM_TYPE = 1, OUT_DIM_TYPE = 2, IN_DIM_IDX = 3;
     final int OUT_DIM_IDX = 4, UNITS = 5, PASS = 6, L_RATE = 7, MOM = 8;
     final int TRAIN_PROB = 9, PATTERN_NUM = 10, ITER_NUM = 11, AAM_TYPE = 12;

     Option[] opts = userOptions[NACS][NACS_AMN][amnIdx][0][0][0];
     global.setAmnType( amnIdx, opts[AMN_TYPE].getUserChoice() );
     // input dimension values.
     int type = opts[IN_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     int dimNum = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     short[] dimIdxs = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] dimVals = new short[ dimNum ];
     short[][] featInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          dimVals[i] = (short)global.getFeatureLength(type, dimIdxs[i]);
          featInfo[i][0] = (short)type;
          featInfo[i][1] = dimIdxs[i];
     }
     global.setAmnInputDimVals( amnIdx, dimVals );
     global.setAmnInputFeatureInfo( amnIdx, featInfo );
     // output dimension values.
     type = opts[OUT_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     dimNum = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     short[] oDimIdxs = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] oDimVals = new short[ dimNum ];
     short[][] oFeatInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          oDimVals[i] = (short)global.getFeatureLength(type, oDimIdxs[i]);
          oFeatInfo[i][0] = (short)type;
          oFeatInfo[i][1] = oDimIdxs[i];
     }
     global.setAmnOutputDimVals( amnIdx, oDimVals );
     global.setAmnOutputFeatureInfo( amnIdx, oFeatInfo );
     // network unit numbers.
     global.setAmnHiddenNum(amnIdx, opts[UNITS].getOptionItem(0).getParameter(1).getIntValue());
     global.setAmnMultiPassOn( amnIdx, opts[PASS].getUserChoice()==ON );
     if( global.isAmnMultiPassOn(amnIdx) )
         global.setAmnIterNum( amnIdx, opts[PASS].getOptionItem(0).getParameter(0).getIntValue());
     else
         global.setAmnIterNum( amnIdx, 1 );
     // learning rate and momentum settings.
     global.setAmnBPLearningRate( amnIdx, opts[L_RATE].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setAmnBPMomentum( amnIdx,
            opts[MOM].getOptionItem(0).getParameter(0).getDoubleValue() );
     // settings for AAM or HAM.
     global.setAamTrainProb(opts[TRAIN_PROB].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setAamTrainPatternNum(opts[PATTERN_NUM].getOptionItem(0).getParameter(0).getIntValue());
     global.setAamTrainIterNum(opts[ITER_NUM].getOptionItem(0).getParameter(0).getIntValue());
     if( global.getAmnType(amnIdx)==global.AAM )
         global.setAamTrainPatternType(opts[AAM_TYPE].getUserChoice());
  }

  private void initGlobalAem()
  {
     final int AEM_BOUND = 0, AEM_EM_PROB = 1, AEM_EM_ITEM = 2, AEM_EM_LR = 3;
     final int AEM_EM_MOM = 4, AEM_NS_NUM = 5, AEM_ACS_PROB = 6, AEM_ACS_ITEM = 7;
     final int AEM_ACS_ITER = 8, AEM_ACS_TEMP = 9;

     Option[] opts = userOptions[NACS][NACS_AEM][0][0][0][0];
     global.setAemStateNumBound(opts[AEM_BOUND].getOptionItem(0).getParameter(0).getIntValue());
     global.setAemTrainedByEmProb(opts[AEM_EM_PROB].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setAemTrainedByEmItemNum(opts[AEM_EM_ITEM].getOptionItem(0).getParameter(0).getIntValue());
     global.setAemTrainedByEmBPLearningRate(opts[AEM_EM_LR].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setAemTrainedByEmBPMomentum(opts[AEM_EM_MOM].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setAemPotentialNextStateNum(opts[AEM_NS_NUM].getOptionItem(0).getParameter(0).getIntValue());
     global.setAemTrainAcsProb(opts[AEM_ACS_PROB].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setAemTrainAcsSampleNum(opts[AEM_ACS_ITEM].getOptionItem(0).getParameter(0).getIntValue());
     global.setAemTrainAcsIterNum(opts[AEM_ACS_ITER].getOptionItem(0).getParameter(0).getIntValue());
     global.setAemTrainAcsOutputTemp(opts[AEM_ACS_TEMP].getOptionItem(0).getParameter(0).getDoubleValue());
  }

  private void initGlobalNacsCoordinate()
  {
     final int COR = 0, GKS = 1, ITER = 2;
     Option[] opts = userOptions[NACS][NACS_COR][0][0][0][0];
     global.setCorAcsNacsType( opts[COR].getUserChoice() );
     global.setGksReasoningMethod( opts[GKS].getUserChoice() );
     global.setGksReasonIterNum( opts[ITER].getOptionItem(0).getParameter(0).getIntValue() );
  }

  /************ init Global Supervisory Subsystem *************/
  private void initGlobalSuperComp()
  {
    final int MS = 0, MCS = 1;
    Option[] opts = userOptions[SUPER][SUPER_COMP][0][0][0][0];
    global.setMsOn( opts[MS].getUserChoice() == ON );
    global.setMcsOn( opts[MCS].getUserChoice() == ON );
  }

  private void initGlobalMS()
  {
    final int DRIVE = 0, DRIVE_REP = 1, DRIVE_NET = 2;
    Option[] opts = userOptions[SUPER][SUPER_MS][0][0][0][0];
    //global.setDrives( String value );
    //global.setDriveReps( String value );
  }

  private void initGlobalMCS()
  {
    final int GS_DRIVE = 0, REIN = 1;
    final int ACS_IN_DIM = 2, NACS_IN_DIM = 3, ACS_OUT_DIM = 4, NACS_OUT_DIM = 5;
    final int ACS_IN_VAL = 6, NACS_IN_VAL = 7, ACS_OUT_VAL = 8, NACS_OUT_VAL = 9;
    final int ACS_LEARN = 10, NACS_LEARN = 11, ACS_REASON = 12, NACS_REASON = 13;
    final int ACS_LEVEL = 14, NACS_LEVEL = 15, ACS_CROSS = 16, GS_TIME = 17;
    final int ACS_PERFORM = 18, NACS_PERFORM = 19, ACS_CONC_NUM = 20, NACS_CONC_NUM = 21;
    final int ACS_GAUGE = 22, NACS_GAUGE = 23, ACS_EPI_NUM = 24, NACS_EPI_NUM = 25;
    final int EPI_DEF = 26, ACS_INTEG = 27, NACS_INTEG = 28;
    Option[] opts = userOptions[SUPER][SUPER_MCS][0][0][0][0];
    //global.setModuleGS( String value );
    //global.setModuleRein( String value );
    //global.setModuleAcsInputDims( String value );
    //global.setModuleNacsInputDims( String value );
    //global.setModuleAcsOutputDims( String value );
    //global.setModuleNacsOutputDims( String value );
    //global.setModuleAcsInputValues( String value );
    //global.setModuleNacsInputValues( String value );
    //global.setModuleAcsOutputValues( String value );
    //global.setModuleNacsOutputValues( String value );
    //global.setModuleAcsLearningMethod( String value );
    //global.setModuleNacsLearningMethod( String value );
    //global.setModuleAcsReasoningMethod( String value );
    //global.setModuleNacsReasoningMethod( String value );
    //global.setModuleAcsLevelSelection( String value );
    //global.setModuleNacsLevelSelection( String value );
    //global.setAcsRegulationCL( String value );
    //global.setTimingGS( String value );
    //global.setAcsPerformMeasure( String value );
    //global.setNacsPerformMeasure( String value );
    //global.setAcsGaugeLeaningMeasure( String value );
    //global.setNacsGaugeLearningMeasure( String value );
    global.setMonitorAcsTopConcNum(opts[ACS_CONC_NUM].getOptionItem(0).getParameter(TL).getIntValue());
    global.setMonitorAcsBottomConcNum(opts[ACS_CONC_NUM].getOptionItem(0).getParameter(BL).getIntValue());
    global.setMonitorAcsTopEpisodeNum(opts[ACS_EPI_NUM].getOptionItem(0).getParameter(TL).getIntValue());
    global.setMonitorAcsBottomEpisodeNum(opts[ACS_EPI_NUM].getOptionItem(0).getParameter(BL).getIntValue());
    global.setMonitorNacsTopConcNum(opts[NACS_CONC_NUM].getOptionItem(0).getParameter(TL).getIntValue());
    global.setMonitorNacsBottomConcNum(opts[NACS_CONC_NUM].getOptionItem(0).getParameter(BL).getIntValue());
    global.setMonitorNacsTopEpisodeNum(opts[NACS_EPI_NUM].getOptionItem(0).getParameter(TL).getIntValue());
    global.setMonitorNacsBottomEpisodeNum(opts[NACS_EPI_NUM].getOptionItem(0).getParameter(BL).getIntValue());
    //global.setEpisodeMeasure( String value );
    //global.setAcsParamCLMcs( String value );
    //global.setNacsParamCLMcs( String value );
  }

  /**************** init Global Response Time ******************/
  private void initGlobalRT()
  {
     final int OVER = 0, OVER_BL = 1, OVER_TL = 2, PT_BL = 3, DT_BL = 4, AT_BL = 5;
     final int PT_TL = 6, DT_TL = 7, AT_TL = 8, ASSOC = 9, CHUNK = 10, AMN_PASS = 11;
     Option[] opts = userOptions[RT][0][0][0][0][0];
     //global.setOverallFormula( String value );
     //global.setBLFormula( String value );
     //global.setTLFormula( String value );
     global.setPT_BL(opts[PT_BL].getOptionItem(0).getParameter(0).getIntValue());
     global.setDT_BL(opts[DT_BL].getOptionItem(0).getParameter(0).getIntValue());
     global.setAT_BL(opts[AT_BL].getOptionItem(0).getParameter(0).getIntValue());
     global.setPT_TL(opts[PT_TL].getOptionItem(0).getParameter(0).getIntValue());
     global.setDT_TL_actionTime(opts[DT_TL].getOptionItem(0).getParameter(0).getIntValue());
     global.setDT_TL_t0(opts[DT_TL].getOptionItem(0).getParameter(1).getDoubleValue());
     global.setDT_TL_t1(opts[DT_TL].getOptionItem(0).getParameter(2).getDoubleValue());
     global.setAT_TL(opts[AT_TL].getOptionItem(0).getParameter(0).getIntValue());
     //global.setAssoAppTimeFormula( String value );
     global.setAssocAppTime_t4(opts[ASSOC].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setAssocAppTime_t5(opts[ASSOC].getOptionItem(0).getParameter(1).getDoubleValue());
     //global.setChunkRetTimeFormula( String value );
     global.setChunkRetTime_t2(opts[CHUNK].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setChunkRetTime_t3(opts[CHUNK].getOptionItem(0).getParameter(1).getDoubleValue());
     global.setAmnOnePassTime(opts[AMN_PASS].getOptionItem(0).getParameter(0).getIntValue());
  }

  public void initGlobalTaskSpec()
  {
     final int RECORD = 0;
     Option[] opts = userOptions[TS][0][0][0][0][0];
     boolean[] outputFormat = new boolean[ opts[RECORD].getOptionItem(0).getCount()];
     for( int i = 0; i < outputFormat.length; i++ )
          outputFormat[i] = opts[RECORD].getOptionItem(0).getParameter(0).getBoolValue();
     global.setOutputFormat( outputFormat );
  }

  /****************** init Global display **********************/
  private void initGlobalDisplay()
  {
     final int DISP = 0, FREQ = 1;
     Option[] opts = userOptions[DISPLAY][0][0][0][0][0];
     global.setRuleDisplayMode( opts[DISP].getUserChoice() );
     switch( opts[FREQ].getUserChoice() ){
       case 0:
             global.setRuleDisplayFreq(Integer.MAX_VALUE);
             break;
       case 1:
             global.setRuleDisplayFreq(1);
             break;
       case 2:
             global.setRuleDisplayFreq(opts[FREQ].getOptionItem(2).getParameter(0).getIntValue());
             break;
     }
  }

  /************* init Global ACS knowledge types **************/
  // 14 userOptions.
  private void initGlobalAcsNetBasics( int netType, int nIdx )
  {
     final int IDN_ON = 0, RER_ON = 1, IRL_ON = 2, FR_ON = 3;
     final int EX_INSTR = 4, IM_LEARN = 5, PLAN = 6, MCS = 7;
     final int DETER = 8, COMB = 9, STOCH = 10, BU = 11, TG = 12;
     final int ELIG = 13;
     Option[] opts = userOptions[ACS][ACS_NET][netType][nIdx][COMP][0];
     // convert nIdx.
     int netIdx = this.convertNetIdx( netType, nIdx );
     global.setRerOn( netIdx, opts[RER_ON].getUserChoice()==ON );
     global.setIrlOn( netIdx, opts[IRL_ON].getUserChoice()==ON );
     if( global.isIrlOn( netIdx ) )
         global.setIrlSetNum( netIdx, opts[IRL_ON].getOptionItem(0).getParameter(0).getIntValue());
     global.setFrOn( netIdx, opts[FR_ON].getUserChoice()==ON );
     if( global.isFrOn( netIdx ) )
         global.setFixRuleNum( netIdx, opts[FR_ON].getOptionItem(0).getParameter(0).getIntValue());
     global.setExtInstructOn( netIdx, opts[EX_INSTR].getUserChoice()==ON );
     global.setILOn( netIdx, opts[IM_LEARN].getUserChoice()==ON );
     global.setCombineDeterMode( opts[DETER].getUserChoice() );
     int combMethod1 = opts[COMB].getUserChoice();
     global.setAcsCrossCombineMode( netIdx, 0, combMethod1 );
     int combMethod2 = opts[COMB + 1 + combMethod1].getUserChoice();
     global.setAcsCrossCombineMode( netIdx, 1, combMethod2 );
     int paraNum = opts[COMB + 1 + combMethod1].getOptionItem(combMethod2).getParameters().length;
     if( combMethod1 != Global.STOCH_COMB_MODE )
         paraNum--;
     if( combMethod2 == global.FIX_COMB_MODE ){
         double[] params = new double[ paraNum ];
         for( int i = 0; i < paraNum; i++ )
              params[i] = opts[COMB + 1 + combMethod1].getOptionItem(combMethod2).getParameter(i).getDoubleValue();
         global.setAcsCrossCombineParas( netIdx, params );
       }
     if( combMethod2 == global.VAR_COMB_MODE ){
         double[] params = new double[ paraNum-2 ];
         for( int i = 0; i < paraNum-2; i++ )
              params[i] = opts[COMB + 1 + combMethod1].getOptionItem(combMethod2).getParameter(i).getDoubleValue();
         global.setAcsCrossCombineParas( netIdx, params );
         double[] aboves = new double[ Global.ACS_KNOW_TYPE_NUM ];
         for( int i = 0; i < aboves.length; i++ )
              aboves[i] = opts[COMB+1+combMethod1].getOptionItem(combMethod2).getParameter(paraNum-2).getDoubleValue();
         global.setAcsCrossCombineVarParaAboves( netIdx, aboves );
         double[] unders = new double[ Global.ACS_KNOW_TYPE_NUM ];
         for( int i = 0; i < unders.length; i++ )
              unders[i] = opts[COMB+1+combMethod1].getOptionItem(combMethod2).getParameter(paraNum-1).getDoubleValue();
         global.setAcsCrossCombineVarParaUnders( netIdx, unders );
     }
     if( combMethod2 == global.CT_COMB_MODE ){
     }
     if( combMethod1 != Global.STOCH_COMB_MODE )
         global.setOverallActionSelectionTemp( netIdx,
              opts[COMB + 1 + combMethod1].getOptionItem(combMethod2).getParameter(paraNum).getDoubleValue() );
  }

  // 13 userOptions.
  private void initGlobalIdn( int netType, int nIdx )
  {
     final int IN_DIM_TYPE = 0, OUT_DIM_TYPE = 1, IN_DIM_IDX = 2, OUT_DIM_IDX = 3;
     final int UNITS = 4, LEARN = 5, L_RATE = 6, MOM = 7, Q_RATE = 8;
     final int TEMP = 9, REIN_EACH = 10, MCS = 11;
     //final int ACT_NUM = 12, ACT_REP = 13, RWD_NUM = 14, RWD_DIM = 15, RWD = 16;
     Option[] opts = userOptions[ACS][ACS_NET][netType][nIdx][IDN][0];
     // convert nIdx.
     int netIdx = this.convertNetIdx( netType, nIdx );
     // input dimension values.
     int type = opts[IN_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     int dimNum = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     short[] dimIdxs = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] dimVals = new short[ dimNum ];
     short[][] featInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          dimVals[i] = (short)global.getFeatureLength(type, dimIdxs[i]);
          featInfo[i][0] = (short)type;
          featInfo[i][1] = dimIdxs[i];
     }
     global.setIdnInputDimVals( netIdx, dimVals );
     global.setIdnInputFeatureInfo( netIdx, featInfo );

     //System.out.println("in transfer, global feat type = " + global.getIdnInputFeatureInfo(netIdx)[0][0] );
     //System.out.println("in transfer, global feat idx = " + global.getIdnInputFeatureInfo(netIdx)[0][1] );

     // output dimension values.
     type = opts[OUT_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     dimNum = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     short[] oDimIdxs = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] oDimVals = new short[ dimNum ];
     short[][] oFeatInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          oDimVals[i] = (short)global.getFeatureLength(type, oDimIdxs[i]);
          oFeatInfo[i][0] = (short)type;
          oFeatInfo[i][1] = oDimIdxs[i];
     }
     global.setIdnOutputDimVals( netIdx, oDimVals );
     global.setIdnOutputFeatureInfo( netIdx, oFeatInfo );
     global.setIdnHiddenNum(netIdx, opts[UNITS].getOptionItem(0).getParameter(1).getIntValue());
     //global.setExIdnEligibleCondiitons( int netIdx, String value );
     global.setIdnLearningOption( netIdx, opts[LEARN].getUserChoice() );
     global.setIdnBPLearningRate( netIdx,
            opts[L_RATE].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setIdnBPMomentum( netIdx,
            opts[MOM].getOptionItem(0).getParameter(0).getDoubleValue() );
     global.setIdnQDiscountRate( netIdx,
            opts[Q_RATE].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setIdnActionSelectionTemp( netIdx,
            opts[TEMP].getOptionItem(0).getParameter(0).getDoubleValue());
     //global.setIdnRLFunction( int netIdx, String value );
     global.setIdnRLFuncByMCS( netIdx, opts[MCS].getUserChoice()==ON );
  }

  // 24 userOptions.
  private void initGlobalRer( int netType, int nIdx )
  {
     final int DENSITY = 16, EXT_PROB = 17, GS_MODE = 18, POS = 19;
     final int IG = 20, TH = 21, RANGE = 22, MERGE = 23;
     Option[] opts = userOptions[ACS][ACS_NET][netType][nIdx][RER][0];
     // convert nIdx.
     int netIdx = this.convertNetIdx( netType, nIdx );
     // init ACS rule common options.
     initAcsRules( netType, netIdx, RER, 0, opts );
     // init RER specific options.
     global.setRerDensity( netIdx, opts[DENSITY].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setRerExtractionProb( netIdx, opts[EXT_PROB].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setRerGenSpecMode( netIdx, opts[GS_MODE].getUserChoice());
     //global.setRerPosCriterion( netIdx, String value);
     //global.setRerIGMeasurement( netIdx, String value);
     global.setRerIGParaAbove( netIdx, opts[IG].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setRerIGParaUnder( netIdx, opts[IG].getOptionItem(0).getParameter(1).getDoubleValue());
     global.setRerPosThreshold( netIdx, opts[TH].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setRerGenThreshold( netIdx, opts[TH].getOptionItem(0).getParameter(1).getDoubleValue());
     global.setRerSpecThreshold( netIdx, opts[TH].getOptionItem(0).getParameter(2).getDoubleValue());
     global.setRerGenSpecValueRange( netIdx, opts[RANGE].getUserChoice() );
     global.setRuleMergeInterval( netIdx, opts[MERGE].getOptionItem(0).getParameter(0).getIntValue() );
  }

  // 25 userOptions
  private void initGlobalIrl( int netType, int nIdx, int setIdx, int setNum )
  {
     final int RULE_NUM = 16, RULES = 17, DENSITY = 18;
     final int POS = 19, IG = 20, TH = 21, RANGE = 22;
     Option[] opts = userOptions[ACS][ACS_NET][netType][nIdx][IRL][setIdx];
     // convert nIdx.
     int netIdx = this.convertNetIdx( netType, nIdx );
   // init ACS rule common options.
     initAcsRules( netType, netIdx, IRL, setIdx, opts );
     // init IRL specific options.
     global.setIrlRuleNum(netIdx,setIdx,opts[RULE_NUM].getOptionItem(0).getParameter(0).getIntValue());
     //global.setIrlRuleParameters( netIdx, setIdx, params[netIdx][setIdx] );
     global.setIrlDensity( netIdx, opts[DENSITY].getOptionItem(0).getParameter(0).getDoubleValue());
     //global.setIrlPosCriterion( netIdx, String value);
     //global.setIrlIGMeasurement( netIdx, String value);
     global.setIrlIGParaAbove( netIdx, opts[IG].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setIrlIGParaUnder( netIdx, opts[IG].getOptionItem(0).getParameter(1).getDoubleValue());
     // thresholeds
     global.setIrlPosThreshold( netIdx, opts[TH].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setIrlGenThreshold( netIdx, opts[TH].getOptionItem(0).getParameter(1).getDoubleValue());
     global.setIrlSpecThreshold( netIdx, opts[TH].getOptionItem(0).getParameter(2).getDoubleValue());
     global.setIrlDeleteThreshold( netIdx, opts[TH].getOptionItem(0).getParameter(3).getDoubleValue());
     global.setRerGenSpecValueRange( netIdx, opts[RANGE].getUserChoice() );
  }

  // 18 userOptions
  private void initGlobalFR( int netType, int nIdx, int setIdx, int setNum )
  {
     final int RULE_COND = 16, RULE_ACT = 17;
     Option[] opts = userOptions[ACS][ACS_NET][netType][nIdx][FR][setIdx];
     // convert nIdx.
     int netIdx = this.convertNetIdx( netType, nIdx );
     // init ACS rule common options.
     initAcsRules( netType, netIdx, FR, setIdx, opts );
     // init FR specific options.
     // global.setFixRuleConditions( netIdx, setIdx, conditions[netIdx][setIdx] );
     // global.setFixRuleAction( netIdx, setIdx, actions[netIdx][setIdx] );
  }

  // 16 OPTIONS.
  public void initAcsRules( int netType, int nIdx, int ruleType, int setIdx, Option[] opts )
  {
     final int IN_DIM_TYPE = 0, OUT_DIM_TYPE = 1, IN_DIM_IDX = 2, OUT_DIM_IDX = 3, TEMP = 4;
     final int REASON = 5, MCS = 6, UTL_ON = 7, SUP_ON = 8, PM_ON = 9, RBLA_ON = 10;
     final int CBLA_ON = 11, WEIGHT = 12, RBLA = 13, CBLA = 14, UTL = 15;
     // convert nIdx.
     int netIdx = this.convertNetIdx( netType, nIdx );
     // input dimension values.
     int type = opts[IN_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     int dimNum = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     int inputNum = 0;
     short[] dimIdxs = opts[IN_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] dimVals = new short[ dimNum ];
     short[][] featInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          dimVals[i] = (short)global.getFeatureLength(type, dimIdxs[i]);
          inputNum += dimVals[i];
          featInfo[i][0] = (short)type;
          featInfo[i][1] = dimIdxs[i];
     }
     global.setARInputDimVals( netIdx, ruleType, dimVals );
     global.setARInputFeatureInfo( netIdx, ruleType, featInfo );
     // output dimension values.
     type = opts[OUT_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue();
     dimNum = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getCount();
     int outputNum = 0;
     short[] oDimIdxs = opts[OUT_DIM_IDX].getOptionItem(0).getParameter(0).getIntValues();
     short[] oDimVals = new short[ dimNum ];
     short[][] oFeatInfo = new short[ dimNum ][2];
     for( int i = 0; i < dimNum; i++ ){
          oDimVals[i] = (short)global.getFeatureLength(type, oDimIdxs[i]);
          outputNum += oDimVals[i];
          oFeatInfo[i][0] = (short)type;
          oFeatInfo[i][1] = oDimIdxs[i];
     }
     global.setAROutputDimVals( netIdx, ruleType, oDimVals );
     global.setAROutputFeatureInfo( netIdx, ruleType, oFeatInfo );
     global.setARActionSelectionTemp( netIdx, ruleType, opts[TEMP].getOptionItem(0).getParameter(0).getDoubleValue());
     global.setARReasoningMethod( netIdx, ruleType, opts[REASON].getUserChoice() );
     global.setARReasoningByMCSOn( netIdx, ruleType, opts[MCS].getUserChoice()==ON );
     global.setRuleUtilityOn( netIdx, ruleType, setIdx, opts[UTL_ON].getUserChoice()==ON );
     global.setRuleSupportOn( netIdx, ruleType, setIdx, opts[SUP_ON].getUserChoice()==ON );
     global.setRulePartMatchOn( netIdx, ruleType, setIdx, opts[PM_ON].getUserChoice()==ON );
     global.setRuleBlaOn( netIdx, ruleType, setIdx, opts[RBLA_ON].getUserChoice()==ON );
     global.setActionChunkBlaOn( netIdx, ruleType, setIdx, opts[CBLA_ON].getUserChoice()==ON );
     global.setActionRuleWeightMode( netIdx, ruleType, setIdx, opts[WEIGHT].getUserChoice() );

     //if( ruleType == FR )
      //   System.out.println( "before bla" );

     // BLA settings.
     if( global.isRuleBlaOn( netIdx, ruleType, setIdx ) ){
         global.setActionRuleBlaOption( netIdx, ruleType, setIdx, opts[RBLA].getUserChoice());
         if( global.getActionRuleBlaOption( netIdx, ruleType, setIdx ) == global.CONSTANT_OPTION )
             global.setActionRuleBla( netIdx, ruleType, setIdx,
                opts[RBLA].getOptionItem(0).getParameter(0).getDoubleValue());
         else{
             double[] blaParams = new double[ opts[RBLA].getOptionItem(1).getParameters().length ];
             for( int j = 0; j < blaParams.length; j++ )
                  blaParams[j] = opts[RBLA].getOptionItem(1).getParameter(j).getDoubleValue();
             global.setActionRuleBlaParas( netIdx, ruleType, setIdx, blaParams );
         }
     }

     //if( ruleType == FR )
     //    System.out.println( "after RULE bla" );

     if( global.isActionChunkBlaOn( netIdx, ruleType, setIdx ) ){
         global.setAcsChunkBlaOption( netIdx, ruleType, setIdx,
                opts[CBLA].getUserChoice() );
         if( global.getAcsChunkBlaOption( netIdx, ruleType, setIdx ) == global.CONSTANT_OPTION )
             global.setAcsChunkBla( netIdx, ruleType, setIdx,
                opts[CBLA].getOptionItem(0).getParameter(0).getDoubleValue());
         else{
             double[] blaParams = new double[ opts[CBLA].getOptionItem(1).getParameters().length ];
             for( int j = 0; j < blaParams.length; j++ )
                  blaParams[j] = opts[CBLA].getOptionItem(1).getParameter(j).getDoubleValue();
             global.setAcsChunkBlaParas( netIdx, ruleType, setIdx, blaParams );
         }
     }

     //if( ruleType == FR )
     //    System.out.println( "after CHUNK bla" );

     // utility settings.
     if( global.isRuleUtilityOn( netIdx, ruleType, setIdx ) ){
         int optIdx = opts[UTL].getUserChoice();
         global.setRuleUtilityOption( netIdx, ruleType, setIdx, optIdx );
         if( optIdx < 2 ){ // not the user defined
             double[] utlParams = new double[ opts[UTL].getOptionItem(optIdx).getParameters().length ];
             for( int j = 0; j < utlParams.length; j++ ){
                  utlParams[j] = opts[UTL].getOptionItem(optIdx).getParameter(j).getDoubleValue();
                  //System.out.println( "param value = " + utlParams[j] );
             }
             global.setRuleUtilityParas( netIdx, ruleType, setIdx, utlParams );
         }
     }
  }

  private void copyFileStructure( File from, File to )
  {
     if( from.isDirectory() ){
         File[] files = from.listFiles();
         for( int i = 0; i < files.length; i++ ){
              try{
                   File subDir = new File( to, files[i].getName() );
                   boolean succFlag = false;
                   if( files[i].isDirectory() )
                       succFlag = subDir.mkdir();
                   if( files[i].isFile() )
                       succFlag = subDir.createNewFile();
                   //System.out.println( subDir.getAbsolutePath() + ": " + succFlag );
                   copyFileStructure( files[i], subDir );
              }
              catch ( IOException e ) {
                 JOptionPane.showMessageDialog( null, "File Operation Error in creating!",
                      "Invalid File Name", JOptionPane.ERROR_MESSAGE );
              }
        }
     }
     if( from.isFile() ){
         try {
              RandomAccessFile fromFile = new RandomAccessFile( from, "rw" );
              RandomAccessFile toFile = new RandomAccessFile( to, "rw" );
              fromFile.seek( 0 );
              toFile.seek( 0 );
              while( fromFile.getFilePointer() < fromFile.length() )
                     toFile.writeByte( fromFile.readByte() );
              fromFile.close();
              toFile.close();
         }
         catch ( IOException e ) {
                 JOptionPane.showMessageDialog( null, "File Operation Error in copying!",
                      "Invalid File Name", JOptionPane.ERROR_MESSAGE );
         }
     }
  }

  // search a most suitable setting dir.
  private String searchFile( String subSysName )
  {
     String path = global.getOptionDir() + "\\" + global.getTaskName() + "\\" +
                   global.getOptionName() + "\\" + subSysName;
     File file = new File( path );
     if( file.exists() )
         return path + "\\";
     // search a most suitable setting file.
     String taskPath = global.getOptionDir() + "\\" + global.getTaskName();
     String taskSettingPath = taskPath + "\\" + global.getOptionName();
     String[] settingNames = searchCurrentSettings();
     boolean existFlag = false;
     for( int i = 0; i < settingNames.length; i++ ){
          String existSubsysSettingPath = taskPath + "\\" + settingNames[i] + "\\" + subSysName;
          File existSubsysSettingDir = new File( existSubsysSettingPath );
          if( existSubsysSettingDir.exists() ){
              path = existSubsysSettingPath;
              existFlag = true;
              break;
          }
     }
     if( !existFlag ){
         String defaultSubsysSettingPath = sysSettingPath + "\\" + subSysName;
         path = defaultSubsysSettingPath;
     }
     return path + "\\";
  }

  // search a most suitable setting dir.
  private String searchFile( String subSysName, String fileName )
  {
     String path = subsysPath;
     File file = new File( subsysPath + fileName );
     if( file.exists() )
         return path;
     // search a most suitable setting file.
     String taskPath = global.getOptionDir() + "\\" + global.getTaskName();
     String taskSettingPath = taskPath + "\\" + global.getOptionName();
     String[] settingNames = searchCurrentSettings();
     boolean existFlag = false;
     for( int i = 0; i < settingNames.length; i++ ){
          String existSubsysSettingPath = taskPath + "\\" + settingNames[i] + "\\" + subSysName;
          File existSubsysSettingDir = new File( existSubsysSettingPath );
          if( existSubsysSettingDir.exists() ){
              File existAemFile = new File( existSubsysSettingPath + "\\" + fileName );
              if( existAemFile.exists() ){
                  path = existSubsysSettingPath + "\\";
                  existFlag = true;
                  break;
              }
          }
     }
     if( !existFlag ){
         String defaultSubsysSettingPath = sysSettingPath + "\\" + subSysName + "\\";
         path = defaultSubsysSettingPath;
     }
     return path;
  }

  private int convertNetIdx( int netType, int nIdx )
  {
     // convert nIdx.
     int netIdx = 0;
     if( netType == this.EX_NET )
         netIdx = nIdx;
     if( netType == this.GS_NET )
         netIdx = global.getGsNetIdx();
     if( netType == this.WM_NET )
         netIdx = global.getWmNetIdx();
     return netIdx;
  }
}