package clarion.options.acs;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;
import clarion.options.acs.net.*;

public class GuiACS extends GuiTemplate{

  String buttonTexts[] = {
        "Components",
        "IDNs and Corresponding Rule Groups",
        "Working Memory",
        "Goal Structure"
  };
  SelectionTemplate subSelections[];
  GuiTemplate networks;

  public GuiACS( int num )
  {
     super( num, "OPTIONS OF THE ACTION-CENTERED SYSTEM");
     setButtonTexts( buttonTexts );
     subSelections = new SelectionTemplate[4];
     subSelections[0] = new SelectionAcsComp( this, 490, 220, transfer );
     if( transfer.getWmOption() ){
         optButtons[2].setEnabled( true );
         subSelections[1] = new SelectionAcsWM( this, 600, 400, transfer );
     }
     else
         optButtons[2].setEnabled( false );
     if( transfer.getGsOption() != Global.GS_NON ){
         optButtons[3].setEnabled( true );
         subSelections[2] = new SelectionAcsGS( this, 600, 380, transfer );
     }
     else
         optButtons[3].setEnabled( false );
     networks = new GuiAcsNets( 4 );
     networks.init( getFrame() );
  }

  public void returnFrom()
  {
     if( activeButtonIdx == 0 ){
         if( transfer.getWmOption() ){
             optButtons[2].setEnabled( true );
             subSelections[1] = new SelectionAcsWM( this, 600, 400, transfer );
         }
         else
             optButtons[2].setEnabled( false );
         if( transfer.getGsOption() != Global.GS_NON ){
             optButtons[3].setEnabled( true );
             subSelections[2] = new SelectionAcsGS( this, 600, 380, transfer );
         }
         else
             optButtons[3].setEnabled( false );
         ((GuiAcsNets)networks).updateGui();
     }
  }

  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < OPT_NUM; i++ ){
          final int idx = i;
          optButtons[ idx ].addActionListener(  new  ActionListener(){
                            public void actionPerformed( ActionEvent e ){
                               activeButtonIdx = idx;
                               switch( idx ){
                                 case 0:
                                      subSelections[idx].setEnabled( true );
                                      subSelections[idx].setVisible( true );
                                      break;
                                 case 1:
                                      networks.setEnabled(true);
                                      networks.setVisible(true);
                                      break;
                                 case 2: case 3: case 4:
                                      subSelections[idx-1].setEnabled( true );
                                      subSelections[idx-1].setVisible( true );
                                      break;
                              }
                              setEnabled( false );
                            }
                    } );
     }
  }
}