package clarion.options.acs;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionAcsComp extends SelectionTemplate{
  final int GS = 0, WM = 1, EX_NET_NUM = 2, GS_IDN = 3, WM_IDN = 4;
  final int ON = 0, OFF = 1, NEITHER = 2;
  int exNetNum;

  JLabel capLabel = new JLabel();
  JPanel panel = new JPanel();
  // gs
  JLabel gsLabel = new JLabel();
  JRadioButton[]  gsButtons = new JRadioButton[ 3 ]; {
     for( int i = 0; i < 3; i++ )
          gsButtons[i] = new JRadioButton();
  }
  // wm
  JLabel wmLabel = new JLabel();
  JRadioButton[]  wmButtons = new JRadioButton[ 2 ]; {
     for( int i = 0; i < 2; i++ )
          wmButtons[i] = new JRadioButton();
  }
  // external net number.
  JLabel exNumLabel = new JLabel();
  JTextField exNumField = new JTextField();
  // gs IDN
  JLabel gsIdnLabel = new JLabel();
  JRadioButton[]  gsIdnButtons = new JRadioButton[ 2 ]; {
     for( int i = 0; i < 2; i++ )
          gsIdnButtons[i] = new JRadioButton();
  }
  // wm IDN
  JLabel wmIdnLabel = new JLabel();
  JRadioButton[]  wmIdnButtons = new JRadioButton[ 2 ]; {
     for( int i = 0; i < 2; i++ )
          wmIdnButtons[i] = new JRadioButton();
  }
  // return button
  JButton returnButton = new JButton();

  public SelectionAcsComp( JFrame superFrame, int width, int height, SettingTransfer transfer )
  {
    super( superFrame, width, height, transfer );
    initGui();
  }

  public void initGui()
  {
    options = transfer.getOptions( Global.ACS, Global.ACS_COMP, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout( null );
    // caption.
    initLabel( capLabel, "OPTIONS OF ACS COMPONENTS", new Font("Dialog",1,14),
               SwingConstants.CENTER, new Rectangle(40, 0, 350, 26) );
    initPanel( panel, BORDER, null, new Rectangle(10, 32, 460, 120) );
    // GS option.
    String[] gsTexts = { "goal stack", "goal list", "neither" };
    Rectangle[] gsRects = { new Rectangle(100, 8, 80, 17),
                new Rectangle(188, 8, 80, 17), new Rectangle(276, 8, 80, 17)};
    initButtonBlock( panel, gsLabel, "goal structure", new Rectangle(4, 8, 90, 17),
                    gsButtons, gsTexts, gsRects, options[GS], NEITHER, gsIdnButtons );
    // WM option.
    Rectangle[] wmRects = { new Rectangle(120, 28, 50, 17),new Rectangle(180, 28, 50, 17)};
    initButtonBlock( panel, wmLabel, "working memory", new Rectangle(4, 28, 100, 17),
                     wmButtons, onOffTexts, wmRects, options[WM], OFF, wmIdnButtons );
    // external network number.
    int maxExNetNum = Global.MAX_EX_NET_NUM;
    initLabel( exNumLabel, "number of external IDNs and corresponding rule groups(1 to " +
               String.valueOf(maxExNetNum) + ")",  new Rectangle(4, 48, 360, 17) );
    initField( exNumField, String.valueOf(options[EX_NET_NUM].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(370, 48, 24, 17), 3, options[EX_NET_NUM], 0, 0 );
    // GS IDN option.
    Rectangle[] gsIdnRects = { new Rectangle(280, 68, 50, 17), new Rectangle(330, 68, 50, 17)};
    initButtonBlock( panel, gsIdnLabel, "goal action IDN and corresponding rule group",
         new Rectangle(4, 68, 270, 17), gsIdnButtons, onOffTexts, gsIdnRects, options[GS_IDN] );
    // GS IDN option.
    Rectangle[] wmIdnRects = { new Rectangle(350, 88, 50, 17),new Rectangle(400, 88, 50, 17)};
    initButtonBlock( panel, wmIdnLabel, "working memory action IDN and corresponding rule group",
         new Rectangle(4, 88, 340, 17),  wmIdnButtons, onOffTexts, wmIdnRects, options[WM_IDN] );
    // return button.
    initReturnButton( returnButton, "RETURN", new Rectangle(260, 160, 88, 28) );
    panel.add(exNumLabel, null);
    panel.add(exNumField, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(panel, null);
    this.getContentPane().add(returnButton, null);
  }
}