package clarion.options.acs.net;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;

public class GuiAcsExNets extends GuiTemplate{

  String buttonTexts[];
  GuiTemplate[] networks;

  public GuiAcsExNets( int netNum )
  {
     super( Global.MAX_EX_NET_NUM, "OPTIONS OF ACS EXTERNAL IDNS AND CORRESPONDING RULE GROUPS" );
     buttonTexts = new String[ OPT_NUM ];
     for( int i = 0; i < OPT_NUM; i++ )
          buttonTexts[i] = "IDN And Corresponding Rule Group - " + String.valueOf( i + 1 );
     setButtonTexts( buttonTexts );
     for( int i = netNum; i < Global.MAX_EX_NET_NUM; i++ ){
          optButtons[i].setEnabled( false );
          optButtons[i].setVisible( false );
     }
     networks = new GuiTemplate[ Global.MAX_EX_NET_NUM ];
     for( int i = 0; i < OPT_NUM; i++ ){
          networks[i] = new GuiAcsNet( Global.EX_NET, i );
          networks[i].init( getFrame() );
     }
  }

  // only update the GUI components of this frame resulting from upper level.
  public void updateGui()
  {
     int acsNetNum = transfer.getAcsExNetNum();
     if( OPT_NUM >= acsNetNum ){
         for( int i = 0; i < acsNetNum; i++ ){
              optButtons[i].setEnabled( true );
              optButtons[i].setVisible( true );
         }
         for( int i = acsNetNum; i < OPT_NUM; i++ ){
              optButtons[i].setEnabled( false );
              optButtons[i].setVisible( false );
         }
         OPT_NUM = acsNetNum;
     }
     else if( OPT_NUM < acsNetNum ){
              OPT_NUM = Math.min( Global.MAX_EX_NET_NUM, acsNetNum );
              for( int i = 0; i < OPT_NUM; i++ ){
                   optButtons[i].setEnabled( true );
                   optButtons[i].setVisible( true );
              }
              for( int i = OPT_NUM; i < Global.MAX_EX_NET_NUM; i++ ){
                   optButtons[i].setEnabled( false );
                   optButtons[i].setVisible( false );
              }
          }
  }

  // only update the GUI components of the sub frame resulting from upper level.
  public void update()
  {
      for( int i = 0; i < OPT_NUM; i++ )
           if( optButtons[i].isEnabled() )
               ((GuiAcsNet)networks[i]).update();
  }

  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < OPT_NUM; i++ ){
          final int idx = i;
          optButtons[ idx ].addActionListener(  new  ActionListener(){
                            public void actionPerformed( ActionEvent e ){
                               activeButtonIdx = idx;
                               networks[idx].setEnabled( true );
                               networks[idx].setVisible( true );
                               setEnabled( false );
                            }
                    } );
     }
  }
}