package clarion.options.acs.net;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;

public class GuiAcsNet extends GuiTemplate{

  final int BL = 0, RER = 1, IRL = 2, FR = 3;
  String buttonTexts[] = { "BASICS", "IDN", "RER", "IRL", "FIXED RULES" };
  SelectionTemplate basics;
  SelectionTemplate netComps[][];
  int netType, netIdx;

  public GuiAcsNet( int netType, int netIdx )
  {
     super( 5, "OPTIONS OF AN IDN AND CORRESPONDING RULE GROUP" );
     setButtonTexts( buttonTexts );
     this.netType = netType;
     this.netIdx = netIdx;
     basics = new SelectionAcsNetBasic(  this, 880, 620, netType, netIdx, transfer );
     // initialize component GUI.
     netComps = new SelectionTemplate[ OPT_NUM-1 ][];
     netComps[BL] = new SelectionTemplate[ Global.MAX_RULE_NUMS[BL] ];
     if( !transfer.isAcsCompOn( netType, netIdx, BL ) )
         optButtons[BL+1].setEnabled( false );
     else{
         netComps[BL][0] = new SelectionAcsIdn( this, 690, 400, netType, netIdx, transfer );
     }
     netComps[RER] = new SelectionTemplate[ Global.MAX_RULE_NUMS[RER] ];
     if( !transfer.isAcsCompOn( netType, netIdx, RER ) )
         optButtons[RER+1].setEnabled( false );
     else{
         netComps[RER][0] = new SelectionAcsRer( this, 1020, 800, netType, netIdx, 0, transfer );
     }
     netComps[IRL] = new SelectionTemplate[ Global.MAX_RULE_NUMS[IRL] ];
     if( !transfer.isAcsCompOn( netType, netIdx, IRL ) )
         optButtons[IRL+1].setEnabled( false );
     else{
         int irlSetNum = transfer.getAcsCompFileNum( netType, netIdx, IRL );
         for( int i = 0; i < irlSetNum; i++ )
              netComps[IRL][i] = new SelectionAcsIrl( this, 1020, 800, netType, netIdx, i, transfer );
     }
     netComps[FR] = new SelectionTemplate[ Global.MAX_RULE_NUMS[FR] ];
     if( !transfer.isAcsCompOn( netType, netIdx, FR ) )
         optButtons[FR+1].setEnabled( false );
     else{
         int frRuleNum = transfer.getAcsCompFileNum( netType, netIdx, FR );
         for( int i = 0; i < frRuleNum; i++ )
              netComps[FR][i] = new SelectionAcsFR(  this, 980, 600, netType, netIdx, i, transfer );
     }
  }

  // resulting from lower level.
  public void returnFrom( int idx, int command )
  {
     switch( activeButtonIdx ){
      case 0:
           setEnabled( true );
           setVisible( true );
           for( int i = 0; i < 4; i++ )
              if( transfer.isAcsCompOn( netType, netIdx, i ) ){
                  optButtons[i+1].setEnabled( true );
                  int setNum = transfer.getAcsCompFileNum( netType, netIdx, i );
                  for( int j = 0; j < setNum; j++ ){
                      if( netComps[i][j] == null )
                          switch(i){
                           case IRL:
                                netComps[i][j] = new SelectionAcsIrl( this, 1020, 800, netType, netIdx,
                                                     j, transfer );
                                break;
                           case FR:
                                netComps[i][j] = new SelectionAcsFR(  this, 980, 600, netType, netIdx,
                                                     j, transfer );
                                break;
                         }
                      netComps[i][j].update();
                  }
              }
              else
                  optButtons[i+1].setEnabled( false );
      case 1:
      case 2:
           setEnabled( true );
           setVisible( true );
           break;
      default:
           switch( command ){
           case 0:  // previous.
                netComps[activeButtonIdx-1][idx-1].setEnabled( true );
                netComps[activeButtonIdx-1][idx-1].setVisible( true );
                break;
           case 1: // next.
                netComps[activeButtonIdx-1][idx+1].setEnabled( true );
                netComps[activeButtonIdx-1][idx+1].setVisible( true );
                break;
           case 2: // return to top.
                setEnabled( true );
                setVisible( true );
                break;
           }
           break;
     }
  }

  // only update the GUI components of the sub frame resulting from upper level.
  public void update()
  {
     basics.update();
     netComps[BL][0].update();
  }

  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < OPT_NUM; i++ ){
          final int idx = i;
          optButtons[ idx ].addActionListener(  new  ActionListener(){
                            public void actionPerformed( ActionEvent e ){
                               activeButtonIdx = idx;
                               if( idx > 0 ){
                                   netComps[idx-1][0].setEnabled( true );
                                   netComps[idx-1][0].setVisible( true );
                               }
                               else{
                                   basics.setEnabled( true );
                                   basics.setVisible( true );
                               }
                               setEnabled( false );
                            }
                    } );
     }
  }
}