package clarion.options.acs.net;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;

public class GuiAcsNets extends GuiTemplate{

  String buttonTexts[] = {
      "External IDNs And Corresponding Rule Groups",
      "Working Memory IDN And Corresponding Rule Group",
      "Goal Structure IDN And Corresponding Rule Group",
      "Options Relavant to All"
  };
  GuiTemplate[] networks;
  SelectionTemplate subSelection;

  public GuiAcsNets( int netTypeNum )
  {
     super( netTypeNum, "OPTIONS OF THE ACS NETWROKS" );
     setButtonTexts( buttonTexts );
     optButtons[Global.WM_NET].setEnabled( transfer.getWmOption() && transfer.isWmIdnOn() );
     optButtons[Global.GS_NET].setEnabled( transfer.getGsOption()!= Global.GS_NON && transfer.isGsIdnOn() );
     networks = new GuiTemplate[3];
     for( int i = 0; i < 3; i++ ){
          if( i == Global.EX_NET )
              networks[i] = new GuiAcsExNets( transfer.getAcsExNetNum() );
          else
              networks[i] = new GuiAcsNet( i, 0 );
          networks[i].init( getFrame() );
     }
     // relevant to all nets.
     optButtons[3].setEnabled( true );
     subSelection = new SelectionAcsCor( this, 760, 330, transfer );
  }

  public void returnFrom()
  {
     if( activeButtonIdx == 3 )  // reinforcement functions.
         update();
  }

  // only update the GUI components of this frame resulting from upper level.
  public void updateGui()
  {
     optButtons[Global.WM_NET].setEnabled( transfer.getWmOption() && transfer.isWmIdnOn() );
     optButtons[Global.GS_NET].setEnabled( transfer.getGsOption()!= Global.GS_NON && transfer.isGsIdnOn());
     ((GuiAcsExNets)networks[Global.EX_NET]).updateGui();
  }

  // only update the GUI components of the sub frame.
  public void update()
  {
     for( int i = 0; i < OPT_NUM - 1; i++ )
          if( optButtons[i].isEnabled() ){
              if( i == Global.EX_NET )
                  ((GuiAcsExNets)networks[i]).update();
              else
                  ((GuiAcsNet)networks[i]).update();
          }
  }

  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < OPT_NUM; i++ ){
          final int idx = i;
          optButtons[ idx ].addActionListener(  new  ActionListener(){
                            public void actionPerformed( ActionEvent e ){
                               activeButtonIdx = idx;
                               if( idx < OPT_NUM-1 ){
                                   networks[idx].setEnabled( true );
                                   networks[idx].setVisible( true );
                                   setEnabled( false );
                               }
                               else{
                                   subSelection.setEnabled( true );
                                   subSelection.setVisible( true );
                                   setEnabled( false );
                               }
                            }
                    } );
     }
  }
}