package clarion.options.acs.net;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionAcsIdn extends SelectionTemplate {
 final int IN_DIM_TYPE = 0, OUT_DIM_TYPE = 1, IN_DIM_IDX = 2, OUT_DIM_IDX = 3;
 final int UNITS = 4, LEARN = 5, L_RATE = 6, MOM = 7, Q_RATE = 8;
 final int TEMP = 9, REIN_EACH = 10, MCS = 11;
 final int ACT_NUM = 12, ACT_REP = 13, RWD_NUM = 14, RWD_DIM = 15, RWD = 16;
 // from other levels
 final int COMB = 9, REIN = 1;
 int netType, netIdx;

 JLabel capLabel = new JLabel();
 // io
 JPanel ioPanel = new JPanel();
 JLabel ioLabel = new JLabel();
 JButton inputDimButton = new JButton();
 JButton outputDimButton = new JButton();
 JLabel hideUnitLabel = new JLabel();
 JTextField hideUnitField = new JTextField();
 // temperature
 boolean[] tempCompOns;
 JPanel tempPanel = new JPanel();
 JLabel blTempLabel = new JLabel();
 JLabel blTempLabel1 = new JLabel();
 JTextField blTempField = new JTextField();
 // learning option
 JPanel learningPanel = new JPanel();
 JLabel learningLabel = new JLabel();
 JRadioButton[] blLearnButtons = new JRadioButton[5]; {
    for( int i = 0; i < 5; i++ )
         blLearnButtons[i] = new JRadioButton();
 }
 // parameters for learning.
 JPanel paramPanel = new JPanel();
 JLabel paramLabel = new JLabel();
 JLabel lrLabel = new JLabel();
 JTextField lrField = new JTextField();
 JLabel momLabel = new JLabel();
 JTextField momField = new JTextField();
 JLabel qdLabel = new JLabel();
 JTextField qdField = new JTextField();
 // reinforcement function(each)
 boolean[] rfCompOns;
 JPanel rfPanel = new JPanel();
 JLabel reinLabel = new JLabel();
 JRadioButton[] rfButtons = new JRadioButton[2]; {
      rfButtons[0] = new JRadioButton();
      rfButtons[1] = new JRadioButton();
 }
 JButton rfEachSampleButton = new JButton();
 JButton rfEachLoadButton = new JButton();
 JLabel rfLoadFileLabel = new JLabel();
 JLabel rfLoadMethodLabel = new JLabel();
 JTextField[][] rfEachFields = new JTextField[2][];{
    rfEachFields[1] = new JTextField[2];
    rfEachFields[1][0] = new JTextField();
    rfEachFields[1][1] = new JTextField();
 }
 // return button
 JButton returnButton = new JButton();
 OptionDims[] optDims = new OptionDims[2];
 // relative options for dependency
 Option reinOption;
 Option combOption;

 public SelectionAcsIdn( JFrame superFrame, int width, int height, int netType, int netIdx,
                         SettingTransfer transfer )
 {
    super( superFrame, width, height, transfer );
    this.netType = netType;
    this.netIdx = netIdx;
    initGui();
 }

 public void initGui()
 {
    options = transfer.getOptions( Global.ACS, Global.ACS_NET, netType, netIdx, Global.ACS_IDN, 0 );
    int CENTER = SwingConstants.CENTER;
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption
    initLabel( capLabel, "OPTIONS FOR EACH IDN", new java.awt.Font("Dialog", 1, 16),
               CENTER, new Rectangle(175, 0, 277, 26) );
    // io
    initPanel( ioPanel, BORDER, null, new Rectangle(10, 26, 350, 90) );
    initLabel( ioLabel, "I/O dimensions and values", new Rectangle(4, 4, 156, 17) );
    initButton( inputDimButton, "dimensions in input", new Rectangle(4, 28, 160, 24));
    initButton( outputDimButton, "dimensions in output", new Rectangle(170, 28, 170, 24));
    optDims[0] = new OptionDims( this, 420, 780, "IDN INPUT SPECIFICATION", 30, transfer,
            options[IN_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue(), options[IN_DIM_IDX] );
    optDims[1] = new OptionDims( this, 420, 780, "IDN OUTPUT SPECIFICATION", 30, transfer,
            options[OUT_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue(), options[OUT_DIM_IDX] );
    initDimButton( this, inputDimButton, optDims[0] );
    initDimButton( this, outputDimButton, optDims[1] );
    initLabel( hideUnitLabel, "Number of hidden units", new Rectangle(4, 64, 134, 17));
/********* NEEDS BE UPDATE: three fields indicate input, hidden and ouput unit number ****************/
    initField( hideUnitField, String.valueOf( options[UNITS].getOptionItem(0).getParameter(1).getIntValue()),
               new Rectangle(144, 64, 32, 17), 4, options[UNITS], 0, 1 );
/*****************************************************************************************************/
    // temperature
    initPanel( tempPanel, BORDER, null, new Rectangle(10, 120, 350, 46 ) );
    initLabel( blTempLabel, "Boltzmann temperature for bottom-level action",
               new Rectangle(4, 4, 330, 17));
    initLabel( blTempLabel1, "selection", new Rectangle(4, 26, 60, 17));
    initField( blTempField, String.valueOf( options[TEMP].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(70, 26, 32, 17), 4, options[TEMP], 0, 0 );
    tempPanel.add(blTempLabel, null);
    tempPanel.add(blTempLabel1, null);
    tempPanel.add(blTempField, null);
    tempCompOns = new boolean[tempPanel.getComponentCount()];
    // Bottom level learning options
    initPanel( paramPanel, BORDER, null, new Rectangle(10, 170, 350, 130) );
    String[] blLearnTexts = {"Q-learning with backprogagation",
         "simplified Q-learning with backprogagation", "(supervised learning) backprogagation",
         "fixed", "the learning method to be determined by MCS on the fly" };
    Rectangle[] blLearnRects = { new Rectangle(4, 28, 205, 17), new Rectangle(4, 48, 260, 17),
                new Rectangle(4, 68, 241, 17),new Rectangle(4, 88, 200, 17),new Rectangle(4, 108, 340, 17)};
    initButtonBlock( paramPanel, paramLabel, "Bottom level learning options", new Rectangle(4, 8, 180, 17),
                     blLearnButtons, blLearnTexts, blLearnRects, options[LEARN] );
    // Parameters for BP and Q-learning
    initPanel( learningPanel, BORDER, null, new Rectangle(370, 26, 300, 90));
    initLabel( learningLabel,"Parameters for BP and Q-learning",new Rectangle(4, 8, 210, 17) );
    initLabel( lrLabel, "BP learning rate", new Rectangle(4, 28, 96, 17) );
    initField( lrField, String.valueOf( options[L_RATE].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(100, 28, 32, 17), 4, options[L_RATE], 0, 0 );
    initLabel( momLabel, "BP momentum", new Rectangle(4, 48, 96, 17));
    initField( momField, String.valueOf( options[MOM].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(100, 48, 32, 17), 4, options[MOM], 0, 0 );
    initLabel( qdLabel, "Q value discount rate", new Rectangle(4, 68, 128, 17));
    initField( qdField, String.valueOf( options[Q_RATE].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(130, 68, 32, 17), 4, options[Q_RATE], 0, 0 );
    // Reinforcement function for each network
    initPanel( rfPanel, BORDER, null, new Rectangle(370, 130, 300, 120) );
    seeFrame = new SeeSampleFrame( this );
    seeFrame.setEnabled( false );
    seeFrame.setVisible( false );
    initSeeButton( rfEachSampleButton, new Rectangle(180, 48, 110, 17),
                  TaskClarion.getSample(TaskClarion.ACS, TaskClarion.REIN ) );
    String[] rfTexts = {"default (no reinforcement function)", "user defined"};
    Rectangle[] rfRects = {new Rectangle(4, 28, 240, 17),new Rectangle(4, 48, 100, 17)};
    initButtonBlock( rfPanel, reinLabel, "Reinforcement function for each network", new Rectangle(4, 4, 300, 17),
                     rfButtons, rfTexts, rfRects, options[REIN_EACH], rfEachFields, 1, rfEachLoadButton );
    initLoadBlock( rfPanel, rfEachLoadButton, new Rectangle(110, 48, 64, 17), rfLoadFileLabel,
      new Rectangle(24, 68, 80, 17), rfLoadMethodLabel, new Rectangle(24, 88, 100, 17), rfEachFields[1][0],
      new Rectangle(110, 68, 180, 17), rfEachFields[1][1], new Rectangle(130, 88, 160, 17), options[REIN_EACH], 1 );
    rfPanel.add( reinLabel, null );
    rfPanel.add( rfEachSampleButton );
    rfCompOns = new boolean[rfPanel.getComponentCount()];
    //reinOption = transfer.getOptions( Global.ACS, Global.ACS_NET, Global.ACS_COR, 0, 0, 0, 1 );
    //this.initPanelStatus( reinOption, Global.REIN_EACH, rfPanel, rfCompOns );
    // return button.
    initReturnButton( returnButton, "RETURN", new Rectangle(560, 310, 100, 29) );
    ioPanel.add(ioLabel, null);
    ioPanel.add(inputDimButton, null);
    ioPanel.add(outputDimButton, null);
    ioPanel.add(hideUnitLabel, null);
    ioPanel.add(hideUnitField, null);
    learningPanel.add(learningLabel, null);
    learningPanel.add(lrLabel, null);
    learningPanel.add(lrField, null);
    learningPanel.add(momLabel, null);
    learningPanel.add(momField, null);
    learningPanel.add(qdLabel, null);
    learningPanel.add(qdField, null);
    paramPanel.add(paramLabel, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(ioPanel, null);
    this.getContentPane().add(tempPanel, null);
    this.getContentPane().add(learningPanel, null);
    this.getContentPane().add(paramPanel, null);
    this.getContentPane().add(rfPanel, null);
    this.getContentPane().add(returnButton, null);
    // init panel status.
    combOption = transfer.getOptions( Global.ACS, Global.ACS_NET, netType, netIdx, Global.ACS_BASIC, 0, COMB );
    reinOption = transfer.getOptions( Global.ACS, Global.ACS_NET, Global.ACS_COR, 0, 0, 0, REIN );
    // temperature.
    initPanelStatus( combOption, Global.STOCH_COMB_MODE, tempPanel, tempCompOns );
    // reinforcement function
    initPanelStatus( reinOption, Global.REIN_EACH, rfPanel, rfCompOns );
  }

  public void update()
  {
    // temperature.
    if( combOption.getUserChoice() == Global.STOCH_COMB_MODE ){
        if( !tempPanel.isEnabled() ){
            tempPanel.setEnabled( true );
            for( int j = 0; j < tempCompOns.length; j++ )
                 tempPanel.getComponent(j).setEnabled( tempCompOns[j] );
        }
    }
    else{
        if( tempPanel.isEnabled() ){
            for( int j = 0; j < tempCompOns.length; j++ )
                 tempCompOns[ j ] = tempPanel.getComponent(j).isEnabled();
            tempPanel.setEnabled( false );
            for( int j = 0; j < tempPanel.getComponentCount(); j++ )
                 tempPanel.getComponent(j).setEnabled( false );
        }
    }
    // reinforcement function
    if( reinOption.getUserChoice() == Global.REIN_EACH ){
        if( !rfPanel.isEnabled() ){
            rfPanel.setEnabled( true );
            for( int j = 0; j < rfCompOns.length; j++ )
                 rfPanel.getComponent(j).setEnabled( rfCompOns[j] );
        }
    }
    else{
        if( rfPanel.isEnabled() ){
            for( int j = 0; j < rfCompOns.length; j++ )
                 rfCompOns[ j ] = rfPanel.getComponent(j).isEnabled();
            rfPanel.setEnabled( false );
            for( int j = 0; j < rfPanel.getComponentCount(); j++ )
                 rfPanel.getComponent(j).setEnabled( false );
        }
    }
  }
}