package clarion.options.acs.net;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionAcsIrl extends SelectionAcsRule{
 final int RULE_NUM = 16, RULES = 17, DEN = 18;
 final int POS = 19, IG = 20, TH = 21, RANGE = 22;
 // rules
 JPanel rulePanel = new JPanel();
 JLabel ruleLabel = new JLabel();
 JLabel ruleNumLabel = new JLabel();
 JTextField ruleNumField = new JTextField();
 JLabel ruleLabel1 = new JLabel();
 JButton irlSampleButton = new JButton();
 JButton ruleLoadButton = new JButton();
 JLabel ruleFileLabel = new JLabel();
 JTextField ruleFileField = new JTextField();
 JLabel ruleMethodLabel = new JLabel();
 JTextField ruleMethodField = new JTextField();
 // parameter
 JPanel paramPanel = new JPanel();
 JLabel paramLabel = new JLabel();
 JLabel denLabel = new JLabel();
 JTextField denField = new JTextField();
 JLabel genOnLabel = new JLabel();
 JLabel sgLabel = new JLabel();
 JRadioButton[] sgButtons = new JRadioButton[4];{
   for( int i = 0; i < 4; i++ )
       sgButtons[i] = new JRadioButton();
 }
 JLabel rangeLabel = new JLabel();
 JRadioButton[] rangeButtons = new JRadioButton[3]; {
     for( int i = 0; i < 3; i++ )
          rangeButtons[i] = new JRadioButton();
 }
 // positivity
 JPanel posPanel = new JPanel();
 JLabel posLabel = new JLabel();
 JRadioButton[] posButtons = new JRadioButton[3];{
   posButtons[0] = new JRadioButton();
   posButtons[1] = new JRadioButton();
   posButtons[2] = new JRadioButton();
 }
 JLabel posLabel11 = new JLabel();
 JLabel posLabel12 = new JLabel();
 JLabel posLabel21 = new JLabel();
 JButton posLoadButton = new JButton();
 JLabel posFileLabel = new JLabel();
 JLabel posMethodLabel = new JLabel();
 JTextField[][] posFields = new JTextField[3][];{
    posFields[2] = new JTextField[2];
    posFields[2][0] = new JTextField();
    posFields[2][1] = new JTextField();
 }
 // IG
 JPanel igPanel = new JPanel();
 JLabel igLabel = new JLabel();
 JRadioButton[] igButtons = new JRadioButton[2]; {
      igButtons[0] = new JRadioButton();
      igButtons[1] = new JRadioButton();
 }
 JButton igLoadButton = new JButton();
 JLabel igFileLabel = new JLabel();
 JLabel igMethodLabel = new JLabel();
 JLabel[] igLabels = new JLabel[3]; {
    for( int i = 0; i < 3; i++ )
         igLabels[i] = new JLabel();
 }
 JTextField[][] igFields = new JTextField[2][2];{
    for( int i = 0; i < 2; i++ )
      for( int j = 0; j < 2; j++ )
          igFields[i][j] = new JTextField();
 }
 // threholds.
 JPanel rlthPanel = new JPanel();
 JLabel rlthLabel = new JLabel();
 JLabel[] rlthLabels = new JLabel[4]; {
     for( int i = 0; i < 4; i++ )
          rlthLabels[i] = new JLabel();
 }
 JTextField[] rlthFields = new JTextField[4];{
     for( int i = 0; i < 4; i++ )
          rlthFields[i] = new JTextField();
 }
 // return buttons.
 JButton nextButton = new JButton();
 JButton backButton = new JButton();

 public SelectionAcsIrl( JFrame superFrame, int width, int height, int netType, int netIdx, int setIdx,
                         SettingTransfer transfer )
 {
    super( superFrame, width, height, netType, netIdx, Global.IRL, setIdx, transfer );
    // add new components.
    addNewComponents();
    // update
    update();
 }

 public void update()
 {
    super.update();
    if( setIdx > 0 )
        backButton.setEnabled( true );
    else
        backButton.setEnabled( false );
    if( setIdx < transfer.getAcsCompFileNum( netType, netIdx, Global.IRL )-1 )
        nextButton.setEnabled( true );
    else
        nextButton.setEnabled( false );
 }

 protected void addNewComponents()
 {
    // IRL rules.
    initPanel( rulePanel, BORDER, null, new Rectangle(660, 30, 350, 110));
    initLabel( ruleLabel,"IRL rule subset Information", new Rectangle(4, 2, 200, 17));
    initLabel( ruleNumLabel,"number of rules in this subset", new Rectangle(8, 30, 180, 17));
    initField( ruleNumField, String.valueOf(options[RULE_NUM].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(190, 30, 24, 17), 5, options[RULE_NUM], 0, 0 );
    seeFrame = new SeeSampleFrame( this );
    seeFrame.setEnabled( false );
    seeFrame.setVisible( false );
    initSeeButton( irlSampleButton, new Rectangle(210, 50, 110, 17),
                  TaskClarion.getSample(TaskClarion.ACS, TaskClarion.IRL_PARAM ) );
    initLabel( ruleLabel1,"IRL rules", new Rectangle(8, 50, 120, 17));
    initLoadBlock( rulePanel, ruleLoadButton, new Rectangle(140, 50, 64, 17), ruleFileLabel,
           new Rectangle(16, 70, 110, 17), ruleMethodLabel, new Rectangle(16, 90, 120, 17),
           ruleFileField, new Rectangle(130, 70, 200, 17), ruleMethodField,
           new Rectangle(140, 90, 190, 17), options[RULES], 0 );
    // parameters.
    initPanel( paramPanel, BORDER, null, new Rectangle(660, 145, 350, 110));
    initLabel( paramLabel,"IRL Parameters", new Rectangle(4, 2, 128, 17));
    initLabel( denLabel,"the density parameter", new Rectangle(8, 28, 136, 17));
    initField( denField, String.valueOf(options[DEN].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(144, 28, 40, 17), 5, options[DEN], 0, 0 );
    String[] rangeTexts = {"contiguous value range","non-contiguous value range","one value or all"};
    Rectangle[] rangeRects = { new Rectangle(8, 68, 156, 17),new Rectangle(168, 68, 181, 17),
                               new Rectangle(8, 88, 117, 17) };
    initButtonBlock( paramPanel, rangeLabel,"generalization/specification style",
             new Rectangle(8, 48, 272, 17), rangeButtons, rangeTexts, rangeRects,options[RANGE] );
    // positivity criterion.
    initPanel( posPanel, BORDER, null, new Rectangle(660, 260, 350, 190));
    String[] posTexts = { "default 1", "default 2", "user defined criterion"};
    Rectangle[] posRects = { new Rectangle(8, 24, 205, 17), new Rectangle(8, 84, 144, 17),
                             new Rectangle(8, 124, 144, 17) };
    initButtonBlock( posPanel, posLabel,"Rule positivity criterion",new Rectangle(4, 2, 156, 17),
                     posButtons, posTexts, posRects, options[POS], posFields, 2, posLoadButton );
    initLabel( posLabel11,"reward + QdiscountRate * maxbQ(y,b) -Q(x,a)",new Rectangle(24, 44, 259, 17));
    initLabel( posLabel12, "> threshold_IRL", new Rectangle(24, 64, 110, 17));
    initLabel( posLabel21,"reward > threshold_IRL", new Rectangle(24, 104, 259, 17));
    initLoadBlock( posPanel, posLoadButton, new Rectangle(180, 120, 64, 22), posFileLabel,
      new Rectangle(24, 144, 110, 17), posMethodLabel, new Rectangle(24, 164, 120, 17),
      posFields[2][0], new Rectangle(140, 144, 190, 17), posFields[2][1], new Rectangle(150, 164, 180, 17),
      options[POS], 2 );
    // info gain
    initPanel( igPanel, BORDER, null, new Rectangle(660, 455, 350, 150));
    String[] igButtonTexts = {"the default measure", "user defined measure"};
    Rectangle[] igButtonRects = {new Rectangle(8, 22, 144, 17),new Rectangle(8, 88, 144, 17)};
    initButtonBlock(igPanel,igLabel,"IG measures for rule learning ", new Rectangle(4, 2, 188, 17),
                    igButtons, igButtonTexts, igButtonRects, options[IG], igFields, 1, igLoadButton );
    initLoadBlock( igPanel, igLoadButton, new Rectangle(180, 84, 64, 22), igFileLabel,
       new Rectangle(24, 108, 110, 17),igMethodLabel,new Rectangle(24, 128, 120, 17), igFields[1][0],
       new Rectangle(140, 108, 190, 17), igFields[1][1], new Rectangle(150, 128, 180, 17), options[IG], 1);
    String[] igLabelTexts = {"c5 =","c6 =","IG( C ) = log2( ( PM(C) + C5 ) / ( PM(C) + NM(C) + C6 ) )"};
    Rectangle[] igLabelRects = { new Rectangle(24, 40, 24, 17), new Rectangle(92, 40, 24, 17),
                                 new Rectangle(24, 60, 345, 17) };
    String[] igFieldTexts = { String.valueOf(options[IG].getOptionItem(0).getParameter(0).getDoubleValue()),
                              String.valueOf(options[IG].getOptionItem(0).getParameter(1).getDoubleValue()) };
    Rectangle[] igFieldRects = {new Rectangle(50, 40, 24, 17),new Rectangle(118, 40, 24, 17)};
    initFieldBlock( igPanel, igLabels, igLabelTexts, igLabelRects, igFields[0], igFieldTexts,
                    igFieldRects, options[IG], 0 );
    // thresholds.
    initPanel( rlthPanel, BORDER, null, new Rectangle(660, 610, 350, 110));
    initLabel( rlthLabel, "Rule learning thresholds",new Rectangle(4, 2, 140, 17) );
    String[] rlthLabelTexts = {
                "threshold_IRL ( for positivity ) =", "threshold6 ( for generalization ) =",
                "threshold7 ( for specialization ) =", "threshold4 ( for rule deletion ) =" };
    Rectangle[] rlthLabelRects = {
                new Rectangle(8, 24, 200, 17), new Rectangle(8, 44, 200, 17),
                new Rectangle(8, 64, 200, 17), new Rectangle(8, 84, 200, 17)
             };
    String[] rlthFieldTexts = {
               String.valueOf(options[TH].getOptionItem(0).getParameter(0).getDoubleValue()),
               String.valueOf(options[TH].getOptionItem(0).getParameter(1).getDoubleValue()),
               String.valueOf(options[TH].getOptionItem(0).getParameter(2).getDoubleValue()),
               String.valueOf(options[TH].getOptionItem(0).getParameter(3).getDoubleValue())
             };
    Rectangle[] rlthFieldRects = {
                new Rectangle(192, 24, 32, 17), new Rectangle(204, 44, 32, 17),
                new Rectangle(200, 64, 32, 17), new Rectangle(192, 84, 32, 17)
              };
    initFieldBlock( rlthPanel, rlthLabels, rlthLabelTexts, rlthLabelRects, rlthFields,
                    rlthFieldTexts, rlthFieldRects, options[TH], 0 );
    // return buttons
    initReturnButton( backButton, "BACK", new Rectangle(680, 735, 110, 29), setIdx, 0 );
    initReturnButton( nextButton, "NEXT", new Rectangle(790, 735, 110, 29), setIdx, 1 );
    // add components
    rulePanel.add(ruleLabel, null);
    rulePanel.add(ruleLabel1, null);
    rulePanel.add(ruleNumLabel, null);
    rulePanel.add(ruleNumField, null);
    rulePanel.add(irlSampleButton, null);
    paramPanel.add(paramLabel, null);
    paramPanel.add(denLabel, null);
    paramPanel.add(denField, null);
    posPanel.add(posLabel, null);
    posPanel.add(posLabel11, null);
    posPanel.add(posLabel12, null);
    posPanel.add(posLabel21, null);
    igPanel.add(igLabel, null);
    rlthPanel.add(rlthLabel, null);
    rootContainer.add(rulePanel, null);
    rootContainer.add(paramPanel, null);
    rootContainer.add(posPanel, null);
    rootContainer.add(igPanel, null);
    rootContainer.add(rlthPanel, null);
    rootContainer.add(nextButton, null);
    rootContainer.add(backButton, null);
 }
}