package clarion.options.acs.net;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionAcsRule extends SelectionTemplate{
 final int IN_DIM_TYPE = 0, OUT_DIM_TYPE = 1, IN_DIM_IDX = 2, OUT_DIM_IDX = 3, TEMP = 4;
 final int REASON = 5, MCS = 6, UTL_ON = 7, SUP_ON = 8, PM_ON = 9, RBLA_ON = 10;
 final int CBLA_ON = 11, WEIGHT = 12, RBLA = 13, CBLA = 14, UTL = 15;
 // from other levels
 final int COMB = 9;
 final int ON = 0, OFF = 1;
 // some GUI constants.
 final int CENTER = SwingConstants.CENTER;
 final Border BORDER = BorderFactory.createLineBorder(Color.black);
 final Color COLOR = SystemColor.activeCaption;
 final Font capFont = new java.awt.Font("Dialog", 1, 20);
 final String[] capTexts = { "", "RER  OPTIONS", "IRL  OPTIONS ( current rule subset = ",
                             "FIXED RULES OPTIONS ( current rule NO = "  };
 final String[] onOffTexts = { "ON", "OFF" };
 final int IO = 0, TP = 1, RS = 2, REP = 3, WGT = 4, CB = 5, RB = 6, UT = 7, RTN = 8;
 final Rectangle[][] compLocs = {
       {
          new Rectangle(10, 30, 320, 100), new Rectangle(10, 150, 320, 60),
          new Rectangle(10, 230, 320, 125), new Rectangle(10, 375, 320, 165),
          new Rectangle(10, 560, 320, 160), new Rectangle(340, 30, 310, 176),
          new Rectangle(340, 208, 310, 176), new Rectangle(340, 386, 310, 334),
          new Rectangle(880, 735, 110, 29)
       },
       {
          new Rectangle(4, 24, 320, 96), new Rectangle(4, 135, 320, 65),
          new Rectangle(4, 215, 320, 130), new Rectangle(4, 360, 320, 160),
          new Rectangle(328, 24, 312, 120), new Rectangle(328, 150, 312, 184),
          new Rectangle(328, 336, 312, 184), new Rectangle(644, 24, 312, 338),
          new Rectangle(846, 540, 110, 29)
       }
       };
 int netType, netIdx, ruleType, setIdx, style;
 // GUI components
 Container rootContainer;
 JLabel capLabel = new JLabel();
 // general
 JPanel genPanel = new JPanel();
 JLabel ioLabel = new JLabel();
 JButton inDimButton = new JButton();
 JButton outDimButton = new JButton();
 OptionDims[] optDims = new OptionDims[2];
 // reason.
 JPanel reasonPanel = new JPanel();
 JLabel reasonLabel = new JLabel();
 JRadioButton[] reasonButtons = new JRadioButton[4];{
    for( int i = 0; i < 4; i++ )
         reasonButtons[i] = new JRadioButton();
 }
 // temp
 boolean[] tempCompOns;
 JPanel tempPanel = new JPanel();
 JLabel tlTempLabel = new JLabel();
 JTextField tlTempField = new JTextField();
 // rep
 JPanel repPanel = new JPanel();
 JLabel repLabel = new JLabel();
 JLabel repUtlLabel = new JLabel();
 JRadioButton[] repUtlButtons = new JRadioButton[2];{
   repUtlButtons[0] = new JRadioButton();
   repUtlButtons[1] = new JRadioButton();
 }
 JLabel repSupLabel = new JLabel();
 JRadioButton[] repSupButtons = new JRadioButton[2];{
   repSupButtons[0] = new JRadioButton();
   repSupButtons[1] = new JRadioButton();
 }
 JLabel repPmLabel = new JLabel();
 JRadioButton[] repPmButtons = new JRadioButton[2];{
   repPmButtons[0] = new JRadioButton();
   repPmButtons[1] = new JRadioButton();
 }
 JLabel repRblaLabel = new JLabel();
 JRadioButton[] repRblaButtons = new JRadioButton[2];{
   repRblaButtons[0] = new JRadioButton();
   repRblaButtons[1] = new JRadioButton();
 }
 JLabel repCblaLabel = new JLabel();
 JRadioButton[] repCblaButtons = new JRadioButton[2];{
   repCblaButtons[0] = new JRadioButton();
   repCblaButtons[1] = new JRadioButton();
 }
 // weights.
 boolean[] wgtCompOns;
 JLabel wgtLabel = new JLabel();
 JPanel wgtPanel = new JPanel();
 JRadioButton[] wgtButtons = new JRadioButton[2];{
   wgtButtons[0] = new JRadioButton();
   wgtButtons[1] = new JRadioButton();
 }
 JButton wgtLoadButton = new JButton();
 JLabel wgtFileLabel = new JLabel();
 JLabel wgtMethodLabel = new JLabel();
 JTextField[][] wgtFields = new JTextField[2][];{
    wgtFields[1] = new JTextField[2];
    wgtFields[1][0] = new JTextField();
    wgtFields[1][1] = new JTextField();
 }
 // rule bla
 boolean[] rblaCompOns;
 JPanel rblaPanel = new JPanel();
 // chunk bla.
 boolean[] cblaCompOns;
 JPanel cblaPanel = new JPanel();
 // utility
 boolean[] utlCompOns;
 JPanel utlPanel = new JPanel();
 // return buttons.
 JButton returnButton = new JButton();
 // relative options for dependency
 Option combOption;

 public SelectionAcsRule( JFrame superFrame, int width, int height, int netType, int netIdx,
                          int ruleType, int setIdx, SettingTransfer transfer )
 {
    super( superFrame, width, height, transfer );
    this.netType = netType;
    this.netIdx = netIdx;
    this.ruleType = ruleType;
    this.setIdx = setIdx;
    initGui();
 }

 public void initGui()
 {
    //get options.
    options = transfer.getOptions( Global.ACS, Global.ACS_NET, netType, netIdx, ruleType, setIdx );
    // set size.
    if( parent != null ){
        setSize( 960, 720 );
        rootContainer = parent;
    }
    else{
        setSize( width, height );
        rootContainer = this.getContentPane();
        rootContainer.setLayout(null);
    }
    // set style.
    style = ( ruleType != Global.FR )?0 : 1;
    // caption.
    String capText = capTexts[ruleType];
    if( ruleType != Global.RER )
        capText += setIdx + " )";
    initLabel( capLabel, capText, capFont, CENTER, new Rectangle( (width-500)/2, 0, 500, 26) );
    // io
    initPanel( genPanel, BORDER, null, compLocs[style][IO] );
    initLabel( ioLabel, "I/O dimensions and values", new Rectangle(7, 8, 157, 17) );
    initButton( inDimButton, "input dimensions", new Rectangle(16, 50, 132, 24));
    initButton( outDimButton, "output dimensions", new Rectangle(158, 50, 152, 24));
    optDims[0] = new OptionDims( this, 420, 780, "IDN INPUT SPECIFICATION", 30, transfer,
            options[IN_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue(), options[IN_DIM_IDX] );
    optDims[1] = new OptionDims( this, 420, 780, "IDN OUTPUT SPECIFICATION", 30, transfer,
            options[OUT_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue(), options[OUT_DIM_IDX] );
    initDimButton( this, inDimButton, optDims[0] );
    initDimButton( this, outDimButton, optDims[1] );
    // temperature.
    initPanel( tempPanel, BORDER, null, compLocs[style][TP] );
    initLabel( tlTempLabel, "temperature for top-level action selection",new Rectangle(6,30,240,17));
    initField( tlTempField, String.valueOf(options[TEMP].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(250, 28, 30, 17), 5, options[TEMP], 0, 0 );
    tempPanel.add(tlTempLabel, null);
    tempPanel.add(tlTempField, null);
    tempCompOns = new boolean[tempPanel.getComponentCount()];
    // reasoning.
    initPanel( reasonPanel, BORDER, null, compLocs[style][RS] );
    String[] reasonTexts = { "forward chaining", "backward chaining",
             "similarity-based forward chaining", "determined by MCS" };
    Rectangle[] reasonRects = {new Rectangle(4, 30, 126, 17),new Rectangle(4, 54, 130, 17),
             new Rectangle(4, 73, 208, 17), new Rectangle(4, 95, 133, 17) };
    initButtonBlock( reasonPanel,reasonLabel, "Options for using action rules in action decision making",
             new Rectangle(4, 8, 314, 17), reasonButtons, reasonTexts, reasonRects, options[REASON] );
    // weights.
    initPanel(wgtPanel, BORDER, null, compLocs[style][WGT]);
    String[] wgtTexts = { "default (all weights are equal)", "user defined" };
    Rectangle[] wgtRects = { new Rectangle(8, 38, 200, 17), new Rectangle(8, 68, 120, 17)};
    initButtonBlock( wgtPanel, wgtLabel, "Weights of action rule conditions", new Rectangle(4, 4, 200, 17),
                     wgtButtons, wgtTexts, wgtRects, options[WEIGHT], wgtFields, 1, wgtLoadButton );
    initLoadBlock( wgtPanel, wgtLoadButton, new Rectangle(160, 68, 72, 17), wgtFileLabel,
         new Rectangle(24, 88, 110, 17), wgtMethodLabel, new Rectangle(24, 118, 120, 17), wgtFields[1][0],
         new Rectangle(140, 88, 160, 17), wgtFields[1][1], new Rectangle(150, 118, 150, 17), options[WEIGHT], 1 );
    wgtCompOns = new boolean[wgtPanel.getComponentCount()];
    super.initPanelStatus( options[SUP_ON], ON, wgtPanel, wgtCompOns );
    // chunk bla
    initPanel( cblaPanel, BORDER, null, compLocs[style][CB] );
    initBlaBlock( cblaPanel, "Chunk base-level activation", options[CBLA] );
    cblaCompOns = new boolean[cblaPanel.getComponentCount()];
    super.initPanelStatus( options[CBLA_ON], ON, cblaPanel, cblaCompOns );
    // rule bla
    initPanel( rblaPanel, BORDER, null, compLocs[style][RB] );
    initBlaBlock( rblaPanel, "Rule base-level activation", options[RBLA] );
    rblaCompOns = new boolean[rblaPanel.getComponentCount()];
    super.initPanelStatus( options[RBLA_ON], ON, rblaPanel, rblaCompOns );
    // rule utility
    initPanel( utlPanel, BORDER, null, compLocs[style][UT] );
    initUtilityBlock(utlPanel, "Rule utility options", options[UTL]);
    utlCompOns = new boolean[utlPanel.getComponentCount()];
    super.initPanelStatus( options[UTL_ON], ON, utlPanel, utlCompOns );
    // representation.
    initPanel( repPanel, BORDER, null, compLocs[style][REP] );
    initLabel( repLabel, "Options for action rule representations", new Rectangle(8, 7, 223, 17));
    Rectangle[] repUtlRects = {new Rectangle(83, 30, 45, 17), new Rectangle(147, 28, 52, 17)};
    initButtonBlock( repPanel, repUtlLabel, "rule utility", new Rectangle(12, 28, 68, 17),
                     repUtlButtons, onOffTexts, repUtlRects, options[UTL_ON], ON, utlPanel, utlCompOns );
    Rectangle[] repSupRects = {new Rectangle(100, 48, 45, 17), new Rectangle(161, 46, 52, 17)};
    initButtonBlock( repPanel, repSupLabel, "rule support", new Rectangle(13, 49, 75, 17),
                     repSupButtons, onOffTexts, repSupRects, options[SUP_ON], ON, wgtPanel, wgtCompOns );
    Rectangle[] repPmRects = {new Rectangle(112, 71, 45, 17),new Rectangle(166, 69, 52, 17)};
    initButtonBlock( repPanel, repPmLabel, "partial matching", new Rectangle(11, 72, 97, 17),
                     repPmButtons, onOffTexts, repPmRects, options[PM_ON] );
    Rectangle[] repRblaRects = {new Rectangle(155, 95, 45, 17),new Rectangle(207, 95, 52, 17)};
    initButtonBlock( repPanel, repRblaLabel, "rule base-level activation", new Rectangle(11, 97, 143, 17),
                     repRblaButtons, onOffTexts, repRblaRects, options[RBLA_ON], ON, rblaPanel, rblaCompOns );
    Rectangle[] repCblaRects = {new Rectangle(205, 125, 45, 17),new Rectangle(258, 127, 52, 17)};
    initButtonBlock( repPanel, repCblaLabel, "action chunk base-level activation", new Rectangle(9, 124, 194, 17),
                     repCblaButtons, onOffTexts, repCblaRects, options[CBLA_ON], ON, cblaPanel, cblaCompOns );
    // return button.
    initReturnButton( returnButton, "RETURN", compLocs[style][RTN] );
    // init panel status.
    combOption = transfer.getOptions( Global.ACS, Global.ACS_NET, netType, netIdx, Global.ACS_BASIC, 0, COMB );
    initPanelStatus( combOption, Global.STOCH_COMB_MODE, tempPanel, tempCompOns );
    // add components
    genPanel.add(ioLabel, null);
    genPanel.add(inDimButton, null);
    genPanel.add(outDimButton, null);
    repPanel.add(repLabel, null);
    rootContainer.add(capLabel, null);
    rootContainer.add(genPanel, null);
    rootContainer.add(tempPanel, null);
    rootContainer.add(reasonPanel, null);
    rootContainer.add(repPanel, null);
    rootContainer.add(wgtPanel, null);
    rootContainer.add(rblaPanel, null);
    rootContainer.add(utlPanel, null);
    rootContainer.add(cblaPanel, null);
    rootContainer.add(returnButton, null);
 }

 // update resulting from upper level
 public void update()
 {
    // temperature.
    if( combOption.getUserChoice() == Global.STOCH_COMB_MODE ){
        if( tempPanel.isEnabled() )
            return;
        tempPanel.setEnabled( true );
        for( int j = 0; j < tempCompOns.length; j++ )
             tempPanel.getComponent(j).setEnabled( tempCompOns[j] );
    }
    else{
        if( !tempPanel.isEnabled() )
            return;
        for( int j = 0; j < tempCompOns.length; j++ )
             tempCompOns[ j ] = tempPanel.getComponent(j).isEnabled();
        tempPanel.setEnabled( false );
        for( int j = 0; j < tempPanel.getComponentCount(); j++ )
             tempPanel.getComponent(j).setEnabled( false );
    }
 }

}