package clarion.options.dims;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.options.*;
import clarion.system.*;


public class SelectionDims extends SelectionTemplate{

  int dimNum, maxDimNum, featType;
  String capName;
  JLabel capLabel = new JLabel();
  JPanel panel = new JPanel();
  JLabel dimNumLabel = new JLabel();
  JTextField dimNumField = new JTextField();
  JLabel noteLabel1 = new JLabel();
  JLabel noteLabel2 = new JLabel();
  JLabel dimLabel = new JLabel();
  JLabel dimNameLabel = new JLabel();
  JLabel dimValNumLabel = new JLabel();
  JLabel[] dimLabels;
  JTextField[] dimNameFields;
  JTextField[] dimValNumFields;
  JButton returnButton = new JButton();

  public SelectionDims( JFrame superFrame, int width, int height, String name,
         int maxDimNum, int featType, SettingTransfer transfer )
  {
    super( superFrame, width, height, transfer );
    capName = name;
    this.maxDimNum = maxDimNum;
    this.featType = featType;
    dimLabels = new JLabel[maxDimNum];
    dimNameFields = new JTextField[maxDimNum];
    dimValNumFields = new JTextField[maxDimNum];
    for( int i = 0; i < maxDimNum; i++ ){
         dimLabels[i] = new JLabel();
         dimNameFields[i] = new JTextField();
         dimValNumFields[i] = new JTextField();
    }
    initGui();
  }

  public void initGui()
  {
    final int TYPE_NUM = 0, FEAT_NUMS = 1, FEAT_NAMES = 2;
    final int FEAT_VAL_NUMS_START = 3, FEAT_VAL_NAMES_START = 6;

    options = transfer.getOptions( Global.DIMS, 0, 0, 0, 0, 0 );
    setSize( 500, 720 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    // caption.
    initLabel( capLabel, capName, new Font("Dialog",1,14), SwingConstants.CENTER,
               new Rectangle((width-300)/2, 2, 300, 25) );
    // panel.
    initPanel( panel, BORDER, null, new Rectangle(10, 30, width-30, height-85) );
    dimNum = options[FEAT_NUMS].getOptionItem(0).getParameter(featType).getIntValue();
    initLabel( dimNumLabel, "The number of dimension", new Rectangle(10, 4, 170, 17));
    initField( dimNumField, String.valueOf( dimNum ), new Rectangle(180, 4, 32, 17) );
    initLabel( noteLabel1, "Note: the following dimensions specified exactly as provided by external",
               new Rectangle(10, 30, 450, 17));
    initLabel( noteLabel2, "sources. Name each dimension and specify the value # of each dimension",
               new Rectangle(10, 50, 450, 17));
    initLabel( dimLabel, "dimensions", new Rectangle(10, 70, 150, 17));
    initLabel( dimNameLabel, "name", new Rectangle(170, 70, 100, 17));
    initLabel( dimValNumLabel, "value number", new Rectangle(260, 70, 80, 17));
    dimNumField.addActionListener( new ActionListener() {
             public void actionPerformed(ActionEvent e) {
                  try{
                    int num = Integer.parseInt( dimNumField.getText().trim() );
                    if( num < 1 || num > maxDimNum ){
                        JOptionPane.showMessageDialog( null, "out of range, reset !",
                                                       "Error", JOptionPane.ERROR_MESSAGE );
                        dimNumField.setText( String.valueOf( dimNum ) );
                        return;
                    }
                    else
                        dimNum = num;
                  }
                  catch( NumberFormatException e1 ){
                     JOptionPane.showMessageDialog( null, "Not a number, reset !",
                                                    "Error", JOptionPane.ERROR_MESSAGE );
                     dimNumField.setText( String.valueOf( dimNum ) );
                     return;
                  }
                  dimNumField.setText( String.valueOf( dimNum ) );
                  options[FEAT_NUMS].getOptionItem(0).getParameter(featType).setIntValue(dimNum);
                  options[FEAT_NAMES].getOptionItem(0).getParameter(featType).setCount(dimNum);
                  options[FEAT_VAL_NUMS_START+featType].getOptionItem(0).getParameter(0).setCount(dimNum);
                  options[FEAT_VAL_NAMES_START+featType].getOptionItem(0).setCount(dimNum);
                  for( int i = 0; i < maxDimNum; i++ ){
                       dimLabels[i].setEnabled( i < dimNum );
                       dimNameFields[i].setEnabled( i < dimNum );
                       dimValNumFields[i].setEnabled( i < dimNum );
                  }
            }
         });
    for( int i = 0; i < maxDimNum; i++ ){
         initLabel( dimLabels[i], "dimension" + i, new Rectangle(10, 90+20*i, 100, 17) );
         String name = "dim " + i;
         if ( i < dimNum )
            name = options[FEAT_NAMES].getOptionItem(0).getParameter(featType).getStringValues()[i];
         initField( dimNameFields[i], name, new Rectangle(140, 90+20*i, 100, 17) );
         int offset = FEAT_VAL_NUMS_START + featType;
         int dimValNum = 1;
         if( i < dimNum )
             dimValNum = options[offset].getOptionItem(0).getParameter(0).getIntValues()[i];
         initField( dimValNumFields[i], String.valueOf( dimValNum ), new Rectangle(300, 90+20*i, 24, 17) );
         dimNameFields[i].setEnabled( i < dimNum );
         dimValNumFields[i].setEnabled( i < dimNum );
         final int focus = i;
         dimNameFields[i].addActionListener(new ActionListener() {
             public void actionPerformed(ActionEvent e) {
                 String name = dimNameFields[focus].getText();
                 options[FEAT_NAMES].getOptionItem(0).getParameter(featType).setStringValue(focus,name);
             }
         });
         dimValNumFields[i].addActionListener(new ActionListener() {
             public void actionPerformed(ActionEvent e) {
               int offset = FEAT_VAL_NUMS_START + featType;
               int nameOffset = FEAT_VAL_NAMES_START + featType;
               try{
                 int num = Integer.parseInt( dimValNumFields[focus].getText() );
                 if( num < 1 ){
                     JOptionPane.showMessageDialog( null, "out of range, reset !",
                                                    "Error", JOptionPane.ERROR_MESSAGE );
                     dimValNumFields[focus].setText( String.valueOf(
                       options[offset].getOptionItem(0).getParameter(0).getIntValues()[focus]));
                     return;
                 }
                 options[offset].getOptionItem(0).getParameter(0).setIntValue(focus,num);
                 options[nameOffset].getOptionItem(0).getParameter(focus).setCount( num );
               }
               catch( NumberFormatException e1 ){
                   JOptionPane.showMessageDialog( null, "Not a number, reset !",
                                                  "Error", JOptionPane.ERROR_MESSAGE );
                   dimValNumFields[focus].setText( String.valueOf(
                      options[offset].getOptionItem(0).getParameter(0).getIntValues()[focus]));
                   return;
               }
             }
         });
    }
    // return button.
    initReturnButton( returnButton, "RETURN", new Rectangle(width-120, height-40, 100, 20) );
    // add components.
    panel.add( dimNumLabel );
    panel.add( dimNumField );
    for( int i = 0; i < maxDimNum; i++ ){
         panel.add( dimLabels[i] );
         panel.add( dimNameFields[i] );
         panel.add( dimValNumFields[i] );
    }
    panel.add( noteLabel1 );
    panel.add( noteLabel2 );
    panel.add( dimLabel );
    panel.add( dimNameLabel );
    panel.add( dimValNumLabel );
    parent.add(capLabel, null);
    parent.add(panel, null);
    parent.add(returnButton, null);
  }
}