package clarion.options.inter;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionInter extends SelectionTemplate{
  JFrame superFrame;
  JLabel capLabel = new JLabel();
  JPanel interPanel = new JPanel();
  JLabel dispLabel = new JLabel();
  JRadioButton[] dispButtons = new JRadioButton[3]; {
    for( int i = 0; i < 3; i++ )
         dispButtons[i] = new JRadioButton();
  }
  JLabel freqLabel = new JLabel();
  JRadioButton[] freqButtons = new JRadioButton[3]; {
    for( int i = 0; i < 3; i++ )
         freqButtons[i] = new JRadioButton();
  }
  JLabel stepNumLabel = new JLabel();
  JTextField stepNumField = new JTextField();
  JButton returnButton = new JButton();

  public SelectionInter( JFrame superFrame, int width, int height, SettingTransfer transfer )
  {
    super( superFrame, width, height, transfer );
    initGui();
  }

  public void initGui()
  {
    final int DISP = 0, FREQ = 1;
    options = transfer.getOptions( Global.ACS, Global.ACS_COMP, 0, 0, 0, 0 );
    setSize( width, height );
    getContentPane().setLayout( null );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    // panel
    initPanel( interPanel, BORDER, null, new Rectangle(10, 32, 396, 207) );
    initLabel( capLabel,"OPTIONS OF INTERFACE", new java.awt.Font("Dialog", 1, 17),
               SwingConstants.CENTER, new Rectangle(59, 2, 265, 27));
    // display option.
    String[] dispTexts = {"no display", "show rules matching the current input",
             "show rules matching the current input and action" };
    Rectangle[] dispRects = { new Rectangle(13, 29, 81, 17), new Rectangle(13, 54, 234, 17),
                              new Rectangle(13, 77, 377, 17) };
    initButtonBlock( interPanel, dispLabel, "Rule display options", new Rectangle(11, 8, 116, 17),
                     dispButtons, dispTexts, dispRects, options[DISP] );
    // frequency option
    String[] freqTexts = {"no display", "every step", "every x step" };
    Rectangle[] freqRects = { new Rectangle(15, 131, 81, 17), new Rectangle(14, 154, 81, 17),
                              new Rectangle(14, 177, 95, 17) };
    initLabel( stepNumLabel, "specify x", new Rectangle(123, 181, 53, 13));
    initField( stepNumField, "1", new Rectangle(182, 178, 17, 17));
    initButtonBlock( interPanel, freqLabel, "Rule display frequency", new Rectangle(10, 111, 136, 17),
                     freqButtons, freqTexts, freqRects, options[FREQ], 2, stepNumField );
    // return button.
    initReturnButton( returnButton, "RETURN", new Rectangle(309, 255, 88, 28));
    interPanel.add(stepNumLabel, null);
    interPanel.add(stepNumField, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(interPanel, null);
    this.getContentPane().add(returnButton, null);
  }
}