package clarion.options.nacs;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;
import clarion.options.nacs.amn.*;

public class GuiNACS extends GuiTemplate{

  String buttonTexts[] =
  {
     "Options for NACS components",
     "Options for GKS",
     "Options for AMN",
     "Options for AEM",
     "Options for Coordinating the ACS and NACS",
  };
  SelectionTemplate subSelections[];
  GuiTemplate amns;
  // get basic CLARION info
  int amnNum;

  public GuiNACS( int num )
  {
     super( num, "OPTIONS OF THE NON-ACTION-CENTERED SYSTEM" );
     setButtonTexts( buttonTexts );
     // get basic CLARION info
     amnNum = transfer.getAmnNum();
     subSelections = new SelectionTemplate[ 4 ];
     subSelections[0] = new SelectionNacsComp( this, 400, 280, transfer );
     subSelections[1] = new SelectionGks( this, 960, 850, transfer );
     subSelections[2] = new SelectionAem( this, 360, 420, transfer );
     subSelections[3] = new SelectionCor( this, 380, 440, transfer );
     amns = new GuiAmn( amnNum );
     amns.init( this );
     returnFrom();
  }

  public void returnFrom()
  {
     if( transfer.isGksOn() ){
         optButtons[1].setEnabled( true );
         if( subSelections[1] == null )
             subSelections[1] = new SelectionGks( this, 960, 850, transfer );
         ((SelectionGks)subSelections[1]).update();
     }
     else
         optButtons[1].setEnabled( false );
     if( transfer.isAemOn() ){
         optButtons[3].setEnabled( true );
         if( subSelections[2] == null )
             subSelections[2] = new SelectionAem( this, 360, 420, transfer );
         ((SelectionAem)subSelections[2]).update();
     }
     else
         optButtons[3].setEnabled( false );
     ((GuiAmn)amns).updateGui();
  }

  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < 4; i++ ){
          final int idx = i;
          if( idx < 2 )
              optButtons[ idx ].addActionListener(  new  ActionListener(){
                                public void actionPerformed( ActionEvent e ){
                                  activeButtonIdx = idx;
                                  subSelections[idx].setEnabled( true );
                                  subSelections[idx].setVisible( true );
                               }
                       } );
          else
              optButtons[ idx + 1 ].addActionListener(  new  ActionListener(){
                                public void actionPerformed( ActionEvent e ){
                                  activeButtonIdx = idx;
                                  subSelections[idx].setEnabled( true );
                                  subSelections[idx].setVisible( true );
                               }
                       } );
     }
     optButtons[ 2 ].addActionListener(  new  ActionListener(){
                     public void actionPerformed( ActionEvent e ){
                         activeButtonIdx = 2;
                         amns.setEnabled( true );
                         amns.setVisible( true );
                     }
     } );
  }
}