package clarion.options.nacs;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionAem extends SelectionTemplate{
  JFrame superFrame;
  JLabel capLabel = new JLabel();
 // AEM
 JPanel aemPanel = new JPanel();
 JLabel aemLabel = new JLabel();
 JLabel aemNumLabel1 = new JLabel();
 JLabel aemNumLabel2 = new JLabel();
 JTextField aemNumField = new JTextField();
 JLabel aemProbLabel = new JLabel();
 JTextField aemProbField = new JTextField();
 JLabel aemRlLabel = new JLabel();
 JTextField aemRlField = new JTextField();
 JLabel aemMomLabel = new JLabel();
 JTextField aemMomField = new JTextField();
 JLabel aemBoundLabel = new JLabel();
 JTextField aemBoundField = new JTextField();
 // ACS
 JPanel acsPanel = new JPanel();
 JLabel acsLabel = new JLabel();
 JLabel acsTempLabel = new JLabel();
 JLabel acsProbLabel = new JLabel();
 JLabel acsNumLabel = new JLabel();
 JTextField acsTempField = new JTextField();
 JTextField acsProbField = new JTextField();
 JTextField acsNumField = new JTextField();
 JLabel acsIterLabel1 = new JLabel();
 JLabel acsIterLabel2 = new JLabel();
 JTextField acsIterField = new JTextField();
 JButton returnButton = new JButton();

  public SelectionAem( JFrame superFrame, int width, int height, SettingTransfer transfer )
  {
    super( superFrame, width, height, transfer );
    initGui();
  }

  public void initGui()
  {
    final int AEM_BOUND = 0, AEM_EM_PROB = 1, AEM_EM_ITEM = 2, AEM_EM_LR = 3;
    final int AEM_EM_MOM = 4, AEM_NS_NUM = 5, AEM_ACS_PROB = 6, AEM_ACS_ITEM = 7;
    final int AEM_ACS_ITER = 8, AEM_ACS_TEMP = 9;

    options = transfer.getOptions( Global.NACS, Global.NACS_AEM, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption
    initLabel( capLabel,"AEM   OPTIONS",new java.awt.Font("Dialog", 1, 16),
               SwingConstants.CENTER, new Rectangle(50, 0, 240, 26));
    // training AEM
    initPanel( aemPanel, BORDER, null, new Rectangle(10, 26, 330, 160));
    initLabel( aemLabel, "Parameters for training AEM", new Rectangle(4, 6, 320, 17) );
    initLabel( aemProbLabel, "probability of training AEM at each step", new Rectangle(8, 28, 221, 17));
    initField( aemProbField, String.valueOf(options[AEM_EM_PROB].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(235, 28, 32, 17), 4, options[AEM_EM_PROB], 0, 0 );
    initLabel( aemNumLabel1, "number of action-centered EM items to pick for", new Rectangle(8, 48, 300, 17));
    initLabel( aemNumLabel2, "training AEM", new Rectangle(8, 68, 88, 17));
    initField( aemNumField, String.valueOf(options[AEM_EM_ITEM].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(104, 68, 32, 17), 4, options[AEM_EM_ITEM], 0, 0 );
    initLabel( aemRlLabel, "BP learning rate for training AEM", new Rectangle(8, 88, 200, 17));
    initField( aemRlField, String.valueOf(options[AEM_EM_LR].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(208, 88, 32, 17), 4, options[AEM_EM_LR], 0, 0 );
    initLabel( aemMomLabel, "BP momentum for traIning AEM", new Rectangle(8, 108, 190, 17));
    initField( aemMomField, String.valueOf(options[AEM_EM_MOM].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(200, 108, 32, 17), 4, options[AEM_EM_MOM], 0, 0 );
    initLabel( aemBoundLabel, "Max # of states involved", new Rectangle(8, 128, 170, 17));
    initField( aemBoundField, String.valueOf(options[AEM_BOUND].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(178, 128, 32, 17), 4, options[AEM_BOUND], 0, 0 );
    // traing ACS
    initPanel( acsPanel, BORDER, null, new Rectangle(10, 200, 330, 150));
    initLabel( acsLabel,"Parameters for using AEM to train ACS",new Rectangle(4, 6, 221, 17));
    initLabel( acsProbLabel,"probability of using AEM to train ACS",new Rectangle(8, 32, 206, 17));
    initField( acsProbField, String.valueOf(options[AEM_ACS_PROB].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(226, 32, 32, 17), 4, options[AEM_ACS_PROB], 0, 0 );
    initLabel( acsNumLabel,"number of  AEM  samples to pick for training ACS", new Rectangle(8, 54, 280, 17));
    initField( acsNumField, String.valueOf(options[AEM_ACS_ITEM].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(290, 54, 32, 17), 4, options[AEM_ACS_ITEM], 0, 0 );
    initLabel( acsIterLabel1,"number of  times each selected item is presented to",
               new Rectangle(8, 76, 310, 17));
    initLabel( acsIterLabel2, "ACS for training ACS", new Rectangle(8, 98, 123, 17));
    initField( acsIterField, String.valueOf(options[AEM_ACS_ITER].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(140, 98, 32, 17), 4, options[AEM_ACS_ITER], 0, 0 );
    initLabel( acsTempLabel, "temperature for output selection", new Rectangle(8, 120, 185, 17));
    initField( acsTempField, String.valueOf(options[AEM_ACS_TEMP].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(200, 120, 32, 17), 4, options[AEM_ACS_TEMP], 0, 0  );
    // RETTURN BUTTONS.
    initReturnButton( returnButton, "RETURN", new Rectangle(250, 360, 80, 29));
    aemPanel.add(aemLabel, null);
    aemPanel.add(aemProbField, null);
    aemPanel.add(aemNumLabel2, null);
    aemPanel.add(aemNumField, null);
    aemPanel.add(aemProbLabel, null);
    aemPanel.add(aemNumLabel1, null);
    aemPanel.add(aemRlLabel, null);
    aemPanel.add(aemRlField, null);
    aemPanel.add(aemMomLabel, null);
    aemPanel.add(aemMomField, null);
    aemPanel.add(aemBoundLabel, null);
    aemPanel.add(aemBoundField, null);
    acsPanel.add(acsLabel, null);
    acsPanel.add(acsProbField, null);
    acsPanel.add(acsNumField, null);
    acsPanel.add(acsTempLabel, null);
    acsPanel.add(acsTempField, null);
    acsPanel.add(acsProbLabel, null);
    acsPanel.add(acsNumLabel, null);
    acsPanel.add(acsIterLabel1, null);
    acsPanel.add(acsIterLabel2, null);
    acsPanel.add(acsIterField, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(aemPanel, null);
    this.getContentPane().add(acsPanel, null);
    this.getContentPane().add(returnButton, null);
    update();
  }

  public void update()
  {
      /*
      if( transfer.isAemOn() ){
          aemPanel.setEnabled( true );
          for( int i = 0; i < aemPanel.getComponentCount(); i++ )
               aemPanel.getComponent(i).setEnabled( true );
          acsPanel.setEnabled( true );
          for( int i = 0; i < acsPanel.getComponentCount(); i++ )
               acsPanel.getComponent(i).setEnabled( true );
      }
      else{
          aemPanel.setEnabled( false );
          for( int i = 0; i < aemPanel.getComponentCount(); i++ )
               aemPanel.getComponent(i).setEnabled( false );
          acsPanel.setEnabled( false );
          for( int i = 0; i < acsPanel.getComponentCount(); i++ )
               acsPanel.getComponent(i).setEnabled( false );
      }
      */
  }
}