package clarion.options.nacs;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionCor extends SelectionTemplate{
  JFrame superFrame;
  JLabel capLabel = new JLabel();
  JPanel corPanel = new JPanel();
  JLabel corLabel = new JLabel();
  JRadioButton[] corButtons = new JRadioButton[2]; {
     corButtons[0] = new JRadioButton();
     corButtons[1] = new JRadioButton();
  }
  // reasoning
  JPanel reasonPanel = new JPanel();
  JLabel reasonLabel = new JLabel();
  JLabel reasonLabel1 = new JLabel();
  JRadioButton[] reasonButtons = new JRadioButton[6]; {
     for( int i = 0; i < 6; i++ )
          reasonButtons[i] = new JRadioButton();
  }
  JLabel iterLabel = new JLabel();
  JRadioButton[] iterButtons = new JRadioButton[2]; {
     for( int i = 0; i < 2; i++ )
          iterButtons[i] = new JRadioButton();
  }
  JTextField iterField = new JTextField();
  // return buttons.
  JButton returnButton = new JButton();

  public SelectionCor( JFrame superFrame, int width, int height, SettingTransfer transfer )
 {
    super( superFrame, width, height, transfer );
    initGui();
 }

 public void initGui()
 {
    final int COR = 0, GKS = 1, ITER = 2;
    options = transfer.getOptions( Global.NACS, Global.NACS_COR, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption
    initLabel( capLabel, "OPTIONS OF COORDINATING ACS AND NACS", new java.awt.Font("Dialog", 1, 14),
               SwingConstants.CENTER, new Rectangle(16, 2, 327, 26));
    // coordinate
    initPanel( corPanel, BORDER, null, new Rectangle(10, 30, 336, 70));
    String[] corTexts = {"action-directed reasoning", "user defined"};
    Rectangle[] corRects = {new Rectangle(12, 28, 164, 17), new Rectangle(12, 48, 140, 17)};
    initButtonBlock( corPanel,corLabel,"Option for coordinating ACS/NACS",new Rectangle(8, 4, 197, 17),
                     corButtons, corTexts, corRects, options[COR] );
    // reasoning
    initPanel( reasonPanel, BORDER, null, new Rectangle(10, 110, 336, 240));
    initLabel( reasonLabel, "Option and parameters for action-directed reasoning",new Rectangle(8, 7, 300, 17));
    String[] reasonTexts = {"forward chaining","backward chaining","similarity-based forward reasoning",
           "counterfactual reasoning","proof by contradiction","determined by ACS"};
    Rectangle[] reasonRects = {new Rectangle(15, 51, 120, 17),new Rectangle(15, 71, 128, 17),
                new Rectangle(15, 91, 222, 17), new Rectangle(15, 110, 163, 17),
                new Rectangle(16, 130, 158, 17), new Rectangle(15, 150, 158, 17)};
    initButtonBlock( reasonPanel, reasonLabel1, "GKS reasoning method", new Rectangle(12, 32, 140, 17),
                     reasonButtons, reasonTexts, reasonRects, options[GKS] );
    // # of iterations.
    initField( iterField, String.valueOf(options[ITER].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(150, 196, 32, 17) );
    String[] iterTexts = {"specify a number","determined by ACS"};
    Rectangle[] iterRects = {new Rectangle(15, 196, 120, 17), new Rectangle(15, 216, 140, 17)};
    initButtonBlock( reasonPanel, iterLabel, "number of iterations of reasoning", new Rectangle(12, 176, 191, 17),
                     iterButtons, iterTexts, iterRects, options[ITER], 0, iterField );
    // return buttons.
    initReturnButton( returnButton, "RETURN", new Rectangle(250, 366, 80, 28));
    corPanel.add(corLabel, null);
    reasonPanel.add(reasonLabel, null);
    reasonPanel.add(reasonLabel1, null);
    reasonPanel.add(iterField, null);
    this.getContentPane().add(corPanel, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(reasonPanel, null);
    this.getContentPane().add(returnButton, null);
  }
}