package clarion.options.nacs.amn;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.options.*;

public class GuiAmn extends GuiTemplate{

  String buttonTexts[];
  SelectionTemplate[] amns;

  public GuiAmn( int netNum )
  {
     super( Global.MAX_AMN_NUM, "OPTIONS OF ASSOCIATIVE MEMRORY NETWROKS" );
     buttonTexts = new String[ OPT_NUM ];
     for( int i = 0; i < OPT_NUM; i++ )
          buttonTexts[i] = "Network - " + String.valueOf( i + 1 );
     setButtonTexts( buttonTexts );
     for( int i = netNum; i < Global.MAX_AMN_NUM; i++ ){
          optButtons[i].setEnabled( false );
          optButtons[i].setVisible( false );
     }
     amns = new SelectionTemplate[ OPT_NUM ];
     for( int i = 0; i < OPT_NUM; i++ ){
          amns[ i ] = new SelectionAmn( this, 400, 500, i, transfer );
     }
  }

  // used to update components in the GUI.
  public void updateGui()
  {
     int amnNum = transfer.getAmnNum();
     if( OPT_NUM > amnNum ){
         for( int i = 0; i < amnNum; i++ ){
              optButtons[i].setEnabled( true );
              optButtons[i].setVisible( true );
              ((SelectionAmn)amns[i]).update();
         }
         for( int i = amnNum; i < OPT_NUM; i++ ){
              optButtons[i].setEnabled( false );
              optButtons[i].setVisible( false );
         }
         OPT_NUM = amnNum;
     }
     else if( OPT_NUM < amnNum ){
              OPT_NUM = Math.min( Global.MAX_AMN_NUM, amnNum );
              for( int i = 0; i < OPT_NUM; i++ ){
                   optButtons[i].setEnabled( true );
                   optButtons[i].setVisible( true );
                   ((SelectionAmn)amns[i]).update();
              }
              for( int i = OPT_NUM; i < Global.MAX_AMN_NUM; i++ ){
                   optButtons[i].setEnabled( false );
                   optButtons[i].setVisible( false );
              }
          }
          else{
              for( int i = 0; i < OPT_NUM; i++ )
                   ((SelectionAmn)amns[i]).update();
          }
  }

  public void addActionListeners( final JFrame mainFrame )
  {
     for( int i = 0; i < OPT_NUM; i++ ){
          final int idx = i;
          optButtons[ idx ].addActionListener(  new  ActionListener(){
                            public void actionPerformed( ActionEvent e ){
                               activeButtonIdx = idx;
                               amns[idx].setEnabled( true );
                               amns[idx].setVisible( true );
                               setEnabled( false );
                            }
                    } );
     }
  }
}