package clarion.options.nacs.amn;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionAmn extends SelectionTemplate{
 int netIdx;

 JFrame superFrame;
 // caption
 JLabel capLabel = new JLabel();
 // general
 JPanel genPanel = new JPanel();
 JLabel ioLabel = new JLabel();
 JLabel amnTypeLabel = new JLabel();
 JRadioButton[] amnTypeButtons = new JRadioButton[2]; {
    amnTypeButtons[0] = new JRadioButton();
    amnTypeButtons[1] = new JRadioButton();
 }
 JButton inDimButton = new JButton();
 JButton outDimButton = new JButton();
 JLabel hideUnitLabel = new JLabel();
 JTextField hideUnitField = new JTextField();
 // pass
 JPanel passPanel = new JPanel();
 JLabel passLabel = new JLabel();
 JRadioButton[] passButtons = new JRadioButton[2]; {
    passButtons[0] = new JRadioButton();
    passButtons[1] = new JRadioButton();
 }
 JLabel passNumLabel = new JLabel();
 JTextField passNumField = new JTextField();
 // AAM or HAM
 JPanel assimPanel = new JPanel();
 JLabel assimLabel = new JLabel();
 JLabel assimProbLabel = new JLabel();
 JTextField assimProbField = new JTextField();
 JLabel assimNumLabel1 = new JLabel();
 JLabel assimNumLabel2 = new JLabel();
 JTextField assimNumField = new JTextField();
 JLabel assimIterLabel = new JLabel();
 JTextField assimIterField = new JTextField();
 JLabel assimTypeLabel = new JLabel();
 JRadioButton[] assimTypeButtons = new JRadioButton[2]; {
    assimTypeButtons[0] = new JRadioButton();
    assimTypeButtons[1] = new JRadioButton();
 }
 // learn
 JPanel learnPanel = new JPanel();
 JLabel learnLabel = new JLabel();
 JLabel lrLabel = new JLabel();
 JTextField lrField = new JTextField();
 JLabel momLabel = new JLabel();
 JTextField momField = new JTextField();
 // return.
 JButton returnButton = new JButton();
 OptionDims[] optDims = new OptionDims[2];

 public SelectionAmn( JFrame superFrame, int width, int height, int netIdx, SettingTransfer transfer )
 {
    super( superFrame, width, height, transfer );
    this.netIdx = netIdx;
    initGui();
 }

 public void initGui()
 {
    final int AMN_TYPE = 0, IN_DIM_TYPE = 1, OUT_DIM_TYPE = 2, IN_DIM_IDX = 3;
    final int OUT_DIM_IDX = 4, UNITS = 5, PASS = 6, L_RATE = 7, MOM = 8;
    final int TRAIN_PROB = 9, PATTERN_NUM = 10, ITER_NUM = 11, AAM_TYPE = 12;

    options = transfer.getOptions( Global.NACS, Global.NACS_AMN, netIdx, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    String[] onOffTexts = { "ON", "OFF" };
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption
    initLabel( capLabel, "OPTIONS FOR EACH AMN ( AMN # = " + netIdx + " )", new java.awt.Font("Dialog", 1, 14),
               SwingConstants.CENTER, new Rectangle((width-300)/2, 0, 300, 26) );
    // general
    initPanel( genPanel, BORDER, null, new Rectangle(10, 26, 370, 100));
    initLabel( ioLabel, "AMN general options", new Rectangle(4, 4, 120, 17));
    String[] amnTypeTexts = { "AAM", "HAM" };
    Rectangle[] amnTypeRects = {new Rectangle(170, 28, 60, 17),new Rectangle(230, 28, 60, 17)};
    initButtonBlock( genPanel, amnTypeLabel, "AMN type of this network", new Rectangle(8, 28, 160, 17),
                     amnTypeButtons, amnTypeTexts, amnTypeRects, options[AMN_TYPE], 1, assimTypeButtons );
    initButton( inDimButton, "dimensions in input", new Rectangle( 20, 48, 150, 20));
    initButton( outDimButton, "dimensions in output", new Rectangle( 190, 48, 160, 20));
    // frames for dimension selection
    optDims[0] = new OptionDims( this, 420, 780, "IDN INPUT SPECIFICATION", 30, transfer,
        options[IN_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue(), options[IN_DIM_IDX] );
    optDims[1] = new OptionDims( this, 420, 780, "IDN OUTPUT SPECIFICATION", 30, transfer,
        options[OUT_DIM_TYPE].getOptionItem(0).getParameter(0).getIntValue(), options[OUT_DIM_IDX] );
    initDimButton( this, inDimButton, optDims[0] );
    initDimButton( this, outDimButton, optDims[1] );
    initLabel( hideUnitLabel, "Number of hidden units", new Rectangle(8, 78, 328, 17));
    initField( hideUnitField, String.valueOf( options[UNITS].getOptionItem(0).getParameter(1).getIntValue()),
               new Rectangle(144, 78, 32, 17), 4, options[UNITS], 0, 1 );
    // pass
    initPanel( passPanel, BORDER, null, new Rectangle(10, 130, 370, 50));
    String[] passTexts = {"one pass", "multiple pass",};
    Rectangle[] passRects = {new Rectangle(160, 4, 80, 17), new Rectangle(240, 4, 100, 17)};
    initButtonBlock( passPanel, passLabel, "Options for using AMN", new Rectangle(4, 4, 144, 17),
                     passButtons, passTexts, passRects, options[PASS], 1, passNumField );
    initLabel( passNumLabel,"if multiple pass, the number of iterations", new Rectangle(8, 24, 240, 17));
    initField( passNumField, String.valueOf( options[PASS].getOptionItem(1).getParameter(0).getIntValue()),
               new Rectangle(250, 24, 32, 17));
    // BP learning in AMN
    initPanel( learnPanel, BORDER, null, new Rectangle(10, 184, 370, 46));
    initLabel( learnLabel,"Parameters for BP learning in AMN", new Rectangle(4, 4, 202, 17) );
    initLabel( lrLabel, "BP learning rate", new Rectangle(8, 24, 96, 17));
    initField( lrField, String.valueOf( options[L_RATE].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(104, 24, 32, 17), 4, options[L_RATE], 0, 0 );
    initLabel( momLabel, "BP momentum", new Rectangle(176, 24, 96, 17));
    initField( momField, String.valueOf( options[MOM].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(272, 24, 32, 17), 4, options[MOM], 0, 0 );
    // AAM or HAM
    initPanel( assimPanel, BORDER, null, new Rectangle(10, 234, 370, 170));
    initLabel( assimLabel, "Options and parameters for AMN assimilation", new Rectangle(4, 4, 258, 17) );
    initLabel( assimProbLabel,"probability of the network training at each step",new Rectangle(8, 26, 270, 17));
    initField( assimProbField, String.valueOf(options[TRAIN_PROB].getOptionItem(0).getParameter(0).getDoubleValue()),
               new Rectangle(280, 26, 32, 17), 4, options[TRAIN_PROB], 0, 0 );
    initLabel( assimNumLabel1, "number of items (data patterns for AAM, associative mappings",
               new Rectangle(8, 46, 370, 17)) ;
    initLabel( assimNumLabel2, "for HAM) from EM to pick for training at each step", new Rectangle(8, 66, 290, 17)) ;
    initField( assimNumField, String.valueOf(options[PATTERN_NUM].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(300, 66, 32, 17), 4, options[PATTERN_NUM], 0, 0 );
    initLabel( assimIterLabel, "number of training iterations for each data pattern",
               new Rectangle(8, 86, 288, 17) );
    initField( assimIterField, String.valueOf(options[ITER_NUM].getOptionItem(0).getParameter(0).getIntValue()),
               new Rectangle(300, 86, 32, 17), 4, options[ITER_NUM], 0, 0 );
    String[] assimTypeTexts = { "default( experienced states )", "user defined" };
    Rectangle[] assimTypeRects = { new Rectangle(12, 126, 184, 17), new Rectangle(12, 146, 184, 17) };
    initButtonBlock( assimPanel, assimTypeLabel, "If an AAM, select type of data pattern for training AAM",
        new Rectangle(8, 106, 320, 17), assimTypeButtons, assimTypeTexts, assimTypeRects, options[AAM_TYPE]);
    // return button.
    initReturnButton( returnButton, "RETURN", new Rectangle(260, 420, 110, 29));
    genPanel.add(ioLabel, null);
    genPanel.add(inDimButton, null);
    genPanel.add(outDimButton, null);
    genPanel.add(hideUnitLabel, null);
    genPanel.add(hideUnitField, null);
    passPanel.add(passLabel, null);
    passPanel.add(passNumLabel, null);
    passPanel.add(passNumField, null);
    assimPanel.add(assimLabel, null);
    assimPanel.add(assimProbLabel, null);
    assimPanel.add(assimProbField, null);
    assimPanel.add(assimNumLabel1, null);
    assimPanel.add(assimNumLabel2, null);
    assimPanel.add(assimNumField, null);
    assimPanel.add(assimIterLabel, null);
    assimPanel.add(assimIterField, null);
    learnPanel.add(learnLabel, null);
    learnPanel.add(momLabel, null);
    learnPanel.add(lrLabel, null);
    learnPanel.add(lrField, null);
    learnPanel.add(momField, null);
    this.getContentPane().add(genPanel, null);
    this.getContentPane().add(capLabel, null);
    this.getContentPane().add(passPanel, null);
    this.getContentPane().add(assimPanel, null);
    this.getContentPane().add(learnPanel, null);
    this.getContentPane().add(returnButton, null);
 }

 public void update()
 {
 }
}