package clarion.options.taskspec;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import clarion.options.*;
import clarion.system.*;

public class SelectionTaskSpec extends SelectionTemplate {
 JFrame superFrame;

 JLabel capLabel = new JLabel();
 JPanel panel = new JPanel();
 // record information
 JLabel recordLabel = new JLabel();
 JCheckBox[] recordBoxes = new JCheckBox[5];{
    for( int i = 0; i < 5; i++ )
         recordBoxes[i] = new JCheckBox();
 }
 // return buttons.
 JButton returnButton = new JButton();

 public SelectionTaskSpec( JFrame superFrame, int width, int height, SettingTransfer transfer )
  {
    super( superFrame, width, height, transfer );
    initGui();
  }

 public void initGui()
 {
    final int RECORD = 0;

    options = transfer.getOptions( Global.TS, 0, 0, 0, 0, 0 );
    Border BORDER = BorderFactory.createLineBorder(Color.black);
    Color COLOR = SystemColor.activeCaption;
    setSize( width, height );
    this.getContentPane().setLayout(null);
    // caption.
    initLabel( capLabel, "TASK SPECIFIC OPTIONS", new java.awt.Font("Dialog", 1, 14),
               SwingConstants.CENTER, new Rectangle(50, 0, 200, 26) );
    initPanel( panel, BORDER, null, new Rectangle(10, 30, 300, 200));
    // the information to record.
    String[] recordBoxTexts = { "input (state)", "output (aciton)", "new state", "reinforcement",
                                "response time" };
    Rectangle[] recordBoxRects = { new Rectangle(10, 30, 150, 17), new Rectangle(10, 50, 150, 17),
                                  new Rectangle(10, 70, 150, 17), new Rectangle(10, 90, 150, 17),
                                  new Rectangle(10, 110, 150, 17)
                                };
    initCheckBoxBlock( panel, recordLabel, "the information to record", new Rectangle(10, 10, 200, 17),
                       recordBoxes, recordBoxTexts, recordBoxRects, options[RECORD] );
    // return buttons.
    initReturnButton( returnButton, "RETURN", new Rectangle(200, 240, 100, 25));
    // add components.
    this.getContentPane().add( capLabel, null );
    this.getContentPane().add( panel, null );
    this.getContentPane().add( returnButton, null );
  }
}