package clarion.system;
import java.lang.Class;
import clarion.common.*;
import clarion.acs.*;
import clarion.nacs.*;
import clarion.ms.*;
import clarion.mcs.*;
import clarion.acs.gs.*;
import clarion.acs.wm.*;
import clarion.tools.*;

public class Global{

 // class loader.
 ClarionClassLoader classLoader;
 /*************************** global constants. *******************************/
 /****************** constants for parameter types ****************************/
 final public static int PRIM_TYPE = 0, ARRAY_TYPE = 1;
 final public static int BOOL = 0, INT = 1, DOUBLE = 2, STRING = 3;
 final public static String VALUE_DELIM = ",;";
 /****************** constants for option settings ****************************/
 final public static int MAX_TASK_NUM = 20, MAX_SETTING_NUM = 20;
 final public static int SAVE_TO_GLOBAL = 0, SAVE_TO_FILES = 1;

 /************ constants for user interface.*********************/
 final public static int SUBSYS_NUM = 8;
 final public static int ACS = 0, NACS = 1, SUPER = 2, RT = 3, INTERFACE = 4,
                         DIMS = 5, TS = 6, SUBSYS = 7;
 // indices for major ACS options.
 final public static int ACS_COMP_NUM = 4;
 final public static int ACS_COMP = 0, ACS_NET = 1, ACS_WM = 2, ACS_GS = 3;
 final public static int ACS_NET_OPT_NUM = 4;
 final public static int EX_NET = 0, WM_NET = 1, GS_NET = 2, ACS_COR = 3;
 final public static int ACS_NET_COMP_NUM = 5;
 final public static int ACS_IDN = 0, ACS_RER = 1, ACS_IRL = 2, ACS_FR = 3, ACS_BASIC = 4;
 final public static int MAX_EX_NET_NUM = 4;
 final public static int MAX_RULE_NUMS[] = { 1, 1, 15, 15 };
 // indices for major NACS options.
 final public static int NACS_COMP_NUM = 5;
 final public static int NACS_COMP = 0, NACS_GKS = 1, NACS_AMN = 2, NACS_AEM = 3, NACS_COR = 4;
 final public static int MAX_AMN_NUM = 2;
 final public static int SUPER_COMP_NUM = 5;
 final public static int SUPER_COMP = 0, SUPER_MS = 1, SUPER_MCS = 2;
 // indices for major supervisory options.
 // indices for major RT options.
 // constants for the format of ACS action controlling NACS.
 final public static int D_TYPE = 0, D_ACT = 1, D_STAGE = 2, D_INFER = 3, D_REPORT = 4;
 final public static int D_CUE = 5, D_OUTPUT = 6, D_TIME = 7, D_WM = 8;
 final public static int DO_NOTHING = 0, RETRIEVAL_ONE = 1, RETRIEVAL_ALL = 2;
 // constants for minor options in each major option.
 final public static int FEAT_INPUT = 0, FEAT_OUTPUT = 1, FEAT_INTERNAL = 2;  // feature types.
 final public static int FEAT_GS_ACTION = 0, FEAT_WM_ACTION = 1, FEAT_GOAL = 2; // INTERNAL features
 final public static int AEM = 1;
 final public static int AAM = 0, HAM = 1;
 final public static int EMPTY = -1, CONSTANT_OPTION = 0, VARIED_OPTION = 1;
 final public static int EX_TYPE = 0, WM_TYPE = 1, GS_TYPE = 2;
 final public static int GS_STACK = 0, GS_LIST = 1, GS_NON = 2;
 final public static int INPUT = 0, HIDDEN = 1, OUTPUT = 2;
 final public static int ACS_KNOW_TYPE_NUM = 4;
 final public static int BL = 0, TL = 1, RER = 1, IRL = 2, FR = 3;
 final public static int ORDINAL = 0, NOMINAL = 1;
 final public static int QL = 0, SQL = 1, BP = 2, FIX = 3, BL_BY_MCS = 4;
 final public static int REIN_ALL = 0, REIN_EACH = 1;
 final public static int FORWARD_CHAIN = 0, BACK_CHAIN = 1, SB_FORWARD_CHAIN = 2,
                         COUTER_REASON = 3, PROOF_CONTRA = 4, REASON_BY_MCS = 5;
 final public static int GENERALIZATION = 0, SPECIFICATION = 1;
 final public static int NO_GEN_SPEC = 0, SPEC_TO_GEN = 1, GEN_TO_SPEC = 2, DBL_DIRECT = 3;
 final public static int POS_MATCH_TYPE = 0, NEG_MATCH_TYPE = 1;
 final public static int GS_CONTI_VAL = 0, GS_NCONT_VAL = 1, GS_ONE_ALL_VALUE = 2;
 final public static int NO_MERGE = 0, MERGE_PER_ONE = 1, MERGE_PER_TEN = 3;
 final public static int UTL_BENE = 0, UTL_COST = 1, UTL_V = 2, UTL_C7 = 3, UTL_C8 = 4;
 final public static int BLA_C = 0, BLA_D = 1, BLA_I = 2;
 final public static int ACTION_BY_TL = 0, ACTION_BY_BOTH = 1;
 final public static int COMB_BY_MCS = 0, COMB_NBY_MCS = 1;
 final public static int FIX_COMB_MODE = 0, VAR_COMB_MODE = 1, CT_COMB_MODE = 2;
 final public static int STOCH_COMB_MODE = 0, BU_COMB_MODE = 1, TG_COMB_MODE = 2;
 final public static int CHK_STATE_DIM = 0, CHK_ACTION_DIM = 1, CHK_REWARD = 2, CHK_STEP = 3,
                         CHK_STATE = 4, CHK_ACTION = 5, CHK_ACTION_RULE = 6, CHK_CUE = 7,
                         CHK_RETRIEVAL = 8, CHK_COMB = 9, CHK_ASSOC = 10, CHK_GOAL = 11;
 final public static String[] CHUNK_TYPE_LABELS ={
                         "STATE DIM", "ACTION DIM", "REWARD", "STEP",
                         "STATE", "ACTION", "ACTION RULE", "CUE",
                         "RETRIEVAL", "COMB", "ASSOC", "GOAL"
                     };
 final public static int STEP_COMP_NUM = 4;
 final public static int CUR_STATE = 0, CUR_ACTION = 1, NEXT_STATE = 2, REWARD = 3;
 final public static int COR_EXT_ALL = 0, COR_EXT_ONE = 1;
 final public static int RULE_BASED = 0, SIMI_BASED = 1;
 final public static int ONE_PASS = 0, MULTI_PASS = 1;
 final public static int ADR_REASON = 0, ADM_REASON = 1;
 final public static int NO_DISPLAY = 0, DISP_INPUT = 1, DISP_BOTH = 2;
 final public static int EVERY_STEP = 1, EVERY_X_STEP = 2;
 /*-------------------------  CLARION SETTINGS -------------------------------*/
  Clarion clarion;
  boolean nacsOn;
  boolean superOn;
  boolean rtOn;
 /*---------------------------------------------------------------------------*/
/*---------------------------FEATURES INFORMATION.----------------------------*/
 int     featureTypeNum;             // GS, STATE, ACTION, REWARD, NORMAL features.
 short[] featureNums;                // feature # in each type.
 short[] featureLengths[];           // the length of each feature.
 String  featureNames[][];           // names of features
 String  featureValueNames[][][];    // names of feature values.
 /*---------------------------------------------------------------------------*/
 /*=============== SETTINGS ABOUT ACTION-CENTERED SUBSYSTEM ==================*/
 /******************** SETTINGS ABOUT ACS COMPONENTS **************************/
  int     acsNetNum;            // all nets including EX, WM, GS if exist.
  int     exNetNum;
  int     wmNetIdx;             // the WM net indice.
  int     gsNetIdx;             // the GS net indice.
  int     gsOption;
  boolean wmOn;
  boolean gsIdnOn;
  boolean wmIdnOn;
  //int     acsInputDimNum;       // used for EM.
  //short[]   acsActionNums;        // action # of each net.
  //short[] acsActionDimNums;     // dim # of net's action.
  //short[] acsActionFeatureInfo[][];
  // acsActionReps: dim_1 : netIdx, dim_2 : actionIdx,( value of each action-dim an action has ).
  //short[] acsActionReps[][];
  //short[] acsRewardNums;
  //short[] acsRewardDimNums;
  //double  acsRewards[][];
  short[] inputDimCharacters;
 /************************** SETTINGS ABOUT IDN *******************************/
  short[] idnInputDimVals[];
  short[] idnOutputDimVals[];
  short[] idnInputFeatureInfo[][];
  short[] idnOutputFeatureInfo[][];
  short[] idnHiddenNums;
  String  exIdnEligibleConditions[];
  short[] idnBLLearningOptions;
  short[] idnBlAssimFreqs[];
  double  idnBPLRs[];
  double  idnBPMoms[];
  double  idnQDiscountRates[];
  double  idnActionSelTemps[];
  double  overallActionSelTemps[];
  short   idnRLFuncOpts[];
  String  overallIdnRLFunction;
  String  idnRLFunctions[];
  boolean idnRLFuncByMCSs[];
 /************************** SETTINGS ABOUT ARS *******************************/
  short[] arInputDimVals[][];
  short[] arOutputDimVals[][];
  short[] arInputFeatureInfo[][][];
  short[] arOutputFeatureInfo[][][];
  double  arActionSelTemps[][];
  short[] arReasoningMethods[];
  boolean arReasoningByMCSOns[][];
 /********************* SETTINGS ABOUT RULE LEARNING **************************/
  int     acsKnowledgeNum;
  boolean rerOns[];
  boolean irlOns[];
  boolean extInstructOns[];
  boolean ilOns[];
  boolean frOns[];
  boolean frActionVariedOns[][];
  boolean acsRLByMCSs[];
  int     maxRerRuleNum;
  String  frSets[][];
  short[] frConditions[][][];
  short[] frActions[][];
  short[] frNums;
  short[] irlSetNums;
  String  irlSets[][][];
  short[] irlRuleNums[];
  double  irlRuleParams[][][][];
  boolean irlGenOns[];
  boolean irlSpecOns[];
  double  d_is[];
  double  d_rs[];
  double  p_res[];
  short[] rerGenSpecModes;
  short[] irlGenSpecModes;
  String  rerPosCriterions[];
  String  irlPosCriterions[];
  double  threshold_RERs[];
  double  threshold_IRLs[];
  String  rerIGMeasures[];
  String  irlIGMeasures[];
  double  c1s[];
  double  c2s[];
  double  c5s[];
  double  c6s[];
  double  threshold1s[];    // for RER GEN
  double  threshold2s[];    // for RER SPEC
  double  threshold6s[];    // for IRL GEN
  double  threshold7s[];    // for IRL SPEC
  double  threshold4s[];    // for IRL deletion
  short[] rerGsValueRanges;
  short[] irlGsValueRanges;
  short[] ruleMergeIntervals;
 /******************* SETTINGS ABOUT RULE REPRESENTATIN ***********************/
  boolean ruleUtilityOns[][][];
  boolean ruleSupportOns[][][];
  boolean rulePartMatchOns[][][];
  boolean ruleBlaOns[][][];
  boolean actionChunkBlaOns[][][];
  short   actionRuleWeightModes[][][];
  short   actionRuleBlaOptions[][][];
  double  actionRuleBlas[][][];
  double  actionRuleBlaParas[][][][];
  short   ruleUtilityOptions[][][];
  double  ruleUtilityParas[][][][];
  short   acsChunkBlaOptions[][][];
  double  acsChunkBlas[][][];
  double  acsChunkBlaParas[][][][];
 /********************* SETTINGS ABOUT GOAL STRUCTURE *************************/
  GoalStructure gs;
  String  goalFeatLabels[];
  String  goalChunkLabels[];
  short[] goals[][];
  int     size_gc;
  short[] goalParaDimVals;
  int     size_g;
  double  threshold_GS;
  int     goalDecisionMode;
  int     goalBlaOption;
  double  goalBla;
  double  goalBlaParas[];
  double  P_EXT;
  double  P_GS;
  short[] gsItemDimInfo[];   // item dim info.
  int     gsItemLength;      // length of GS item with sum of all dim lengths including GOAL dim.
  int     gsInputLength;     // length of GS as input to IDN.
 /********************* SETTINGS ABOUT WORKING MEMORY *************************/
  WM      wm;
  int     size_wm;
  double  threshold_WM;
  boolean wmFlagsOn;
  int     wmActionDecisionMode;
  int     wmActionFlagDecisionMode;
  int     wmBlaOption;
  double  wmBla;
  double  wmBlaParas[];
  short[] wmItemNums;         // item # in each WM section.
  short[] wmItemDimInfos[][]; // item dim info in a WM section.
  short[] wmItemLengths;      // length of each WM item with sum of all dim lengths.
  int     wmInputLength;      // length of WM as input to IDN.
 /***************** SETTINGS ABOUT COORDINATING ARS AND IDN *******************/
  boolean overrideByIdnOn;
  int     combineDeterMode;
  short   acsCrossCombModes[][];  //element 0: STOCH, BU, TG; element 1: FIX, VAR, CT.
  double  acsCrossCombParas[][];
  double  c3s[][];
  double  c4s[][];
  int     corMultiExtMode;
 /*===========================================================================*/
 /*============= SETTINGS ABOUT NON-ACTION-CENTERED SUBSYSTEM ================*/
 /******************** SETTINGS ABOUT NACS COMPONENTS *************************/
  boolean gksOnFlag;
  boolean emOnFlag;
  boolean aemOnFlag;
 /******************** SETTINGS ABOUT GKS REPRESENATIONS **********************/
  short[] gksInputDimVals;
  short[] gksOutputDimVals;
  short[] gksInputFeatureInfo[];
  short[] gksOutputFeatureInfo[];
  int     gksMaxChunkNum = 200;
  double  gksOutputTemperature;
  boolean esChunkOnFlag;
  boolean epiChunkOnFlag;
  boolean assocUtilityOn;
  boolean assocSupportOn;
  boolean assocPartMatchOn;
  boolean assocBlaOn;
  boolean nacsChunkBlaOn;
  int     assocUtilityOption;
  double  assocUtilityParas[];
  int     assocWeightMode;
  int     assocBlaOption;
  double  assocBla;
  double  assocBlaParas[];
  int     chunkBlaOption;
  double  chunkBla;
  double  chunkBlaParas[];
  short[] emBlaOptions;
  double  emBlas[];
  double  emBlaParas[][];
  double  threshold_EM;
  int     emCapacity = 50;
  double  emTrainProb;
  int     c9;
  int     c10;
  double  threshold_sim;
  double  c14;
  double  c15;
 /*********************** SETTINGS ABOUT GKS LEARNINGS ************************/
  boolean assocExtractOn;
  boolean assocEncodeExternOn;
  boolean assocAssimiOn;
  boolean chunkEncodeExternOn;
  boolean chunkFromAmnOn;
  boolean chunkByMCSOn;
  double  p_c;
  double  p_a;
  double  d_c;
  double  d_a;
  double  threshold_ae;
  double  threshold_ce;
  double  p_ae;
  double  p_ce;
  int     activationMeasure;
 /******************** SETTINGS ABOUT AMN REPRESENATIONS **********************/
 /*-------- AMN SETTINGS --------*/
  int     amnNum;
  short[] amnTypes;                  // AAM or HAM.
  short[] amnInputChunkTypes;        // the input chunk type of an AMN.
  short[] amnOutputChunkTypes;
  short[] amnInputDimVals[];
  short[] amnOutputDimVals[];
  short[] amnInputFeatureInfo[][];
  short[] amnOutputFeatureInfo[][];
  short[] amnHiddenNums;
  boolean amnMultiPassOns[];
  short   amnIterNum[];
  boolean amnMultiFlagOn;  // allow multiple output values in a dim.
 /*-------- AAM SETTINGS --------*/
  double  aamTrainProb;
  int     aamTrainPatternType;
  int     aamTrainPatternNum;
  int     aamTrainIterNum;
 /*-------- HAM SETTINGS --------*/
  double  hamTrainProb;
  int     hamTrainAssocMapNum;
  int     hamTrainIterNum;
 /*-------- AMN BP SETTINGS --------*/
  double  amnLRs[];
  double  amnMoms[];
 /*-------- AEM SETTINGS --------*/
  int     aemStateNumBound;
  double  aemTrainedByEmProb;
  int     aemTrainedByEmItemNum;
  double  aemTrainedByEmLR;
  double  aemTrainedByEmMom;
  int     aemPotentialNextStateNum;
  double  aemTrainAcsProb;
  int     aemTrainAcsSampleNum;
  int     aemTrainAcsIterNum;
  double  aemTrainAcsOutputTemp;
 /**************** SETTINGS ABOUT COORDINATING ACS and NACS *******************/
  // action-directed reasoning or reasoning for action decision making.
  int     corAcsNacsType;
  boolean reasoningByMCSOn;
  int     gksReasoningMethod;
  int     gksReasonIterNum;
  boolean gksReasonByMCSOn;
  int     admTLReasoningMethod;
  int     admReasonIterNum;
  boolean admReasonByMCSOn;
 /*===========================================================================*/
 /*================== SETTINGS ABOUT SUPERVISORY SUBSYSTEM ===================*/
 boolean msOn;
 boolean mcsOn;
 int c20, c21, c22, c23, c24, c25, c26, c27, c28, c29, c30, c31;
 MCS mcs;
 MS ms;
 /*===========================================================================*/
 /*============== SETTINGS ABOUT RESPONSE TIME DETERMINATION =================*/
  //int     maxUsageNum;
  String  overallFormula;
  String  blFormula;
  String  tlFormula;
  int     PT_BL;
  int     DT_BL;
  int     AT_BL;
  int     PT_TL;
  int     DT_TL_actionTime;
  double  t0;
  double  t1;
  int     AT_TL;
  String  assocAppTimeFormula;
  double  t4;
  double  t5;
  String  chunkRetTimeFormula;
  double  t2;
  double  t3;
  int     t_AMN;
 /*===========================================================================*/
 /*========================= SETTINGS ABOUT INTERFACE ========================*/
  int ruleDisplayMode;
  int ruleDisplayFreq;
 /*===========================================================================*/
 /*---------------------------------------------------------------------------*/
 /*---------------------- TASK-SPECIFIC SETTINGS -----------------------------*/
 /*---------------------------------------------------------------------------*/
  int       episodeLength = 10;       // the length of each episode.
  boolean   learningTestOn;           // testing the learning process flag.
  boolean[] inputFormat;
  boolean[] outputFormat;
  int       agentGroupId;          // identify agent type.
  TaskAgent taskAgent;
  ACS       acs;
  NACS      nacs;
 /*---------------------------------------------------------------------------*/
 /*---------------------- SYSTEM VARIABLE SETTINGS ---------------------------*/
 /*---------------------------------------------------------------------------*/
  String optionName, dataName;
  static String rootDir = System.getProperty( "user.dir" );
  static String optionDir = "taskSetting";
  static String dataDir = "dataFiles";
  static String classDir = "classes";
  static String docDir = "documentation";
  static String srcDir = "sourceCode";
  // implementing some task specific functions, it should override
  // clarion.system.Task.java.
  static Task  task;
  static Class taskClarionClass;
  TaskClarion taskClarion;
  // the task code info.
  static String taskDir = classDir + "\\tasksimulators\\newsimu\\";
  static String taskPkgName = "tasksimulators.newsimu.";
  static String taskClsName = "TaskPC";
  static String taskName = "PC";
  static boolean guiFlag;   // with GUI or without GUI.

 /*************************** CONSTRUCTER *************************************/
 public Global(){}

 /***************************** GET METHODS ***********************************/
 /*--------------------- FEATURES INFORMATION. -------------------------------*/
 public int getFeatureTypeNum(){ return featureTypeNum; }
 public short[] getFeatureNums(){  return featureNums; }
 public short[][] getFeatureLengths(){ return featureLengths; }
 public short[] getFeatureLengths( int typeIdx ){ return featureLengths[typeIdx]; }
 public int getFeatureLength( int typeIdx, int featIdx )
 { return featureLengths[typeIdx][featIdx]; }
 public String[][] getFeatureNames(){ return featureNames; }
 public String[] getFeatureNames( int typeIdx )
 { return featureNames[ typeIdx ]; }
 public String getFeatureNames( int typeIdx, int featIdx )
 { return featureNames[typeIdx][featIdx]; }
 public String[][][] getFeatureValueNames(){ return featureValueNames; }
 public String[][] getFeatureValueNames( int typeIdx )
 { return featureValueNames[typeIdx]; }
 public String[] getFeatureValueNames(int typeIdx, int featIdx )
 { return featureValueNames[typeIdx][featIdx]; }
 public String getFeatureValueNames(int typeIdx, int featIdx, int valIdx )
 { return featureValueNames[typeIdx][featIdx][valIdx]; }
 /******************** SETTINGS ABOUT SYSTEM COMPONENTS ***********************/
 public Clarion getClarion(){ return clarion; }
 public boolean isNacsOn(){ return nacsOn; }
 public boolean isSupervisorySubsysOn(){ return superOn; }
 public boolean isRtOn(){ return rtOn; }
 /******************** SETTINGS ABOUT ACS COMPONENTS **************************/
  public int getAcsNetNum() {
   return (acsNetNum = (isWmOn()&&isGsOn())?exNetNum+2 : (isWmOn()||isGsOn()?exNetNum+1 : exNetNum)); }
  public int getExNetNum(){ return exNetNum; }
  public int getGsOption() { return gsOption; }
  public boolean isGsOn() { return gsOption != GS_NON; }
  public boolean isWmOn() { return wmOn; }
  public int getWmNetIdx(){ return (wmOn)? exNetNum : EMPTY; }
  public int getGsNetIdx(){ return (gsOption!=EMPTY)?(wmOn?exNetNum+1:exNetNum):EMPTY; }
  public boolean isExNet(int netIdx){ return netIdx<exNetNum;}
  public boolean isWmNet(int netIdx){ return netIdx==getWmNetIdx(); }
  public boolean isGsNet(int netIdx){ return netIdx==getGsNetIdx(); }
  public boolean isIdnOn( int netIdx ){
     if( netIdx < exNetNum ) return true;
     return( netIdx==exNetNum )?((wmOn)?wmIdnOn:gsIdnOn):gsIdnOn;
  }
  public boolean isGsIdnOn() { return gsIdnOn; }
  public boolean isWmIdnOn() { return wmIdnOn; }
  /**************** SETTINGS ABOUT ACTION-CENTERED SUBSYSTEM *******************/
  public int getInputDimCharacter( int idx ){ return inputDimCharacters[ idx ]; }
 /************************** SETTINGS ABOUT IDN *******************************/
  public int getIdnInputDimNum( int netIdx ){ return idnInputDimVals[ netIdx ].length; }
  public int getIdnOutputDimNum( int netIdx ){ return idnOutputDimVals[ netIdx ].length; }
  public short[] getIdnInputDimVals( int netIdx ){ return idnInputDimVals[ netIdx ]; }
  public short[] getIdnOutputDimVals( int netIdx ){ return idnOutputDimVals[ netIdx ]; }
  // give the info of each input dim's type and order in that type.
  public short[][] getIdnInputFeatureInfo( int netIdx ){ return idnInputFeatureInfo[ netIdx ]; }
  // give the info of each output dim's type and order in that type.
  public short[][] getIdnOutputFeatureInfo( int netIdx ){ return idnOutputFeatureInfo[ netIdx ]; }
  public int getIdnInputNum( int netIdx ){ return CommonMethods.getSum( idnInputDimVals[netIdx]); }
  public int getIdnOutputNum( int netIdx ){ return CommonMethods.getSum( idnOutputDimVals[netIdx]); }
  public int getIdnHiddenNum( int netIdx ){ return idnHiddenNums[ netIdx ]; }
  public String getExIdnEligibleCondiitons( int netIdx ){ return exIdnEligibleConditions[ netIdx ]; }
  public int getIdnLearningOption( int netIdx ){ return idnBLLearningOptions[ netIdx ]; }
  public short[] getIdnAssimilationFreqs( int netIdx ){ return idnBlAssimFreqs[ netIdx ]; }
  public double getIdnBPLearningRate( int netIdx ){ return idnBPLRs[ netIdx ]; }
  public double getIdnBPMomentum( int netIdx ){ return idnBPMoms[ netIdx ]; }
  public double getIdnQDiscountRate( int netIdx ){ return idnQDiscountRates[ netIdx ]; }
  public double getIdnActionSelectionTemp( int netIdx ){ return idnActionSelTemps[ netIdx ]; }
  public double getOverallActionSelectionTemp( int netIdx ){ return overallActionSelTemps[ netIdx ]; }
  public int getIdnRLFunctionOption( int netIdx ){ return idnRLFuncOpts[ netIdx ]; }
  public String getOverallIdnRLFunction(){ return overallIdnRLFunction; }
  public String getIdnRLFunctions( int netIdx ){ return idnRLFunctions[ netIdx ]; }
  public boolean isIdnRLFuncByMCS( int netIdx ){ return idnRLFuncByMCSs[ netIdx ]; }
 /************************** SETTINGS ABOUT ARS *******************************/
  public int getARInputDimNum( int netIdx, int ruleType )
  { return arInputDimVals[ netIdx ][ ruleType ].length; }
  public int getAROutputDimNum( int netIdx, int ruleType )
  { return arOutputDimVals[ netIdx ][ ruleType ].length; }
  public short[] getARInputDimVals( int netIdx, int ruleType )
  { return arInputDimVals[ netIdx ][ ruleType ]; }
  public short[] getAROutputDimVals( int netIdx, int ruleType )
  { return arOutputDimVals[netIdx][ruleType]; }
  // give the info of each input dim's type and order in that type.
  public short[][] getARInputFeatureInfo( int netIdx, int ruleType )
  { return arInputFeatureInfo[ netIdx ][ ruleType ]; }
  // give the info of each output dim's type and order in that type.
  public short[][] getAROutputFeatureInfo( int netIdx, int ruleType )
  { return arOutputFeatureInfo[ netIdx ][ ruleType ]; }
  public int getARInputNum( int netIdx, int ruleType )
  { return CommonMethods.getSum( arInputDimVals[ netIdx ][ ruleType ] ); }
  public int getAROutputNum( int netIdx, int ruleType )
  { return CommonMethods.getSum( arOutputDimVals[ netIdx ][ ruleType ] ); }
  public double getARActionSelectionTemp( int netIdx, int ruleType )
  {return arActionSelTemps[netIdx][ruleType];}
  public int getARReasoningMethod( int netIdx, int ruleType )
  {return arReasoningMethods[netIdx][ruleType];}
  public boolean isARReasoningByMCSOn( int netIdx, int ruleType )
  {return arReasoningByMCSOns[netIdx][ruleType];}
 /********************* SETTINGS ABOUT RULE LEARNING **************************/
  public int getAcsKnowledgeNum(){ return acsKnowledgeNum; }
  public boolean isRerOn( int netIdx ){ return rerOns[ netIdx ]; }
  public boolean isIrlOn( int netIdx ){ return irlOns[ netIdx ]; }
  public boolean isExtInstructOn( int netIdx ){ return extInstructOns[ netIdx ]; }
  public boolean isILOn( int netIdx ){ return ilOns[ netIdx ]; }
  public boolean isFrOn( int netIdx ){ return frOns[ netIdx ]; }
  public boolean isAcsRLByMCS( int netIdx ){ return acsRLByMCSs[ netIdx ]; }
  public int getMaxRerRuleNum(){ return maxRerRuleNum; }
  public boolean isFrActionVariedOn( int netIdx, int setIdx )
  {  return frActionVariedOns[ netIdx ][ setIdx ]; }
  public String[] getFixRuleSet( int netIdx ){ return frSets[ netIdx ];}
  public int getFixRuleNum( int netIdx ){return frNums[ netIdx ];}
  public short[][] getFixRuleConditions(int netIdx,int ruleIdx)
  { return frConditions[netIdx][ruleIdx]; }
  public short[] getFixRuleActions( int netIdx, int ruleIdx )
  { return frActions[ netIdx ][ ruleIdx ]; }
  public int getIrlSetNum( int netIdx ){ return irlSetNums[ netIdx ]; }
  public String[] getIrlSet( int netIdx, int setIdx ){ return irlSets[ netIdx ][ setIdx ]; }
  public short[] getIrlRuleNums( int netIdx ){ return irlRuleNums[ netIdx ]; }
  public double[][][] getIrlRuleParameters( int netIdx ){ return irlRuleParams[ netIdx ]; }
  public double[][] getIrlRuleParameters( int netIdx, int setIdx )
  {return irlRuleParams[netIdx][setIdx];}
  public double[] getIrlRuleParameters(int netIdx,int setIdx,int ruleIdx)
  {return irlRuleParams[netIdx][setIdx][ruleIdx];}
  public double getRerDensity( int netIdx ){ return d_rs[ netIdx ];}
  public double getIrlDensity( int netIdx ){ return d_is[ netIdx ];}
  public double[] getRerExtractionProbs(){ return p_res; }
  public double getRerExtractionProb( int netIdx ){ return p_res[ netIdx ]; }
  public int getRerGenSpecMode( int netIdx ){ return rerGenSpecModes[ netIdx ]; }
  public int getIrlGenSpecMode( int netIdx ){ return irlGenSpecModes[ netIdx ]; }
  public String getRerPosCriterion( int netIdx ){ return rerPosCriterions[ netIdx ]; }
  public String getIrlPosCriterion( int netIdx ){ return irlPosCriterions[ netIdx ]; }
  public double getRerPosThreshold( int netIdx ){ return threshold_RERs[ netIdx ]; }
  public double getIrlPosThreshold( int netIdx ){ return threshold_IRLs[ netIdx ]; }
  public String getRerIGMeasurement( int netIdx ){ return rerIGMeasures[ netIdx ]; }
  public String getIrlIGMeasurement( int netIdx ){ return irlIGMeasures[ netIdx ]; }
  public double getRerIGParaAbove( int netIdx ){ return c1s[ netIdx ]; }
  public double getRerIGParaUnder( int netIdx ){ return c2s[ netIdx ]; }
  public double getIrlIGParaAbove( int netIdx ){ return c5s[ netIdx ]; }
  public double getIrlIGParaUnder( int netIdx ){ return c6s[ netIdx ]; }
  public double getRerGenThreshold( int netIdx ){ return threshold1s[ netIdx ]; }
  public double getRerSpecThreshold( int netIdx ){ return threshold2s[ netIdx ]; }
  public double getIrlGenThreshold( int netIdx ){ return threshold6s[ netIdx ]; }
  public double getIrlSpecThreshold( int netIdx ){ return threshold7s[ netIdx ]; }
  public double getIrlDeleteThreshold( int netIdx ){ return threshold4s[ netIdx ]; }
  public int getRerGenSpecValueRange( int netIdx ){return rerGsValueRanges[ netIdx ]; }
  public int getIrlGenSpecValueRange( int netIdx ){return irlGsValueRanges[ netIdx ]; }
  public int getRuleMergeInterval( int netIdx ){ return ruleMergeIntervals[ netIdx ]; }
 /******************* SETTINGS ABOUT RULE REPRESENTATIN ***********************/
  // the following for ACS rules including RER, FR, IRL.
  public boolean[] isRuleUtilityOn( int netIdx, int ruleType )
  { return ruleUtilityOns[netIdx][ruleType]; }
  public boolean isRuleUtilityOn(int netIdx,int ruleType,int setIdx)
  {return ruleUtilityOns[netIdx][ruleType][setIdx];}
  public boolean[] isRuleSupportOn( int netIdx, int ruleType )
  { return ruleSupportOns[ netIdx ][ ruleType ]; }
  public boolean isRuleSupportOn(int netIdx,int ruleType,int setIdx)
  {return ruleSupportOns[ netIdx ][ ruleType ][ setIdx ];}
  public boolean[] isRulePartMatchOn( int netIdx, int ruleType )
  { return rulePartMatchOns[ netIdx ][ ruleType ]; }
  public boolean isRulePartMatchOn( int netIdx, int ruleType, int setIdx )
  {return rulePartMatchOns[netIdx][ruleType][setIdx];}
  public boolean[] isRuleBlaOn( int netIdx, int ruleType )
  { return ruleBlaOns[ netIdx ][ ruleType ]; }
  public boolean isRuleBlaOn( int netIdx, int ruleType, int setIdx )
  {return ruleBlaOns[netIdx][ruleType][setIdx]; }
  public boolean[] isActionChunkBlaOn( int netIdx, int ruleType )
  {return actionChunkBlaOns[ netIdx ][ ruleType ]; }
  public boolean isActionChunkBlaOn(int netIdx,int ruleType,int setIdx)
  {return actionChunkBlaOns[netIdx][ruleType][setIdx];}
  public short[] getActionRuleWeightMode( int netIdx, int ruleType )
  { return actionRuleWeightModes[netIdx][ruleType];}
  public int getActionRuleWeightMode(int netIdx,int ruleType,int setIdx)
  {return actionRuleWeightModes[netIdx][ruleType][setIdx];}
 /*!!!!!!!!!!! the following 7 options for all types or each??? !!!!!!!!!!!!!!*/
  public short[] getActionRuleBlaOption( int netIdx, int ruleType )
  {return actionRuleBlaOptions[ netIdx ][ ruleType ]; }
  public int getActionRuleBlaOption(int netIdx,int ruleType,int setIdx)
  {return actionRuleBlaOptions[netIdx][ruleType][setIdx];}
  public double[] getActionRuleBla( int netIdx, int ruleType )
  { return actionRuleBlas[ netIdx ][ ruleType ]; }
  public double getActionRuleBla( int netIdx, int ruleType, int setIdx )
  {return actionRuleBlas[ netIdx ][ ruleType ][ setIdx ];}
  public double[][] getActionRuleBlaParas( int netIdx, int ruleType )
  { return actionRuleBlaParas[ netIdx ][ ruleType ];}
  public double[] getActionRuleBlaParas(int netIdx,int ruleType,int setIdx)
  {return actionRuleBlaParas[netIdx][ruleType][setIdx];}
  public short[] getRuleUtilityOption( int netIdx, int ruleType )
  { return ruleUtilityOptions[ netIdx ][ ruleType ];}
  public int getRuleUtilityOption( int netIdx, int ruleType, int setIdx )
  { return ruleUtilityOptions[netIdx][ruleType][setIdx];}
  public double[][] getRuleUtilityParas( int netIdx, int ruleType )
  {return ruleUtilityParas[ netIdx ][ ruleType ];}
  public double[] getRuleUtilityParas( int netIdx, int ruleType, int setIdx )
  {return ruleUtilityParas[netIdx][ruleType][setIdx];}
  public short[] getAcsChunkBlaOption( int netIdx, int ruleType )
  { return acsChunkBlaOptions[ netIdx ][ ruleType ]; }
  public int getAcsChunkBlaOption( int netIdx, int ruleType, int setIdx )
  { return acsChunkBlaOptions[netIdx][ruleType][setIdx];}
  public double[] getAcsChunkBla( int netIdx, int ruleType )
  { return acsChunkBlas[ netIdx ][ ruleType ];}
  public double getAcsChunkBla( int netIdx, int ruleType, int setIdx )
  { return acsChunkBlas[netIdx][ruleType][setIdx]; }
  public double[][] getAcsChunkBlaParas( int netIdx, int ruleType )
  { return acsChunkBlaParas[ netIdx ][ ruleType ]; }
  public double[] getAcsChunkBlaParas(int netIdx,int ruleType,int setIdx)
  { return acsChunkBlaParas[netIdx][ruleType][setIdx]; }
  /********************* SETTINGS ABOUT GOAL STRUCTURE *************************/
  public GoalStructure getGS(){ return gs; }
  public String[] getGoalFeatureLabels(){ return goalFeatLabels; }
  public String[] getGoalChunkLabels(){ return goalChunkLabels; }
  public short[][] getGoals( int goalIdx ){ return goals[ goalIdx ]; }
  public int getGoalChunkSize(){   return size_gc; }
  // return the length of each goal parameter dimension.
  public short[] getGoalParaDimVals(){ return goalParaDimVals;}
  public int getGoalStructSize(){ return size_g; }
  // threshold when checking qualification for participating in the competition
  // of the goal list.
  public double getGoalActivationThreshold(){ return threshold_GS;}
  // goal decided by TL or both of levels.
  public int getGoalDecisionMode(){ return goalDecisionMode; }
  public int getGoalBlaOption(){ return goalBlaOption; }
  public double getGoalBla(){ return goalBla; }
  public double[] getGoalBlaParas(){ return goalBlaParas; }
  public double getExternCorConstant(){ return P_EXT; }
  public double getGoalCorConstant(){ return P_GS; }
  public short[][] getGsItemDimInfo(){ return gsItemDimInfo; }
  public int getGsItemLength()
  { return gsItemLength = CommonMethods.calcGsItemLength(gsItemDimInfo,featureLengths); }
  public int getGsInputLength()
  { return gsInputLength = CommonMethods.calcGsItemLength(gsItemDimInfo,featureLengths); }
 /********************* SETTINGS ABOUT WORKING MEMORY *************************/
  public WM getWM(){ return wm; }
  public int getWmSize(){ return size_wm; }
  public double getWmActivationThreshold(){ return threshold_WM; }
  public boolean isWmFlagsOn(){ return wmFlagsOn; }
  public int getWmActionDecisionMode(){ return wmActionDecisionMode; }
  public int getWmActionFlagDecisionMode(){ return wmActionFlagDecisionMode; }
  public int getWmBlaOption(){ return wmBlaOption; }
  public double getWmBla(){ return wmBla;}
  public double[] getWmBlaParas(){ return wmBlaParas; }
  public short[] getWmItemNums(){ return wmItemNums; }
  public short[][][] getWmItemDimInfos(){ return wmItemDimInfos; }
  public short[] getWmItemLengths(){ return wmItemLengths; }
  public int getWmInputLength(){ return wmInputLength = CommonMethods.getSum( wmItemLengths ); }
  //{return wmItemLengths = CommonMethods.calcWmItemLengths(size_wm,wmItemNums,wmItemDimInfos,featureLengths);}
 /***************** SETTINGS ABOUT COORDINATING ARS AND IDN *******************/
  //public boolean isOverrideByIdn() { return overrideByIdnOn; }
  public boolean isOverrideByIdn() { return this.getGsOption() == Global.GS_NON; }
  public int getCombineDeterMode(){return combineDeterMode;}
  public short[] getAcsCrossCombineModes(int netIdx){ return acsCrossCombModes[netIdx]; }
  public int getAcsCrossCombineMode(int netIdx, int modeIdx){ return acsCrossCombModes[netIdx][modeIdx]; }
  public double[][] getAcsCrossCombineParas(){ return acsCrossCombParas; }
  public double[] getAcsCrossCombineParas( int netIdx ){ return acsCrossCombParas[ netIdx ];}
  public double[][] getAcsCrossCombineVarParaAbove(){return c3s;}
  public double[] getAcsCrossCombineVarParaAbove( int netIdx ){ return c3s[ netIdx ]; }
  public double[][] getAcsCrossCombineVarParaUnder(){ return c4s; }
  public double[] getAcsCrossCombineVarParaUnder( int netIdx ){ return c4s[ netIdx ];}
  public int getCorMultiExtMode(){ return corMultiExtMode;}
 /************** SETTINGS ABOUT NON-ACTION-CENTERED SUBSYSTEM *****************/
 /******************** SETTINGS ABOUT NACS COMPONENTS *************************/
  public boolean isGKSon(){ return gksOnFlag; }
  public boolean isEMon(){  return emOnFlag; }
  public boolean isAEMon(){ return aemOnFlag; }
 /******************** SETTINGS ABOUT GKS REPRESENATIONS **********************/
  public int getGksInputDimNum() { return gksInputDimVals.length; }
  public int getGksOutputDimNum() { return gksOutputDimVals.length; }
  public short[] getGksInputDimVals() { return gksInputDimVals; }
  public short[] getGksOutputDimVals() { return gksOutputDimVals; }
  // include each feature's type and order in that type.
  public short[][] getGksInputFeatureInfo(){ return gksInputFeatureInfo;}
  // include each feature's type and order in that type.
  public short[][] getGksOutputFeatureInfo(){ return gksOutputFeatureInfo; }
  public int getGksInputNum() { return CommonMethods.getSum( gksInputDimVals ); }
  public int getGksOutputNum() { return CommonMethods.getSum( gksOutputDimVals ); }
  public int getGksMaxChunkNum(){ return gksMaxChunkNum;}
  public double getGksOutputTemperature(){ return gksOutputTemperature; }
  public boolean isESChunkOn(){ return esChunkOnFlag; }
  public boolean isEpiChunkOn(){ return epiChunkOnFlag; }
  /******************* the following for NACS rules ********************/
  public boolean isAssocUtilityOn(){ return assocUtilityOn;}
  public boolean isAssocSupportOn(){ return assocSupportOn; }
  public boolean isAssocPartMatchOn(){ return assocPartMatchOn; }
  public boolean isAssocBlaOn(){ return assocBlaOn; }
  public boolean isNacsChunkBlaOn(){ return nacsChunkBlaOn;}
  public int getAssocUtilityOption(){ return assocUtilityOption; }
  public double[] getAssocUtilityParas(){ return assocUtilityParas; }
  public int getAssocWeightMode(){ return assocWeightMode; }
  public int getAssocBlaOption(){ return assocBlaOption; }
  public double getAssocBla(){ return assocBla; }
  public double[] getAssocBlaParas(){ return assocBlaParas; }
  public int getChunkBlaOption(){ return chunkBlaOption; }
  public double getChunkBla(){ return chunkBla;}
  public double[] getChunkBlaParas(){ return chunkBlaParas; }
  public int getEmBlaOption( int emType ){ return emBlaOptions[ emType ]; }
  public double getEmBla(  int emType ){ return emBlas[ emType ]; }
  public double[] getEmBlaParas( int emType ){ return emBlaParas[ emType ]; }
  public double getThreshold_EM(){ return threshold_EM; }
  public int getEmCapacity(){ return emCapacity; }
  public double getEmTrainProb(){  return emTrainProb; }
  public int getEmTrainItemNum(){  return c9; }
  public int getEmTrainIterNum(){ return c10; }
  public double getThreshold_sim(){ return threshold_sim; }
  public double getSBR_BalConstant(){ return c14; }
  public double getRBR_BalConstant(){ return c15; }
 /*********************** SETTINGS ABOUT GKS LEARNINGS ************************/
  public boolean isAssocExtractOn(){ return assocExtractOn; }
  public boolean isAssocEncodeExternOn(){ return assocEncodeExternOn; }
  public boolean isAssocAssimiOn(){ return assocAssimiOn; }
  public boolean isChunkEncodeExternOn() { return chunkEncodeExternOn; }
  public boolean isChunkFromAmnOn(){ return chunkFromAmnOn;}
  public boolean isChunkByMCSOn(){ return chunkByMCSOn; }
  public double getChunkEncodeProb(){  return p_c; }
  public double getAssocEncodeProb(){  return p_a; }
  public double getChunkDensity(){ return d_c; }
  public double getAssocDensity(){ return d_a; }
  public double getAssocExtThreshold(){ return threshold_ae; }
  public double getChunkExtThreshold(){ return threshold_ce; }
  public double getAssocExtProb(){ return p_ae; }
  public double getChunkExtProb(){ return p_ce;}
  public int getActivationMeasure(){ return activationMeasure; }
 /******************** SETTINGS ABOUT AMN REPRESENATIONS **********************/
 /*-------- AMN SETTINGS --------*/
  public int getAmnNum(){return amnNum; }
  public short getAmnType( int idx ){return amnTypes[ idx ];}
  public int getAmnInputDimNum( int idx ){return amnInputDimVals[idx].length;}
  public int getAmnOutputDimNum( int idx ){return amnOutputDimVals[idx].length;}
  public short[] getAmnInputDimVals( int idx ){ return amnInputDimVals[ idx ];}
  public short[] getAmnOutputDimVals( int idx ){ return amnOutputDimVals[ idx ]; }
  // include each feature's type and order in that type.
  public short[][] getAmnInputFeatureInfo( int idx ){ return amnInputFeatureInfo[ idx ];}
  // include each feature's type and order in that type.
  public short[][] getAmnOutputFeatureInfo( int idx ){ return amnOutputFeatureInfo[ idx ]; }
  public int getAmnInputNum( int idx ){ return CommonMethods.getSum( amnInputDimVals[idx]); }
  public int getAmnOutputNum( int idx ){ return CommonMethods.getSum( amnOutputDimVals[idx]); }
  public int getAmnHiddenNum( int idx ){ return amnHiddenNums[ idx ]; }
  public short getAmnInputChunkType( int idx ){ return amnInputChunkTypes[ idx ]; }
  public short getAmnOutputChunkType( int idx ){ return amnOutputChunkTypes[ idx ]; }
  public boolean isAmnMultiPassOn( int idx ){ return amnMultiPassOns[ idx ]; }
  public short getAmnIterNum( int idx ){ return amnIterNum[ idx ]; }
  public boolean isAmnMultiFlagOn(){ return amnMultiFlagOn; }
 /*-------- AAM SETTINGS --------*/
  public double getAamTrainProb(){ return aamTrainProb; }
  public int getAamTrainPatternType(){ return aamTrainPatternType; }
  public int getAamTrainPatternNum(){ return aamTrainPatternNum; }
  public int getAamTrainIterNum(){ return aamTrainIterNum; }
 /*-------- HAM SETTINGS --------*/
  public double getHamTrainProb(){ return hamTrainProb; }
  public int getHamTrainAssocMapNum(){ return hamTrainAssocMapNum; }
  public int getHamTrainIterNum(){ return hamTrainIterNum; }
 /*-------- AMN BP SETTINGS --------*/
  public double getAmnBPLearningRate( int idx ){ return amnLRs[ idx ]; }
  public double getAmnBPMomentum( int idx ){ return amnMoms[ idx ]; }
 /*-------- AEM SETTINGS --------*/
  public int    getAemStateNumBound(){ return aemStateNumBound; }
  public double getAemTrainedByEmProb(){ return aemTrainedByEmProb; }
  public int getAemTrainedByEmItemNum(){ return aemTrainedByEmItemNum; }
  public double getAemTrainedByEmBPLearningRate(){ return aemTrainedByEmLR; }
  public double getAemTrainedByEmBPMomentum(){ return aemTrainedByEmMom; }
  public int getAemPotentialNextStateNum(){ return aemPotentialNextStateNum; }
  public double getAemTrainAcsProb(){ return aemTrainAcsProb; }
  public int getAemTrainAcsSampleNum(){ return aemTrainAcsSampleNum; }
  public int getAemTrainAcsIterNum(){ return aemTrainAcsIterNum; }
  public double getAemTrainAcsOutputTemp(){ return aemTrainAcsOutputTemp; }
 /**************** SETTINGS ABOUT COORDINATING ACS and NACS *******************/
  public int getCorAcsNacsType() { return corAcsNacsType; }
  public boolean isReasoningByMCSOn(){ return reasoningByMCSOn; }
  // forward chaining, backward-chaining, simi-based forward, counterfactual,
  // proof by contradiction.
  public int getGksReasoningMethod(){return gksReasoningMethod;}
  public int getGksReasonIterNum(){return gksReasonIterNum;}
  public boolean isGksReasonByMCSOn(){ return gksReasonByMCSOn;}
  public int getAdmTLReasoningMethod(){  return admTLReasoningMethod; }
  public int getAdmReasonIterNum(){ return admReasonIterNum; }
  public boolean isAdmReasonByMCSOn(){ return admReasonByMCSOn; }
 /****************** SETTINGS ABOUT SUPERVISORY SUBSYSTEM *********************/
  public boolean isMsOn(){ return msOn; }
  public boolean isMcsOn(){ return mcsOn; }
  public MS getMS(){ return ms; }
  public MCS getMCS(){ return mcs; }
  public int getMonitorAcsTopConcNum(){ return c20; }
  public int getMonitorAcsBottomConcNum(){ return c24; }
  public int getMonitorAcsTopStepNum(){ return c22; }
  public int getMonitorAcsBottomStepNum(){ return c26; }
  public int getMonitorAcsTopEpisodeNum(){ return c28; }
  public int getMonitorAcsBottomEpisodeNum(){ return c30; }
  public int getMonitorNacsTopConcNum(){ return c21; }
  public int getMonitorNacsBottomConcNum(){ return c25; }
  public int getMonitorNacsTopStepNum(){ return c23; }
  public int getMonitorNacsBottomStepNum(){ return c27; }
  public int getMonitorNacsTopEpisodeNum(){ return c29; }
  public int getMonitorNacsBottomEpisodeNum(){ return c31; }
 /*************** SETTINGS ABOUT RESPONSE TIME DETERMINATION ******************/
  public boolean isRTOn(){ return rtOn; }
  //public int getMaxUsageNum(){ return maxUsageNum; }
  public String getOverallFormula(){ return overallFormula; }
  public String getBLFormula(){ return blFormula; }
  public String getTLFormula(){ return tlFormula; }
  public int getPT_BL(){ return PT_BL; }
  public int getDT_BL(){ return DT_BL; }
  public int getAT_BL(){ return AT_BL; }
  public int getPT_TL(){ return PT_TL; }
  // used for calculating DT_TL = DT_TL_actioTime + t0/rule_bla + t1/chunk_bla;
  public int getDT_TL_actionTime(){ return DT_TL_actionTime; }
  public double getDT_TL_t0(){ return t0; }
  public double getDT_TL_t1(){ return t1; }
  public int getAT_TL(){ return AT_TL; }
  public String getAssoAppTimeFormula(){ return assocAppTimeFormula;}
  public double getAssocAppTime_t4(){ return t4; }
  public double getAssocAppTime_t5(){ return t5; }
  public String getChunkRetTimeFormula(){return chunkRetTimeFormula;}
  public double getChunkRetTime_t2(){ return t2; }
  public double getChunkRetTime_t3(){ return t3; }
  public int getAmnOnePassTime(){ return t_AMN; }
 /************************** SETTINGS ABOUT INTERFACE *************************/
  public int getRuleDisplayMode(){ return ruleDisplayMode;}
  public int getRuleDisplayFreq(){ return ruleDisplayFreq; }
 /************************ SETTING ABOUT TASK-SPECIFIC ************************/
  public boolean isLearningTestOn(){ return learningTestOn; }
  public int getEpisodeLength(){ return episodeLength; }
  public int getSensoryInputLength(){ return CommonMethods.getSum(featureLengths[INPUT]); }
  public int getAgentGroupId(){ return agentGroupId; }
  public TaskAgent getTaskAgent(){ return taskAgent; }
  public ACS getACS(){ return acs; }
  public NACS getNACS(){ return nacs; }
  public String getOptionName(){ return optionName; }
  static public String getRootDir(){ return rootDir; }
  static public String getOptionDir(){ return optionDir; }
  static public String getDataDir(){ return dataDir; }
  static public Task getTask(){ return task; }
  static public Class getTaskClarionClass(){ return taskClarionClass; }
  public TaskClarion getTaskClarion(){ return taskClarion; }
  static public String getTaskDir(){ return taskDir; }
  static public String getTaskName(){ return taskName; }
  static public String getTaskPackageName(){ return taskPkgName; }
  static public String getTaskClassName(){ return taskClsName; }
  static public boolean isGuiMode(){ return guiFlag; }
 /***************************** SET METHODS ***********************************/
 /*--------------------- FEATURES INFORMATION. -------------------------------*/
  public void setFeatureTypeNum( int value ){ featureTypeNum = value; }
  public void setFeatureNums( short[] values ){ featureNums = CommonMethods.copy( values );}
  public void setFeatureLengths( short[][] values ){ featureLengths = CommonMethods.copy( values );}
  public void setFeatureNames( String[][] values ){ featureNames = CommonMethods.copy( values ); }
  public void setFeatureValueNames( String[][][] values ){ featureValueNames = CommonMethods.copy( values ); }
 /**************** SETTINGS ABOUT ACTION-CENTERED SUBSYSTEM *******************/
  public void setClarion( Clarion value ){ clarion = value; }
  public void setNacsOn(boolean value){ nacsOn = value; }
  public void setSupervisorySubsysOn(boolean value){ superOn = value; }
  public void setRtOn(boolean value){ rtOn = value; }
  public void setInputDimCharacter(int idx,int value){inputDimCharacters[idx]=(short)value; }
 /******************** SETTINGS ABOUT ACS COMPONENTS **************************/
  public void setAcsNetNum( int value ){ acsNetNum = value; }
  public void setGsOption( int value ){ gsOption = value; }
  public void setWmOption( boolean value ){ wmOn = value; }
  public void setExNetNum( int value ){ exNetNum = value; }
  public void setIdnOn( int netIdx, boolean value ){
       if(isWmNet(netIdx)) wmIdnOn = value;
       if(isGsNet(netIdx)) gsIdnOn = value;
  }
  public void setGsIdnOn( boolean value ){ gsIdnOn = value; }
  public void setWmIdnOn( boolean value ){ wmIdnOn = value; }
 /************************** SETTINGS ABOUT IDN *******************************/
  public void setIdnInputDimVals( short[][] values )
  { idnInputDimVals = CommonMethods.copy( values ); }
  public void setIdnInputDimVals( int netIdx, short[] values )
  { idnInputDimVals[ netIdx ] = CommonMethods.copy( values ); }
  public void setIdnOutputDimVals( short[][] values )
  { idnOutputDimVals = CommonMethods.copy( values ); }
  public void setIdnOutputDimVals( int netIdx, short[] values )
  { idnOutputDimVals[ netIdx ] = CommonMethods.copy( values ); }
  // give the info of each input dim's type and order in that type.
  public void setIdnInputFeatureInfo( short[][][] values )
  { idnInputFeatureInfo = CommonMethods.copy( values ); }
  public void setIdnInputFeatureInfo( int netIdx, short[][] values )
  { idnInputFeatureInfo[ netIdx ] = CommonMethods.copy( values ); }
  // give the info of each input dim's type and order in that type.
  public void setIdnOutputFeatureInfo( short[][][] values )
  { idnOutputFeatureInfo = CommonMethods.copy( values ); }
  public void setIdnOutputFeatureInfo( int netIdx, short[][] values )
  { idnOutputFeatureInfo[ netIdx ] = CommonMethods.copy( values ); }
  public void setIdnHiddenNums( short[] values )
  { idnHiddenNums = CommonMethods.copy( values ); }
  public void setIdnHiddenNum( int netIdx, int value )
  { idnHiddenNums[ netIdx ] = (short)value; }
  public void setExIdnEligibleCondiitons( String[] value )
  { exIdnEligibleConditions = value; }
  public void setExIdnEligibleCondiitons( int netIdx, String value )
  { exIdnEligibleConditions[ netIdx ] = value; }
  public void setIdnLearningOptions( short[] values )
  { idnBLLearningOptions = CommonMethods.copy( values ); }
  public void setIdnLearningOption( int netIdx, int value )
  { idnBLLearningOptions[ netIdx ] = (short)value; }
  public void setIdnAssimilationFreqs( short[][] values )
  { idnBlAssimFreqs = CommonMethods.copy( values ); }
  public void setIdnAssimilationFreqs( int netIdx, short[] values )
  { idnBlAssimFreqs[ netIdx ] = CommonMethods.copy( values ); }
  public void setIdnBPLearningRates( double[] values ){ idnBPLRs = CommonMethods.copy( values ); }
  public void setIdnBPLearningRate( int netIdx, double value ){ idnBPLRs[ netIdx ] = value; }
  public void setIdnBPMomentums( double[] values ){ idnBPMoms = CommonMethods.copy( values ); }
  public void setIdnBPMomentum( int netIdx, double value ){ idnBPMoms[ netIdx ] = value; }
  public void setIdnQDiscountRates( double[] values )
  { idnQDiscountRates = CommonMethods.copy( values ); }
  public void setIdnQDiscountRate( int netIdx, double value )
  { idnQDiscountRates[ netIdx ] = value; }
  public void setIdnActionSelectionTemps( double[] values )
  { idnActionSelTemps = CommonMethods.copy( values ); }
  public void setIdnActionSelectionTemp( int netIdx, double value )
  { idnActionSelTemps[ netIdx ] = value; }
  public void setOverallActionSelectionTemps( double[] values )
  { overallActionSelTemps = CommonMethods.copy( values ); }
  public void setOverallActionSelectionTemp( int netIdx, double value )
  { overallActionSelTemps[ netIdx ] = value; }
  public void setIdnRLFunctionOptions( short[] values )
  { idnRLFuncOpts = CommonMethods.copy( values ); }
  public void setIdnRLFunctionOption( int netIdx, int value )
  { idnRLFuncOpts[ netIdx ] = (short)value; }
  public void setOverallIdnRLFunction( String value )
  { overallIdnRLFunction = value; }
  public void setIdnRLFunctions( String[] values )
  { idnRLFunctions = CommonMethods.copy( values ); }
  public void setIdnRLFunction( int netIdx, String value )
  { idnRLFunctions[ netIdx ] = value; }
  public void setIdnRLFuncByMCS( boolean[] values )
  { idnRLFuncByMCSs = CommonMethods.copy( values ); }
  public void setIdnRLFuncByMCS( int netIdx, boolean value )
  { idnRLFuncByMCSs[ netIdx ] = value; }
 /************************** SETTINGS ABOUT ARS *******************************/
  public void setARInputDimVals( short[][][] values )
  { arInputDimVals = CommonMethods.copy( values ); }
  public void setARInputDimVals( int netIdx, int ruleType, short[] values )
  { arInputDimVals[netIdx][ruleType] = CommonMethods.copy( values ); }
  public void setAROutputDimVals( short[][][] values )
  { arOutputDimVals = CommonMethods.copy( values );}
  public void setAROutputDimVals( int netIdx, int ruleType, short[] values )
  { arOutputDimVals[netIdx][ruleType] = CommonMethods.copy( values );}
  // give the info of each input dim's type and order in that type.
  public void setARInputFeatureInfo( int netIdx, int ruleType, short[][] values )
  { arInputFeatureInfo[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  // give the info of each output dim's type and order in that type.
  public void setAROutputFeatureInfo( int netIdx, int ruleType, short[][] values )
  { arOutputFeatureInfo[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setARActionSelectionTemps(double[][] values)
  { arActionSelTemps = CommonMethods.copy( values ); }
  public void setARActionSelectionTemp(int netIdx,int ruleType,double value)
  { arActionSelTemps[netIdx][ruleType]=value;}
  public void setARReasoningMethods( short[][] values )
  { arReasoningMethods = CommonMethods.copy( values ); }
  public void setARReasoningMethod( int netIdx, int ruleType, int value )
  { arReasoningMethods[netIdx][ruleType]=(short)value; }
  public void setARReasoningByMCSOns( boolean[][] values )
  { arReasoningByMCSOns = CommonMethods.copy( values ); }
  public void setARReasoningByMCSOn(int netIdx,int ruleType,boolean value)
  { arReasoningByMCSOns[netIdx][ruleType]=value;}
 /********************* SETTINGS ABOUT RULE LEARNING **************************/
  public void setAcsKnowledgeNum( int value ){ acsKnowledgeNum = value; }
  public void setRerOns( boolean[] values ){ rerOns = CommonMethods.copy( values ); }
  public void setRerOn( int netIdx, boolean value ){ rerOns[ netIdx ] = value;}
  public void setIrlOns( boolean[] values ){ irlOns = CommonMethods.copy( values ); }
  public void setIrlOn( int netIdx, boolean value ){ irlOns[ netIdx ] = value; }
  public void setExtInstructOns(boolean[] values){ extInstructOns = CommonMethods.copy( values ); }
  public void setExtInstructOn(int netIdx,boolean value){extInstructOns[netIdx]=value;}
  public void setILOns( boolean[] values ){ ilOns = CommonMethods.copy( values ); }
  public void setILOn( int netIdx, boolean value ){ ilOns[ netIdx ] = value; }
  public void setFrOns( boolean[] values ){ frOns = CommonMethods.copy( values ); }
  public void setFrOn( int netIdx, boolean value ){ frOns[ netIdx ] = value; }
  public void setAcsRLByMCSOns(boolean[] values){ acsRLByMCSs = CommonMethods.copy( values ); }
  public void setAcsRLByMCSOn(int netIdx,boolean value){acsRLByMCSs[netIdx]=value;}
  public void setMaxRerRuleNum( int value ){ maxRerRuleNum = value; }
  public void setFrActionVariedOns( boolean[][] values )
  {  frActionVariedOns = CommonMethods.copy( values ); }
  public void setFrActionVariedOn( int netIdx, int setIdx, boolean value )
  {  frActionVariedOns[ netIdx ][ setIdx ] = value; }
  public void setFixRuleSet( String[][] values ){ frSets = CommonMethods.copy( values ); }
  public void setFixRuleSet( int netIdx, String[] values ){ frSets[ netIdx ] = CommonMethods.copy( values ); }
  public void setFixRuleNums( short[] values ){ frNums = CommonMethods.copy( values ); }
  public void setFixRuleNum( int netIdx, int value ){ frNums[ netIdx ] = (short)value; }
  public void setFixRuleConditions( short[][][][] values ){ frConditions = CommonMethods.copy( values ); }
  public void setFixRuleConditions( int netIdx, short[][][] values )
  { frConditions[netIdx] = CommonMethods.copy( values );}
  public void setFixRuleConditions( int netIdx, int ruleIdx, short[][] values )
  { frConditions[netIdx][ruleIdx] = CommonMethods.copy( values );}
  public void setFixRuleActions( short[][][] values ){ frActions = CommonMethods.copy( values ); }
  public void setFixRuleActions( int netIdx, short[][] values )
  { frActions[netIdx] = CommonMethods.copy( values ); }
  public void setFixRuleAction( int netIdx, int ruleIdx, short[] values )
  { frActions[netIdx][ruleIdx] = CommonMethods.copy( values ); }
  public void setIrlSets( String[][][] values ){ irlSets = CommonMethods.copy( values ); }
  public void setIrlSet( int netIdx, int setIdx, String[] values )
  { irlSets[ netIdx ][ setIdx ] = CommonMethods.copy( values ); }
  public void setIrlSetNum( short[] values ){ irlSetNums = CommonMethods.copy( values ); }
  public void setIrlSetNum( int netIdx, int value ){ irlSetNums[ netIdx ]= (short)value; }
  public void setIrlRuleNums( short[][] values ){ irlRuleNums = CommonMethods.copy( values ); }
  public void setIrlRuleNums( int netIdx, short[] values ){ irlRuleNums[netIdx] = CommonMethods.copy( values ); }
  public void setIrlRuleNum( int netIdx, int setIdx, int value ){ irlRuleNums[netIdx][setIdx]=(short)value; }
  public void setIrlRuleParameters( double[][][][] values ){ irlRuleParams = CommonMethods.copy( values );}
  public void setIrlRuleParameters( int netIdx, double[][][] values )
  { irlRuleParams[ netIdx ] = CommonMethods.copy( values ); }
  public void setIrlRuleParameters( int netIdx, int setIdx, double[][] values )
  {irlRuleParams[netIdx][setIdx] = CommonMethods.copy( values );}
  public void setIrlRuleParameters(int netIdx,int setIdx,int ruleIdx,double[] values)
  { irlRuleParams[netIdx][setIdx][ruleIdx] = CommonMethods.copy( values ); }
  public void setIrlGenOns( boolean[] values ){ irlGenOns = CommonMethods.copy( values ); }
  public void setIrlGenOn( int netIdx, boolean value){ irlGenOns[ netIdx ] = value; }
  public void setIrlSpecOns( boolean[] values ){ irlSpecOns = CommonMethods.copy( values ); }
  public void setIrlSpecOn( int netIdx, boolean value){ irlSpecOns[ netIdx ] = value; }
  public void setIrlDensities( double[] values ){ d_is = CommonMethods.copy( values ); }
  public void setIrlDensity( int netIdx, double value){ d_is[ netIdx ] = value; }
  public void setRerDensities( double[] values ){ d_rs = CommonMethods.copy( values ); }
  public void setRerDensity( int netIdx, double value){ d_rs[ netIdx ] = value; }
  public void setRerExtractionProbs( double[] values){ p_res = CommonMethods.copy( values ); }
  public void setRerExtractionProb( int netIdx,double value){ p_res[ netIdx ] = value; }
  public void setRerGenSpecModes( short[] values ){ rerGenSpecModes = CommonMethods.copy( values ); }
  public void setRerGenSpecMode( int netIdx, int value ){ rerGenSpecModes[ netIdx ] = (short)value; }
  public void setIrlGenSpecModes( short[] values ){ irlGenSpecModes = CommonMethods.copy( values ); }
  public void setIrlGenSpecMode( int netIdx, int value ){ irlGenSpecModes[ netIdx ] = (short)value; }
  public void setRerPosCriterions(String[] values){ rerPosCriterions = CommonMethods.copy( values ); }
  public void setRerPosCriterion(int netIdx,String value){ rerPosCriterions[ netIdx ] = value; }
  public void setIrlPosCriterions(String[] values){ irlPosCriterions = CommonMethods.copy( values ); }
  public void setIrlPosCriterion(int netIdx,String value){ irlPosCriterions[ netIdx ] = value; }
  public void setRerPosThresholds(double[] values){ threshold_RERs = CommonMethods.copy( values ); }
  public void setRerPosThreshold(int netIdx,double value){ threshold_RERs[ netIdx ] = value; }
  public void setIrlPosThresholds(double[] values){ threshold_IRLs = CommonMethods.copy( values ); }
  public void setIrlPosThreshold(int netIdx,double value){ threshold_IRLs[ netIdx ] = value; }
  public void setRerIGMeasurements(String[] values){ rerIGMeasures = CommonMethods.copy( values ); }
  public void setRerIGMeasurement(int netIdx,String value){ rerIGMeasures[ netIdx ] = value; }
  public void setIrlIGMeasurements(String[] values){ irlIGMeasures = CommonMethods.copy( values ); }
  public void setIrlIGMeasurement(int netIdx,String value){ irlIGMeasures[ netIdx ] = value; }
  public void setRerIGParaAboves(double[] values){ c1s = CommonMethods.copy( values ); }
  public void setRerIGParaAbove(int netIdx,double value){ c1s[ netIdx ] = value; }
  public void setRerIGParaUnders(double[] values){ c2s = CommonMethods.copy( values ); }
  public void setRerIGParaUnder(int netIdx,double value){ c2s[ netIdx ] = value; }
  public void setIrlIGParaAboves(double[] values){ c5s = CommonMethods.copy( values ); }
  public void setIrlIGParaAbove(int netIdx,double value){ c5s[ netIdx ] = value; }
  public void setIrlIGParaUnders(double[] values){ c6s = CommonMethods.copy( values ); }
  public void setIrlIGParaUnder(int netIdx,double value){ c6s[ netIdx ] = value; }
  public void setRerGenThresholds(double[] values){ threshold1s = CommonMethods.copy( values ); }
  public void setRerGenThreshold(int netIdx,double value){ threshold1s[ netIdx ] = value; }
  public void setRerSpecThresholds(double[] values){ threshold2s = CommonMethods.copy( values ); }
  public void setRerSpecThreshold(int netIdx,double value){ threshold2s[ netIdx ] = value; }
  public void setIrlGenThresholds(double[] values){ threshold6s = CommonMethods.copy( values ); }
  public void setIrlGenThreshold(int netIdx,double value){ threshold6s[ netIdx ] = value; }
  public void setIrlSpecThresholds(double[] values){ threshold7s = CommonMethods.copy( values ); }
  public void setIrlSpecThreshold(int netIdx,double value){ threshold7s[ netIdx ] = value; }
  public void setIrlDeleteThresholds(double[] values){ threshold4s = CommonMethods.copy( values ); }
  public void setIrlDeleteThreshold(int netIdx,double value){ threshold4s[ netIdx ] = value; }
  public void setRerGenSpecValueRanges(short[] values){ rerGsValueRanges = CommonMethods.copy( values ); }
  public void setRerGenSpecValueRange(int netIdx,int value){ rerGsValueRanges[ netIdx ] = (short)value; }
  public void setIrlGenSpecValueRanges(short[] values){ irlGsValueRanges = CommonMethods.copy( values ); }
  public void setIrlGenSpecValueRange(int netIdx,int value){ irlGsValueRanges[ netIdx ] = (short)value; }
  public void setRuleMergeIntervals(short[] values){ ruleMergeIntervals = CommonMethods.copy( values ); }
  public void setRuleMergeInterval(int netIdx,int value){ ruleMergeIntervals[ netIdx ] = (short)value; }
 /******************* SETTINGS ABOUT RULE REPRESENTATIN ***********************/
 // the following for ACS rules including RER, FR, IRL.
  public void setRuleUtilityOns( boolean[][][] values )
  {  ruleUtilityOns = CommonMethods.copy( values ); }
  public void setRuleUtilityOns( int netIdx, int ruleType, boolean[] values )
  {  ruleUtilityOns[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setRuleUtilityOn( int netIdx, int ruleType, int setIdx, boolean value )
  {  ruleUtilityOns[ netIdx ][ ruleType ][ setIdx ] = value; }
  public void setRuleSupportOns( boolean[][][] values )
  {  ruleSupportOns = CommonMethods.copy( values ); }
  public void setRuleSupportOns( int netIdx, int ruleType, boolean[] values )
  {  ruleSupportOns[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setRuleSupportOn( int netIdx, int ruleType, int setIdx, boolean value )
  {  ruleSupportOns[ netIdx ][ ruleType ][ setIdx ] = value; }
  public void setRulePartMatchOns( boolean[][][] values )
  {  rulePartMatchOns = CommonMethods.copy( values ); }
  public void setRulePartMatchOns( int netIdx, int ruleType, boolean[] values )
  {  rulePartMatchOns[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setRulePartMatchOn( int netIdx, int ruleType, int setIdx, boolean value )
  {  rulePartMatchOns[ netIdx ][ ruleType ][ setIdx ] = value; }
  public void setRuleBlaOns( boolean[][][] values )
  {  ruleBlaOns = CommonMethods.copy( values ); }
  public void setRuleBlaOns( int netIdx, int ruleType, boolean[] values )
  {  ruleBlaOns[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setRuleBlaOn( int netIdx, int ruleType, int setIdx, boolean value )
  {  ruleBlaOns[ netIdx ][ ruleType ][ setIdx ] = value; }
  public void setActionChunkBlaOns( boolean[][][] values )
  {  actionChunkBlaOns = CommonMethods.copy( values ); }
  public void setActionChunkBlaOns( int netIdx, int ruleType, boolean[] values )
  {  actionChunkBlaOns[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setActionChunkBlaOn( int netIdx, int ruleType, int setIdx, boolean value )
  {  actionChunkBlaOns[ netIdx ][ ruleType ][ setIdx ] = value; }
  public void setActionRuleWeightMode( short[][][] values )
  {  actionRuleWeightModes = CommonMethods.copy( values ); }
  public void setActionRuleWeightMode( int netIdx, int ruleType, short[] values )
  {  actionRuleWeightModes[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setActionRuleWeightMode( int netIdx, int ruleType, int setIdx, int value )
  {  actionRuleWeightModes[ netIdx ][ ruleType ][ setIdx ] = (short)value; }
 /*!!!!!!!!!!! the following 7 options for all types or each??? !!!!!!!!!!!!!!*/
  public void setActionRuleBlaOption( short[][][] values )
  {  actionRuleBlaOptions = CommonMethods.copy( values ); }
  public void setActionRuleBlaOption( int netIdx, int ruleType, short[] values )
  {  actionRuleBlaOptions[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setActionRuleBlaOption( int netIdx, int ruleType, int setIdx, int value )
  { actionRuleBlaOptions[ netIdx ][ ruleType ][ setIdx ] = (short)value; }
  public void setActionRuleBla( double[][][] values )
  {  actionRuleBlas = CommonMethods.copy( values ); }
  public void setActionRuleBla( int netIdx, int ruleType, double[] values )
  {  actionRuleBlas[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setActionRuleBla( int netIdx, int ruleType, int setIdx, double value )
  {  actionRuleBlas[ netIdx ][ ruleType ][ setIdx ] = value; }
  public void setActionRuleBlaParas( double[][][][] values )
  {  actionRuleBlaParas = CommonMethods.copy( values ); }
  public void setActionRuleBlaParas( int netIdx, int ruleType, double[][] values )
  {  actionRuleBlaParas[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setActionRuleBlaParas( int netIdx, int ruleType, int setIdx, double[] values )
  {  actionRuleBlaParas[ netIdx ][ ruleType ][ setIdx ] = CommonMethods.copy( values ); }
  public void setRuleUtilityOption( short[][][] values )
  {  ruleUtilityOptions = CommonMethods.copy( values ); }
  public void setRuleUtilityOption( int netIdx, int ruleType, short[] values )
  {  ruleUtilityOptions[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setRuleUtilityOption( int netIdx, int ruleType, int setIdx, int value )
  {  ruleUtilityOptions[ netIdx ][ ruleType ][ setIdx ] = (short)value; }
  public void setRuleUtilityParas( double[][][][] values )
  {  ruleUtilityParas = CommonMethods.copy( values ); }
  public void setRuleUtilityParas( int netIdx, int ruleType, double[][] values )
  {  ruleUtilityParas[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setRuleUtilityParas( int netIdx, int ruleType, int setIdx, double[] values )
  {  ruleUtilityParas[ netIdx ][ ruleType ][ setIdx ] = CommonMethods.copy( values ); }
  public void setAcsChunkBlaOption( short[][][] values )
  {  acsChunkBlaOptions = CommonMethods.copy( values ); }
  public void setAcsChunkBlaOption( int netIdx, int ruleType, short[] values )
  {  acsChunkBlaOptions[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setAcsChunkBlaOption( int netIdx, int ruleType, int setIdx, int value )
  {  acsChunkBlaOptions[ netIdx ][ ruleType ][ setIdx ] = (short)value; }
  public void setAcsChunkBla( double[][][] values )
  {  acsChunkBlas = CommonMethods.copy( values ); }
  public void setAcsChunkBla( int netIdx, int ruleType, double[] values )
  {  acsChunkBlas[ netIdx ][ ruleType ] = CommonMethods.copy( values ); }
  public void setAcsChunkBla( int netIdx, int ruleType, int setIdx, double value )
  {  acsChunkBlas[ netIdx ][ ruleType ][ setIdx ] = value; }
  public void setAcsChunkBlaParas( double[][][][] values )
  {  acsChunkBlaParas = CommonMethods.copy( values );  }
  public void setAcsChunkBlaParas( int netIdx, int ruleType, double[][] values )
  {  acsChunkBlaParas[ netIdx ][ ruleType ] = CommonMethods.copy( values );  }
  public void setAcsChunkBlaParas( int netIdx, int ruleType, int setIdx, double[] values )
  {  acsChunkBlaParas[ netIdx ][ ruleType ][ setIdx ] = CommonMethods.copy( values ); }
 /********************* SETTINGS ABOUT GOAL STRUCTURE *************************/
  public void setGS( GoalStructure value ){ gs = value; }
  public void setGoalFeatureLabels( String[] values ){  goalFeatLabels = CommonMethods.copy( values ); }
  public void getGoalChunkLabels( String[] values ){  goalChunkLabels = CommonMethods.copy( values );  }
  public void setGoals( short[][][] values ){  goals = CommonMethods.copy( values );  }
  public void setGoalChunkSize( int value ){  size_gc = value; }
  //the length of each goal parameter dimension.
  public void setGoalParaDimVals( short[] values ){  goalParaDimVals = CommonMethods.copy( values ); }
  public void setGoalStructSize( int value ){  size_g = value; }
  // threshol when checking qualification for participating in the competition of the goal list.
  public void setGoalActivationThreshold( double value ){  threshold_GS = value; }
  // goal decided by TL or both of levels.
  public void setGoalDecisionMode( int value ){  goalDecisionMode = value;  }
  public void setGoalBlaOption( int value ){ goalBlaOption = value; }
  public void setGoalBla( double value ){ goalBla = value; }
  public void setGoalBlaParas( double[] values ){goalBlaParas = CommonMethods.copy( values );}
  public void setExternCorConstant( double value ){ P_EXT = value; }
  public void setGoalCorConstant( double value ){ P_GS = value; }
  public void setGsItemDimInfo( short[][] values ){ gsItemDimInfo = CommonMethods.copy( values ); }
  public void setGsItemDimInfo( int dimIdx, short[] values )
  { gsItemDimInfo[dimIdx] = CommonMethods.copy( values ); }
  public void setGsItemLength( int value ){ gsItemLength = value; }
 /********************* SETTINGS ABOUT WORKING MEMORY *************************/
  public void setWM( WM value ){ wm = value; }
  public void setWmSize( int value ){ size_wm = value; }
  public void setWmActivationThreshold( double value ) { threshold_WM = value; }
  public void setWmFlagsOn( boolean value ){ wmFlagsOn = value; }
  public void setWmActionDecisionMode( int value ){ wmActionDecisionMode = value; }
  public void setWmActionFlagDecisionMode( int value ){ wmActionFlagDecisionMode = value; }
  public void setWmBlaOption( int value ){ wmBlaOption = value; }
  public void setWmBla( double value ){ wmBla = value; }
  public void setWmBlaParas( double[] values ){ wmBlaParas = CommonMethods.copy( values ); }
  public void setWmItemNums( short[] values ){ wmItemNums = CommonMethods.copy( values ); }
  public void setWmItemDimInfos( short[][][] values ){ wmItemDimInfos = CommonMethods.copy( values ); }
  public void setWmItemDimInfos( int sectIdx, short[][] values ){ wmItemDimInfos[sectIdx] = CommonMethods.copy( values ); }
  public void setWmItemDimInfo( int sectIdx, int dimIdx, short[] values )
  { wmItemDimInfos[sectIdx][dimIdx] = CommonMethods.copy( values ); }
  public void setWmItemLengths( short[] values ){ wmItemLengths = CommonMethods.copy( values ); }
  /***************** SETTINGS ABOUT COORDINATING ARS AND IDN *******************/
  public void setOverrideByIdn( boolean value ) { overrideByIdnOn = value; }
  public void setCombineDeterMode(int value){ combineDeterMode=value;}
  public void setAcsCrossCombineModes(short[][] values ){ acsCrossCombModes = CommonMethods.copy( values ); }
  public void setAcsCrossCombineMode(int netIdx, short[] values)
  { acsCrossCombModes[netIdx] = CommonMethods.copy( values ); }
  public void setAcsCrossCombineMode(int netIdx,int modelIdx, int value)
  { acsCrossCombModes[netIdx][modelIdx] = (short)value; }
  public void setAcsCrossCombineParas(double[][] values ){ acsCrossCombParas = CommonMethods.copy( values ); }
  public void setAcsCrossCombineParas(int netIdx,double[] values){acsCrossCombParas[netIdx]=values;}
  public void setAcsCrossCombineVarParaAboves(double[][] values ){ c3s = CommonMethods.copy( values ); }
  public void setAcsCrossCombineVarParaAboves(int netIdx,double[] values){ c3s[netIdx]=values;}
  public void setAcsCrossCombineVarParaUnders(double[][] values ){  c4s = CommonMethods.copy( values ); }
  public void setAcsCrossCombineVarParaUnders(int netIdx, double[] values ){ c4s[netIdx]=values;}
  public void setCorMultiExtMode( int value ){ corMultiExtMode = value; }
 /************** SETTINGS ABOUT NON-ACTION-CENTERED SUBSYSTEM *****************/
 /******************** SETTINGS ABOUT NACS COMPONENTS *************************/
  public void setGKSon( boolean value ){ gksOnFlag = value; }
  public void setAmnNum( int value ){ amnNum = value; }
  public void setEMon( boolean value ){ emOnFlag = value; }
  public void setAEMon( boolean value ){ aemOnFlag = value; }
 /******************** SETTINGS ABOUT GKS REPRESENATIONS **********************/
  public void setGksInputDimVals( short[] values ){ gksInputDimVals = CommonMethods.copy( values ); }
  public void setGksOutputDimVals( short[] values ){ gksOutputDimVals = CommonMethods.copy( values ); }
 // include each feature's type and order in that type.
  public void setGksInputFeatureInfo( short[][] values ){ gksInputFeatureInfo=values; }
  // include each feature's type and order in that type.
  public void setGksOutputFeatureInfo( short[][] values ){ gksOutputFeatureInfo=values; }
  public void setGksMaxChunkNum( int value ){ gksMaxChunkNum = value; }
  // chunk selection temperature.
  public void setGksOutputTemperature( double value ){ gksOutputTemperature = value; }
  public void setESChunkOn( boolean value ){ esChunkOnFlag = value; }
  public void setEpiChunkOn( boolean value ){ epiChunkOnFlag = value; }
  /******************* the following for NACS rules ********************/
  public void setAssocUtilityOn( boolean value ){ assocUtilityOn = value; }
  public void setAssocSupportOn( boolean value ){ assocSupportOn = value; }
  public void setAssocPartMatchOn( boolean value ){ assocPartMatchOn = value; }
  public void setAssocBlaOn( boolean value ){ assocBlaOn = value; }
  public void setNacsChunkBlaOn( boolean value ){ nacsChunkBlaOn = value; }
  public void setAssocUtilityOption( int value ){ assocUtilityOption = value; }
  public void setAssocUtilityParas( double[] values ){ assocUtilityParas = CommonMethods.copy( values ); }
  public void setAssocWeightMode( int value ){ assocWeightMode = value; }
  public void setAssocBlaOption( int value ){ assocBlaOption = value; }
  public void setAssocBla( double value ){ assocBla = value; }
  public void setAssocBlaParas( double[] values ){ assocBlaParas = CommonMethods.copy( values ); }
  public void setChunkBlaOption( int value ){ chunkBlaOption = value; }
  public void setChunkBla( double value ){ chunkBla = value; }
  public void setChunkBlaParas( double[] values ){ chunkBlaParas = CommonMethods.copy( values ); }
  public void setEmBlaOptions( short[] values ){ emBlaOptions = CommonMethods.copy( values ); }
  public void setEmBlas( double[] values ){ emBlas = CommonMethods.copy( values ); }
  public void setEmBlaParas( double[][] values ){ emBlaParas = CommonMethods.copy( values ); }
  public void setThreshold_EM( double value ){ threshold_EM = value; }
  public void setEmCapacity( int value ){ emCapacity = value; }
  public void setEmTrainProb( double value ){ emTrainProb = value; }
  public void setEmTrainItemNum( int value ){ c9 = value; }
  public void setEmTrainIterNum( int value ){ c10 = value; }
  public void setThreshold_sim( double value ){ threshold_sim = value; }
  public void setSBR_BalConstant( double value ){ c14 = value; }
  public void setRBR_BalConstant( double value ){ c15 = value; }
 /*********************** SETTINGS ABOUT GKS LEARNINGS ************************/
  public void setAssocExtractOn( boolean value ){ assocExtractOn = value; }
  public void setAssocEncodeExternOn( boolean value ){ assocEncodeExternOn = value; }
  public void setAssocAssimiOn( boolean value ){ assocAssimiOn = value; }
  public void setChunkEncodeExternOn( boolean value ){ chunkEncodeExternOn = value; }
  public void setChunkFromAmnOn( boolean value ){ chunkFromAmnOn = value; }
  public void setChunkByMCSOn( boolean value ){ chunkByMCSOn = value; }
  public void setChunkEncodeProb( double value ){ p_c = value; }
  public void setAssocEncodeProb( double value ){ p_a = value; }
  public void setChunkDensity( double value ){ d_c = value; }
  public void setAssocDensity( double value ){ d_a = value; }
  public void setAssocExtThreshold( double value ){ threshold_ae = value; }
  public void setChunkExtThreshold( double value ){ threshold_ce = value; }
  public void setAssocExtProb( double value ){ p_ae = value; }
  public void setChunkExtProb( double value ){ p_ce = value; }
  public void setActivationMeasure( int value ){ activationMeasure = value; }
 /******************** SETTINGS ABOUT AMN REPRESENATIONS **********************/
 /*-------- AMN SETTINGS --------*/
  public void setAmnTypes( short[] values ){ amnTypes = CommonMethods.copy( values ); }
  public void setAmnType( int idx, int value ){ amnTypes[ idx ] = (short)value; }
  public void setAmnInputDimVals( short[][] values ){ amnInputDimVals = CommonMethods.copy( values ); }
  public void setAmnInputDimVals( int idx, short[] values ){ amnInputDimVals[ idx ] = CommonMethods.copy( values ); }
  public void setAmnOutputDimVals( short[][] values ){ amnOutputDimVals = CommonMethods.copy( values ); }
  public void setAmnOutputDimVals( int idx, short[] values ){ amnOutputDimVals[ idx ] = CommonMethods.copy( values ); }
 // include each feature's type and order in that type.
  public void setAmnInputFeatureInfo( short[][][] values ){ amnInputFeatureInfo=values; }
  public void setAmnInputFeatureInfo( int idx, short[][] values ){ amnInputFeatureInfo[idx]=values; }
  // include each feature's type and order in that type.
  public void setAmnOutputFeatureInfo(short[][][] values){ amnOutputFeatureInfo=values; }
  public void setAmnOutputFeatureInfo(int idx,short[][] values){ amnOutputFeatureInfo[idx]=values; }
  public void setAmnHiddenNums( short[] values ){ amnHiddenNums = CommonMethods.copy( values ); }
  public void setAmnHiddenNum( int netIdx, int value ){ amnHiddenNums[netIdx] = (short)value; }
  //public void setAmnInputChunkTypes( short[] values ){ amnInputChunkTypes = CommonMethods.copy( values ); }
  //public void setAmnInputChunkType( int idx, int value ){ amnInputChunkTypes[ idx ] = (short)value; }
  //public void setAmnOutputChunkTypes( short[] values ){ amnOutputChunkTypes = CommonMethods.copy( values ); }
  //public void setAmnOutputChunkType( int idx, int value ){ amnOutputChunkTypes[idx] = (short)value; }
  public void setAmnMultiPassOns( boolean[] values ){ amnMultiPassOns = CommonMethods.copy( values ); }
  public void setAmnMultiPassOn( int idx, boolean value ){ amnMultiPassOns[ idx ] = value; }
  public void setAmnMultiFlagOn( boolean value ) { amnMultiFlagOn = value; }
 /*-------- AAM SETTINGS --------*/
  public void setAmnIterNums( short[] values ){ amnIterNum = CommonMethods.copy( values ); }
  public void setAmnIterNum( int idx, int value ){ amnIterNum[ idx ] = (short)value; }
  public void setAamTrainProb( double value ){ aamTrainProb = value; }
  public void setAamTrainPatternType( int value ){ aamTrainPatternType = value; }
  public void setAamTrainPatternNum( int value ){ aamTrainPatternNum = value; }
  public void setAamTrainIterNum( int value ){ aamTrainIterNum = value; }
 /*-------- HAM SETTINGS --------*/
  public void setHamTrainProb( double value ){ hamTrainProb = value; }
  public void setHamTrainAssocMapNum( int value ){ hamTrainAssocMapNum = value; }
  public void setHamTrainIterNum( int value ){ hamTrainIterNum = value; }
 /*-------- AMN BP SETTINGS --------*/
  public void setAmnBPLearningRates( double[] values ){ amnLRs = CommonMethods.copy( values ); }
  public void setAmnBPLearningRate( int idx, double value ){ amnLRs[ idx ] = value; }
  public void setAmnBPMomentums( double[] values ){ amnMoms = CommonMethods.copy( values ); }
  public void setAmnBPMomentum( int idx, double value ){ amnMoms[ idx ] = value; }
 /*-------- AEM SETTINGS --------*/
  public void setAemStateNumBound( int value ){ aemStateNumBound = value; }
  public void setAemTrainedByEmProb( double value ){ aemTrainedByEmProb = value; }
  public void setAemTrainedByEmItemNum( int value ){ aemTrainedByEmItemNum = value; }
  public void setAemTrainedByEmBPLearningRate( double value ){ aemTrainedByEmLR = value; }
  public void setAemTrainedByEmBPMomentum( double value ){ aemTrainedByEmMom = value; }
  public void setAemPotentialNextStateNum( int value ){ aemPotentialNextStateNum = value; }
  public void setAemTrainAcsProb( double value ){ aemTrainAcsProb = value; }
  public void setAemTrainAcsSampleNum( int value ){ aemTrainAcsSampleNum = value; }
  public void setAemTrainAcsIterNum( int value ){ aemTrainAcsIterNum = value; }
  public void setAemTrainAcsOutputTemp( double value ){ aemTrainAcsOutputTemp = value; }
 /**************** SETTINGS ABOUT COORDINATING ACS and NACS *******************/
  public void setCorAcsNacsType( int value ) { corAcsNacsType = value; }
  public void setReasoningByMCSOn( boolean value ){ reasoningByMCSOn = value; }
  // forward chaining, backward-chaining, simi-based forward, counterfactual, proof by contradiction.
  public void setGksReasoningMethod( int value ){ gksReasoningMethod = value; }
  public void setGksReasonIterNum( int value ){ gksReasonIterNum = value; }
  public void setGksReasonByMCSOn( boolean value ){ gksReasonByMCSOn = value; }
  public void setAdmTLReasoningMethod( int value ){ admTLReasoningMethod = value; }
  public void setAdmReasonIterNum( int value ){ admReasonIterNum = value; }
  public void setAdmReasonByMCSOn( boolean value ){ admReasonByMCSOn = value; }
 /****************** SETTINGS ABOUT SUPERVISORY SUBSYSTEM *********************/
  public void setMsOn( boolean value ){ msOn = value; }
  public void setMcsOn( boolean value ){ mcsOn = value; }
  public void setMS( MS value ){ ms = value; }
  public void setMCS( MCS value ){ mcs = value; }
  public void setMonitorAcsTopConcNum( int value ){  c20 = value; }
  public void setMonitorAcsBottomConcNum( int value ){  c24 = value; }
  public void setMonitorAcsTopStepNum( int value ){  c22 = value; }
  public void setMonitorAcsBottomStepNum( int value ){  c26 = value; }
  public void setMonitorAcsTopEpisodeNum( int value ){  c28 = value; }
  public void setMonitorAcsBottomEpisodeNum( int value ){  c30 = value; }
  public void setMonitorNacsTopConcNum( int value ){  c21 = value; }
  public void setMonitorNacsBottomConcNum( int value ){  c25 = value; }
  public void setMonitorNacsTopStepNum( int value ){  c23 = value; }
  public void setMonitorNacsBottomStepNum( int value ){  c27 = value; }
  public void setMonitorNacsTopEpisodeNum( int value ){  c29 = value; }
  public void setMonitorNacsBottomEpisodeNum( int value ){  c31 = value; }
 /*************** SETTINGS ABOUT RESPONSE TIME DETERMINATION ******************/
  public void setRTOn( boolean value ){ rtOn = value; }
  //public void setMaxUsageNum( int value ){ maxUsageNum = value;  }
  public void setOverallFormula( String value ){ overallFormula = value; }
  public void setBLFormula( String value ){ blFormula = value; }
  public void setTLFormula( String value ){ tlFormula = value; }
  public void setPT_BL( int value ){ PT_BL = value; }
  public void setDT_BL( int value ){ DT_BL = value; }
  public void setAT_BL( int value ){ AT_BL = value; }
  public void setPT_TL( int value ){ PT_TL = value; }
  // used for calculating DT_TL = DT_TL_actioTime + t0/rule_bla + t1/chunk_bla;
  public void setDT_TL_actionTime( int value ){ DT_TL_actionTime = value; }
  public void setDT_TL_t0( double value ){ t0 = value; }
  public void setDT_TL_t1( double value ){ t1 = value; }
  public void setAT_TL( int value ){ AT_TL = value; }
  public void setAssoAppTimeFormula( String value ){ assocAppTimeFormula = value; }
  public void setAssocAppTime_t4( double value ){ t4 = value; }
  public void setAssocAppTime_t5( double value ){ t5 = value; }
  public void setChunkRetTimeFormula( String value ){ chunkRetTimeFormula = value; }
  public void setChunkRetTime_t2( double value ){ t2 = value; }
  public void setChunkRetTime_t3( double value ){ t3 = value; }
  public void setAmnOnePassTime( int value ){ t_AMN = value; }
 /************************** SETTINGS ABOUT INTERFACE *************************/
  public void setRuleDisplayMode( int value ){ ruleDisplayMode = value; }
  public void setRuleDisplayFreq( int value ){ ruleDisplayFreq = value; }
 /************************ SETTING ABOUT TASK-SPECIFIC ************************/
  public void setLearningTestOn( boolean value ){ learningTestOn = value; }
  public void setEpisodeLength( int value ){ episodeLength = value; }
  public void setAgentGroupId( int value ){ agentGroupId = value; }
  public void setTaskAgent( TaskAgent value ){ taskAgent = value; }
  public void setACS( ACS value ){ acs = value; }
  public void setNACS( NACS value ){ nacs = value; }
  public void setOptionName( String value ){ optionName = value; }
  static public void setRootDir( String value ){ rootDir = value; }
  static public void setOptionDir( String value ){ optionDir = value; }
  static public void setDataDir( String value ){ dataDir = value; }
  static public void setTask( Task value ){ task = value; }
  static public void setTaskClarionClass( Class value ){ taskClarionClass = value; }
  public void setTaskClarion( TaskClarion value ){ taskClarion = value; }
  static public void setTaskDir( String value ){ taskDir = value; }
  static public void setTaskName( String value ){ taskName = value; }
  static public void setTaskPackageName( String value ){ taskPkgName = value; }
  static public void setTaskClassName( String value ){ taskClsName = value; }
  static public void setSettingMode( boolean value ) { guiFlag = value; }
  public void setInputFormat( boolean[] values ) { inputFormat = CommonMethods.copy( values ); };
  public void setOutputFormat( boolean[] values ) { outputFormat = CommonMethods.copy( values ); }
 /*************************** INITIALIZATION CODES ******************************/
  public void initAcsNets()
  {
    idnInputDimVals = new short[acsNetNum][];
    idnOutputDimVals = new short[acsNetNum][];
    idnInputFeatureInfo = new short[acsNetNum][][];
    idnOutputFeatureInfo = new short[acsNetNum][][];
    //String  exIdnEligibleConditions[];
    idnHiddenNums = new short[acsNetNum];
    idnBLLearningOptions = new short[acsNetNum];
    idnBlAssimFreqs = new short[acsNetNum][];
    idnBPLRs = new double[acsNetNum];
    idnBPMoms = new double[acsNetNum];
    idnQDiscountRates = new double[acsNetNum];
    idnActionSelTemps = new double[acsNetNum];
    overallActionSelTemps = new double[acsNetNum];
    idnRLFuncOpts = new short[acsNetNum];
    //String  overallIdnRLFunction;
    //String  idnRLFunctions[];
    idnRLFuncByMCSs = new boolean[acsNetNum];
    arInputDimVals = new short[acsNetNum][ACS_KNOW_TYPE_NUM][];
    arOutputDimVals = new short[acsNetNum][ACS_KNOW_TYPE_NUM][];
    arInputFeatureInfo = new short[acsNetNum][ACS_KNOW_TYPE_NUM][][];
    arOutputFeatureInfo = new short[acsNetNum][ACS_KNOW_TYPE_NUM][][];
    arActionSelTemps = new double[acsNetNum][ACS_KNOW_TYPE_NUM];
    arReasoningMethods = new short[acsNetNum][ACS_KNOW_TYPE_NUM];
    arReasoningByMCSOns = new boolean[acsNetNum][ACS_KNOW_TYPE_NUM];
   /********************* SETTINGS ABOUT RULE LEARNING **************************/
    acsKnowledgeNum = 4;
    rerOns = new boolean[acsNetNum];
    irlOns = new boolean[acsNetNum];
    extInstructOns = new boolean[acsNetNum];
    ilOns = new boolean[acsNetNum];
    frOns = new boolean[acsNetNum];
    frActionVariedOns = new boolean[acsNetNum][];
    acsRLByMCSs = new boolean[acsNetNum];
    maxRerRuleNum = 500;
    //String  frSets[][];
    frConditions = new short[acsNetNum][][][];
    frActions = new short[acsNetNum][][];
    frNums = new short[acsNetNum];
    irlSetNums = new short[acsNetNum];
    //String  irlSets[][][];
    irlRuleNums = new short[acsNetNum][];
    irlRuleParams = new double[acsNetNum][][][];
    irlGenOns = new boolean[acsNetNum];
    irlSpecOns = new boolean[acsNetNum];
    d_is = new double[acsNetNum];
    d_rs = new double[acsNetNum];
    p_res = new double[acsNetNum];
    rerGenSpecModes = new short[acsNetNum];
    irlGenSpecModes = new short[acsNetNum];
    //String  rerPosCriterions[];
    //String  irlPosCriterions[];
    threshold_RERs = new double[acsNetNum];
    threshold_IRLs = new double[acsNetNum];
    //String  rerIGMeasures[];
    //String  irlIGMeasures[];
    c1s = new double[acsNetNum];
    c2s = new double[acsNetNum];
    c5s = new double[acsNetNum];
    c6s = new double[acsNetNum];
    threshold1s = new double[acsNetNum];
    threshold2s = new double[acsNetNum];
    threshold6s = new double[acsNetNum];
    threshold7s = new double[acsNetNum];
    threshold4s = new double[acsNetNum];
    rerGsValueRanges = new short[acsNetNum];
    irlGsValueRanges = new short[acsNetNum];
    ruleMergeIntervals = new short[acsNetNum];
   /******************* SETTINGS ABOUT RULE REPRESENTATIN ***********************/
    ruleUtilityOns = new boolean[acsNetNum][ACS_KNOW_TYPE_NUM][];
    ruleSupportOns = new boolean[acsNetNum][ACS_KNOW_TYPE_NUM][];
    rulePartMatchOns = new boolean[acsNetNum][ACS_KNOW_TYPE_NUM][];
    ruleBlaOns = new boolean[acsNetNum][ACS_KNOW_TYPE_NUM][];
    actionChunkBlaOns = new boolean[acsNetNum][ACS_KNOW_TYPE_NUM][];
    actionRuleWeightModes = new short[acsNetNum][ACS_KNOW_TYPE_NUM][];
    actionRuleBlaOptions = new short[acsNetNum][ACS_KNOW_TYPE_NUM][];
    actionRuleBlas = new double[acsNetNum][ACS_KNOW_TYPE_NUM][];
    actionRuleBlaParas = new double[acsNetNum][ACS_KNOW_TYPE_NUM][][];
    ruleUtilityOptions = new short[acsNetNum][ACS_KNOW_TYPE_NUM][];
    ruleUtilityParas = new double[acsNetNum][ACS_KNOW_TYPE_NUM][][];
    acsChunkBlaOptions = new short[acsNetNum][ACS_KNOW_TYPE_NUM][];
    acsChunkBlas = new double[acsNetNum][ACS_KNOW_TYPE_NUM][];
    acsChunkBlaParas = new double[acsNetNum][ACS_KNOW_TYPE_NUM][][];
 /***************** SETTINGS ABOUT COORDINATING ARS AND IDN *******************/
    acsCrossCombModes = new short[acsNetNum][2];
    acsCrossCombParas = new double[acsNetNum][];
    c3s = new double[acsNetNum][ACS_KNOW_TYPE_NUM];
    c4s = new double[acsNetNum][ACS_KNOW_TYPE_NUM];
  }

  public void initAcsRules( int netIdx, int knowType, int ruleSetNum )
  {
   /******************* SETTINGS ABOUT RULE REPRESENTATIN ***********************/
    ruleUtilityOns[netIdx][knowType] = new boolean[ruleSetNum];
    ruleSupportOns[netIdx][knowType] = new boolean[ruleSetNum];
    rulePartMatchOns[netIdx][knowType] = new boolean[ruleSetNum];
    ruleBlaOns[netIdx][knowType] = new boolean[ruleSetNum];
    actionChunkBlaOns[netIdx][knowType] = new boolean[ruleSetNum];
    actionRuleWeightModes[netIdx][knowType] = new short[ruleSetNum];
    actionRuleBlaOptions[netIdx][knowType] = new short[ruleSetNum];
    actionRuleBlas[netIdx][knowType] = new double[ruleSetNum];
    actionRuleBlaParas[netIdx][knowType] = new double[ruleSetNum][];
    ruleUtilityOptions[netIdx][knowType] = new short[ruleSetNum];
    ruleUtilityParas[netIdx][knowType] = new double[ruleSetNum][];
    acsChunkBlaOptions[netIdx][knowType] = new short[ruleSetNum];
    acsChunkBlas[netIdx][knowType] = new double[ruleSetNum];
    acsChunkBlaParas[netIdx][knowType] = new double[ruleSetNum][];
    //String  frSets[][];
    if( knowType == FR ){
        frConditions[netIdx] = new short[ruleSetNum][][];
        frActions[netIdx] = new short[ruleSetNum][];
    }
    //String  irlSets[][][];
    if( knowType == IRL ){
        irlRuleNums[netIdx] = new short[ruleSetNum];
        irlRuleParams[netIdx] = new double[ruleSetNum][][];
    }
  }

  public void initNacsNets()
  {
    amnTypes = new short[amnNum];
    amnInputChunkTypes = new short[amnNum];
    amnOutputChunkTypes = new short[amnNum];
    amnInputDimVals = new short[amnNum][];
    amnOutputDimVals = new short[amnNum][];
    amnInputFeatureInfo = new short[amnNum][][];
    amnOutputFeatureInfo = new short[amnNum][][];
    amnHiddenNums = new short[amnNum];
    amnMultiPassOns = new boolean[amnNum];
    amnIterNum = new short[amnNum];
    amnLRs = new double[amnNum];
    amnMoms = new double[amnNum];
  }
}