package clarion.system;
import clarion.common.*;
import clarion.nacs.*;
import clarion.tools.*;
import clarion.options.*;

// user needs implementation of this interface to run CLARION.
public abstract class Task {

  // the # of agents running simultineously.
  protected int runningAgentNum;
  // the agents running simultineously.
  protected TaskAgent[] agents;
  // settings of agents.
  protected Global[] globals;
  // the setting names of agents.
  protected String[] settingNames;

  public int getRunningAgentNum()
  { return runningAgentNum; }
  public void setRunningAgentNum( int num )
  { runningAgentNum = num; }
  public TaskAgent getAgent( int agentIdx )
  { return agents[agentIdx]; }
  public void setAgent( int agentIdx, TaskAgent agent )
  { agents[agentIdx] = agent; }
  public void setGlobals( Global[] globals )
  {  this.globals = globals; }
  // initialize the global of each agent without GUI.
  public void init()
  {
     for( int i = 0; i < runningAgentNum; i++ ){
          globals[i].setOptionName( settingNames[i] );
          SettingTransfer transfer = new SettingTransfer( globals[i] );
          transfer.load();
          transfer.setSaveCode( Global.SAVE_TO_GLOBAL );
          transfer.save();
     }

     //System.out.println( "rer threshold = " + globals[0].getRerGenThreshold(0) );
  }
  // the start point of the task.
  abstract public void start();
}