package clarion.tools;
import java.util.Arrays;
import clarion.common.*;

public class CommonMethods {

  static public boolean isEqual( short[] arr1, short[] arr2 )
  {
     return Arrays.equals( arr1, arr2 );
  }

  static public boolean isEqual( int[] arr1, int[] arr2 )
  {
     return Arrays.equals( arr1, arr2 );
  }

  static public boolean isEqual( float[] arr1, float[] arr2 )
  {
     return Arrays.equals( arr1, arr2 );
  }

  static public boolean isEqual( double[] arr1, double[] arr2 )
  {
     return Arrays.equals( arr1, arr2 );
  }

  static public int isEqual( short[][] arr1, short[][] arr2 )
  {
     if( arr1.length != arr2.length )
         return -1;

     int equalDimNum = 0;
     for( int i = 0; i < arr1.length; i++ )
          if( Arrays.equals( arr1[ i ], arr2[ i ] ) )
               equalDimNum++;
      return equalDimNum;
  }

  static public int isEqual( int[][] arr1, int[][] arr2 )
  {
     if( arr1.length != arr2.length )
         return -1;

     int equalDimNum = 0;
     for( int i = 0; i < arr1.length; i++ )
          if( Arrays.equals( arr1[ i ], arr2[ i ] ) )
               equalDimNum++;
      return equalDimNum;
  }

  static public int isEqual( float[][] arr1, float[][] arr2 )
  {
     if( arr1.length != arr2.length )
         return -1;

     int equalDimNum = 0;
     for( int i = 0; i < arr1.length; i++ )
          if( Arrays.equals( arr1[ i ], arr2[ i ] ) )
               equalDimNum++;
      return equalDimNum;
  }

  static public int isEqual( double[][] arr1, double[][] arr2 )
  {
     if( arr1.length != arr2.length )
         return -1;

     int equalDimNum = 0;
     for( int i = 0; i < arr1.length; i++ )
          if( Arrays.equals( arr1[ i ], arr2[ i ] ) )
               equalDimNum++;
      return equalDimNum;
  }

  // if array a1 contains array a2.
  static public short contain( short[] a1, short[] a2 )
  {
     int len = a1.length;
     if( len != a2.length )
         return 0;

     for( int i = 0; i < len; i++ )
          if ( ( a1[i] == 0 ) && ( a2[i] == 1 ) )
               return (short)0;

     return (short)1;
  }

  // if array a1 contains array a2.
  static public short contain( double[] a1, short[] a2 )
  {
     int len = a1.length;
     if( len != a2.length )
         return 0;

     for( int i = 0; i < len; i++ )
          if ( ( a1[i] == 0.0 ) && ( a2[i] == 1 ) )
               return (short)0;

     return (short)1;
  }

  static public int getSum( short[] arr )
  {
     int sum = 0;
     for( int i = 0; i < arr.length; i++ )
          sum += arr[i];
     return sum;
  }

  static public int getSum( int[] arr )
  {
     int sum = 0;
     for( int i = 0; i < arr.length; i++ )
          sum += arr[i];
     return sum;
  }

  static public float getSum( float[] arr )
  {
     float sum = 0;
     for( int i = 0; i < arr.length; i++ )
          sum += arr[i];
     return sum;
  }

  static public double getSum( double[] arr )
  {
     double sum = 0.0;
     for( int i = 0; i < arr.length; i++ )
          sum += arr[i];
     return sum;
  }

  static public int getMaxValueIdx( double[] values )
  {
     int idx = 0;
     double maxVal = values[ 0 ];
     for( int i = 1; i < values.length; i++ ){
          if( maxVal < values[i] ){
              idx = i;
              maxVal = values[i];
          }
     }
     return idx;
  }

  static public int getDiffNum( Feature[] f1, Feature[] f2 )
  {
     int length = Math.min( f1.length, f2.length );
     int diffNum = 0;
     for( int i = 0; i < length; i++ )
          if( f1[i] != null ){
            if( !f1[i].equals( f2[i] ) )
                diffNum++;
          }
          else if( f2[i] != null )
               diffNum++;
     return diffNum;
  }

  static public void calcOffsets( short[] offsets, short[] dimVals )
  {
     offsets[0] = 0;
     for( int i = 1; i < offsets.length; i++ )
          offsets[i] = (short)(offsets[i-1] + dimVals[i-1]);
  }

  static public int calcLength( double[] arr )
  {
     return arr.length;
  }

  static public int calcLength( double[][] arr )
  {
     int len = 0;
     for( int i = 0; i < arr.length; i++ )
          len += arr[i].length;
     return len;
  }

  static public int calcLength( double[][][] arr )
  {
     int len = 0;
     for( int i = 0; i < arr.length; i++ )
       for( int j = 0; j < arr[i].length; j++ )
            len += arr[i][j].length;
     return len;
  }

  static public void resetArray( short[][] arr, int val )
  {
     for( int i = 0; i < arr.length; i++ )
       for( int j = 0; j < arr[i].length; j++ )
            arr[i][j] = (short)val;
  }

  static public void showValues( short[] arr )
  {
     String str = "";
     for( int i = 0; i < arr.length; i++ )
          str += String.valueOf( arr[i] ) + ", ";
     System.out.println( str );
  }

  static public void showValues( double[] arr )
  {
     String str = "";
     for( int i = 0; i < arr.length; i++ )
          str += "value " + i + " = " + String.valueOf( arr[i] ) + "\n";
     System.out.println( str );
  }

/********************************* COPY mehods *******************************/
  static public boolean[] copy( boolean[] values )
  {
     boolean[] newValues = new boolean[ values.length ];
     for( int i = 0; i < values.length; i++ )
          newValues[i] = values[i];
     return newValues;
  }

  static public short[] copy( short[] values )
  {
     short[] newValues = new short[ values.length ];
     for( int i = 0; i < values.length; i++ )
          newValues[i] = values[i];
     return newValues;
  }

  static public double[] copy( double[] values )
  {
     double[] newValues = new double[ values.length ];
     for( int i = 0; i < values.length; i++ )
          newValues[i] = values[i];
     return newValues;
  }

  static public String[] copy( String[] values )
  {
     String[] newValues = new String[ values.length ];
     for( int i = 0; i < values.length; i++ )
          newValues[i] = new String( values[i] );
     return newValues;
  }

  static public boolean[][] copy( boolean[][] values )
  {
     boolean[][] newValues = new boolean[ values.length ][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new boolean[values[i].length];
          for( int j = 0; j < values[i].length; j++ )
               newValues[i][j] = values[i][j];
     }
     return newValues;
  }

  static public short[][] copy( short[][] values )
  {
     short[][] newValues = new short[ values.length ][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new short[values[i].length];
          for( int j = 0; j < values[i].length; j++ )
               newValues[i][j] = values[i][j];
     }
     return newValues;
  }

  static public double[][] copy( double[][] values )
  {
     double[][] newValues = new double[ values.length ][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new double[values[i].length];
          for( int j = 0; j < values[i].length; j++ )
               newValues[i][j] = values[i][j];
     }
     return newValues;
  }

  static public String[][] copy( String[][] values )
  {
     String[][] newValues = new String[ values.length ][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new String[values[i].length];
          for( int j = 0; j < values[i].length; j++ )
               newValues[i][j] = new String( values[i][j] );
     }
     return newValues;
  }

  static public boolean[][][] copy( boolean[][][] values )
  {
     boolean[][][] newValues = new boolean[ values.length ][][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new boolean[values[i].length][];
          for( int j = 0; j < values[i].length; j++ ){
               newValues[i][j] = new boolean[values[i][j].length];
               for( int k = 0; k < values[i][j].length; k++ )
                    newValues[i][j][k] = values[i][j][k];
          }
     }
     return newValues;
  }

  static public short[][][] copy( short[][][] values )
  {
     short[][][] newValues = new short[ values.length ][][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new short[values[i].length][];
          for( int j = 0; j < values[i].length; j++ ){
               newValues[i][j] = new short[values[i][j].length];
               for( int k = 0; k < values[i][j].length; k++ )
                    newValues[i][j][k] = values[i][j][k];
          }
     }
     return newValues;
  }

  static public int[][][] copy( int[][][] values )
  {
     int[][][] newValues = new int[ values.length ][][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new int[values[i].length][];
          for( int j = 0; j < values[i].length; j++ ){
               newValues[i][j] = new int[values[i][j].length];
               for( int k = 0; k < values[i][j].length; k++ )
                    newValues[i][j][k] = values[i][j][k];
          }
     }
     return newValues;
  }

  static public double[][][] copy( double[][][] values )
  {
     double[][][] newValues = new double[ values.length ][][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new double[values[i].length][];
          for( int j = 0; j < values[i].length; j++ ){
               newValues[i][j] = new double[values[i][j].length];
               for( int k = 0; k < values[i][j].length; k++ )
                    newValues[i][j][k] = values[i][j][k];
          }
     }
     return newValues;
  }

  static public String[][][] copy( String[][][] values )
  {
     String[][][] newValues = new String[ values.length ][][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new String[values[i].length][];
          for( int j = 0; j < values[i].length; j++ ){
               newValues[i][j] = new String[values[i][j].length];
               for( int k = 0; k < values[i][j].length; k++ )
                    newValues[i][j][k] = new String( values[i][j][k] );
          }
     }
     return newValues;
  }

  static public short[][][][] copy( short[][][][] values )
  {
     short[][][][] newValues = new short[ values.length ][][][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new short[values[i].length][][];
          for( int j = 0; j < values[i].length; j++ ){
               newValues[i][j] = new short[values[i][j].length][];
               for( int k = 0; k < values[i][j].length; k++ ){
                    newValues[i][j][k] = new short[values[i][j][k].length];
                    for( int m = 0; m < values[i][j].length; m++ )
                         newValues[i][j][k][m] = values[i][j][k][m];
               }
          }
     }
     return newValues;
  }

  static public double[][][][] copy( double[][][][] values )
  {
     double[][][][] newValues = new double[ values.length ][][][];
     for( int i = 0; i < values.length; i++ ){
          newValues[i] = new double[values[i].length][][];
          for( int j = 0; j < values[i].length; j++ ){
               newValues[i][j] = new double[values[i][j].length][];
               for( int k = 0; k < values[i][j].length; k++ ){
                    newValues[i][j][k] = new double[values[i][j][k].length];
                    for( int m = 0; m < values[i][j].length; m++ )
                         newValues[i][j][k][m] = values[i][j][k][m];
               }
          }
     }
     return newValues;
  }

  static public int calcGsItemLength( short[][] gsItemDimInfo, short[][] featLengths )
  {
      int dimLen = gsItemDimInfo.length;
      int itemLength = 0;
      for( int k = 0; k < dimLen; k++ ){
           int featType = gsItemDimInfo[k][0];
           int featOrder = gsItemDimInfo[k][1];
           itemLength += featLengths[featType][featOrder];
      }
      return itemLength;
  }

  static public short[] calcWmItemLengths( int size, short[] wmItemNums,
                        short[][][] wmItemDimInfos, short[][] featLengths )
  {
     short[] wmItemLengths = new short[ size ];
     int itemIdx = 0;
     for( int i = 0; i < wmItemNums.length; i++ )
      for( int j = 0; j < wmItemNums[i]; j++ ){
           int dimLen = wmItemDimInfos[i].length;
           int itemLength = 0;
           for( int k = 0; k < dimLen; k++ ){
                int featType = wmItemDimInfos[i][k][0];
                int featOrder = wmItemDimInfos[i][k][1];
                itemLength += featLengths[featType][featOrder];
           }
           wmItemLengths[itemIdx++] = (short)itemLength;
     }
     return wmItemLengths;
  }
}