// Write information to A RandomAccessFile
package clarion.tools;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JFileChooser;
import clarion.common.*;

public class WriteFile  {

   private final int INTERVAL = 1;
   private final int READ_TYPE = 0;
   private final int WRITE_TYPE = 1;

   private String EQUAL_STR = " = ";
   private String SELECT_STR = ", current choices are: ";

   private RandomAccessFile output;
   private String  fName;
   private File    fileName;

   public WriteFile()
   {
   }

   public String getCurDir()
   {
       return System.getProperty( "user.dir" );
   }

   public boolean openFile( int type, String partName )
   {
       String wholeName = new String("");
       int counter = 0;
       boolean bVal = true;
       boolean existFlag = true;

       while( bVal )
       {
          wholeName =  partName + String.valueOf( counter ) + ".txt" ;
          File name = new File( wholeName );
          bVal = name.exists();
          if( bVal )
              counter++;
       }

       if( type == WRITE_TYPE )
           fName = wholeName;
       else
       {
          if( counter == 0 )
          {
              JOptionPane.showMessageDialog( null, "The file doesn't exist,create?",
                             "File Create",  JOptionPane.PLAIN_MESSAGE );
              existFlag = false;
              fName = wholeName;
          }
          else
          {
              existFlag = true;
              wholeName =  partName + String.valueOf( counter - 1 ) + ".txt" ;
              fName = wholeName;
          }
       }

       try {
              output = new RandomAccessFile( fName, "rw" );
           }
       catch ( IOException e ) {
                JOptionPane.showMessageDialog( null, "File Operation Error",
                      "Invalid File Name", JOptionPane.ERROR_MESSAGE );
              }

      return existFlag;
   }

   public boolean findFile( int whichSetting, int type )
   {
      String  str = new String("");
      switch( whichSetting )
      {
        case 0:
                str = "curParaSet";
                break;
        case 1:
                str = "defParaSet";
                break;
      }

      boolean bVal = openFile( type, str );
      return bVal;
   }

   public boolean readParameters( double[] arr )
   {
      try {
            long fileLen = output.length();
            if( fileLen == 0 )
                return false;

            output.seek( 0 );
            String str = output.readLine();
            while ( str.compareTo( World.TASK_PARA_TEXT[ 0 ] + EQUAL_STR ) != 0 )
                    str = output.readLine();

            int maxLength = World.TASK_PARA_NUM;
            for( int i = 0; i < maxLength; i++ )
            {
               int idx = str.indexOf( EQUAL_STR );
               String subStr = str.substring( idx + EQUAL_STR.length() );
               String dStr = subStr.trim();
               arr[ i ] = Double.parseDouble( dStr );
               if( i < maxLength - 1 )
                   str = output.readLine();
            }
      }
      catch ( IOException e ) {
                JOptionPane.showMessageDialog( null, "File Operation Error",
                      "File read error!", JOptionPane.ERROR_MESSAGE );
              }

      return true;
   }

   public void writeParameters( double[] arr )
   {
      for( int i = 0; i < arr.length; i++ )
      {
         try {
                output.writeBytes( World.TASK_PARA_TEXT[ i ] + EQUAL_STR );
                output.writeBytes( String.valueOf( arr[ i ] ) );
                output.writeBytes( "\n" );
         }
         catch( IOException e )
         {
               JOptionPane.showMessageDialog( null, "file operation error",
                                   "Write Error", JOptionPane.ERROR_MESSAGE );
         }
      }
   }

   public void writeMainParameters( int[][] arr )
   {
      for( int i = 0; i < arr.length; i++ )
      {
         try {
                output.writeBytes( World.MAIN_OPTION_TEXT[ i ] + SELECT_STR );
                output.writeBytes( "\n" );
                for( int j = 0; j < arr[ i ].length; j++ )
                {
                  try {
                        output.writeBytes( World.MAIN_OPT_ITEM_TEXT[ i ][ j ] );
                        if( arr[ i ][ j ] == 1 )
                            output.writeBytes( " ---(SELECTED)" );
                       output.writeBytes( "\n" );
                  }
                  catch( IOException e )
                  {
                     JOptionPane.showMessageDialog( null, "file operation error",
                                    "Write Error", JOptionPane.ERROR_MESSAGE );
                  }
                }
                output.writeBytes( "\n" );
         }
         catch( IOException e )
         {
               JOptionPane.showMessageDialog( null, "file operation error",
                                   "Write Error", JOptionPane.ERROR_MESSAGE );
         }
      }
   }

   public void readLine( String str )
   {
      try {
            str = output.readLine();
      }
      catch ( IOException e ) {
                JOptionPane.showMessageDialog( null, "File Operation Error",
                      "File read error!", JOptionPane.ERROR_MESSAGE );
      }
   }

   public String getFileName()
   {
       return fName;
   }

   public RandomAccessFile openFile()
   {
      JFileChooser fileChooser = new JFileChooser();

      fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY );
      int result = fileChooser.showSaveDialog( null );

      if(result == JFileChooser.CANCEL_OPTION )
        return null;

      fileName = fileChooser.getSelectedFile();

      if( fileName == null || fileName.getName().equals(""))
        JOptionPane.showMessageDialog( null, "Invalid File Name",
          " Invalid File Name", JOptionPane.ERROR_MESSAGE );
      else {
         try {
               output = new RandomAccessFile( fileName, "rw" );
               fName = fileName.getName();
             }
         catch ( IOException e ) {
                JOptionPane.showMessageDialog( null, "File does not exits",
                      "Invalid File Name", JOptionPane.ERROR_MESSAGE );
              }
      }

     return output;
   }

   public void closeFile()
   {
      try {
           output.close();
      }
      catch( IOException ex ) {
          JOptionPane.showMessageDialog( null,"Error closing file",
                                         "Error", JOptionPane.ERROR_MESSAGE );
         System.exit( 1 );
      }
   }

   public void saveData( int[][] arr1, int[][] arr2, int bNum, int tNum )
  {
    for( int i = 0; i < bNum; i++ )
      for( int j = 1; j < tNum; j++)
      {
         try {
              output.writeInt( arr1[i][j] );
              output.writeInt( arr1[i][j] );
         }
         catch( IOException e )
         {
            JOptionPane.showMessageDialog( null, "file operation error",
                                           "Error", JOptionPane.ERROR_MESSAGE );
         }
      }
  }

  public void saveNumericData( int[][][] arr, int bNum, int tNum,
                               int bIdx, int tIdx )
  {

    if( ( bIdx == 0 ) && ( tIdx == 0 ) )
        return;

    String bNumStr = String.valueOf( bNum );
    String tNumStr = String.valueOf( tNum );
    String bIdxStr = String.valueOf( bIdx+1 );
    String tIdxStr = String.valueOf( tIdx );

    try {
          long beginPos = output.length();

          output.seek( beginPos );
          output.writeBytes( "\n" );

          output.writeBytes("THE PRE-SET BLOCK NUMBER = " + bNumStr + "\n" );
          output.writeBytes("THE TRIALS PER BLOCK = " + tNumStr + "\n" );

          output.writeBytes( "THE ACTUAL BLOCK NUMBER WHEN EXPERIMENT IS FINISNED = "
                             + bIdxStr + "\n" );
          //output.writeBytes("THE TRIAL NUMBER WHEN FINISHING THE EXPERIMENT = "
          //                   + tIdxStr + "\n\n" );

          output.writeBytes( "The first colum is the trial number, the second "+
                             "column is input, \n the third is output and the " +
                           " last column is the user response time \n" );
          output.writeBytes( "The first pair of input and output in each block"+
                             " is generated randomly\n\n" );

          for( int i = 0; i < bIdx; i++ )
          {
            String iStr =  String.valueOf( i );
            output.writeBytes( "Current block NO =  " + iStr + "\n\n" );

            for( int j = 0; j < tNum; j++)
            {
              if( j < 9 )
                  output.writeBytes( String.valueOf( j+1 ) + "      " );
              else
                  output.writeBytes( String.valueOf( j+1 ) + "     " );

              output.writeBytes( String.valueOf( arr[i][j][0] ) + "      " );
              output.writeBytes( String.valueOf( arr[i][j][1] ) + "      " );
              output.writeBytes( String.valueOf( arr[i][j][2] ) + "      " );
              output.writeBytes( "\n" );
            }

            output.writeBytes( "\n" );
          }

          String iStr =  String.valueOf( bIdx );
          output.writeBytes( " current block NO =  " + iStr + "\n\n" );

          for( int j = 0; j < tIdx; j++)
          {
              if( j < 9 )
                  output.writeBytes( String.valueOf( j+1 ) + "      " );
              else
                  output.writeBytes( String.valueOf( j+1 ) + "     " );

             output.writeBytes( String.valueOf( arr[bIdx][j][0] ) + "      " );
             output.writeBytes( String.valueOf( arr[bIdx][j][1] ) + "      " );
             output.writeBytes( String.valueOf( arr[bIdx][j][2] ) + "      " );
             output.writeBytes( "\n" );
          }
    }
    catch( IOException e )
    {
       JOptionPane.showMessageDialog( null, "file operation error",
                                     "Error", JOptionPane.ERROR_MESSAGE );
    }
  }

  public void saveStringData( String str )
  {
     try {
          long beginPos = output.length();

          output.seek( beginPos );
          output.writeBytes( "\n" );
          output.writeBytes( str );
     }
     catch( IOException e )
     {
        JOptionPane.showMessageDialog( null, "file operation error",
                                     "Error", JOptionPane.ERROR_MESSAGE );
     }
  }

  public void saveBlockData( int[] arr, int num, int totNum )
  {
    try {
          long beginPos = output.length();

          output.seek( beginPos );
          output.writeBytes( "\n\n" );

          for( int i = 0; i < num; i++ )
           if( ( i % INTERVAL ) == 0 )
           {
             /*
             String iStr = "Block "+ String.valueOf( i );
             //String iStr = String.valueOf( i ) + "    ";
             iStr += "  to block " + String.valueOf( i + INTERVAL - 1 );
             iStr += "'s on-target numbers =  ";

             output.writeBytes( iStr );
             */

             double sum = 0;
             for( int j = i; j < i + INTERVAL; j++ )
                  sum += arr[ j ];
             sum /= INTERVAL * totNum;
             String nStr = String.valueOf( sum );

             output.writeBytes( nStr );
             output.writeBytes( "\n" );
           }
    }
    catch( IOException e )
    {
       JOptionPane.showMessageDialog( null, "file operation error",
                                     "Error", JOptionPane.ERROR_MESSAGE );
    }
  }

}


