package tasksimulators;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.common.*;
import clarion.options.*;
import clarion.tools.*;
import main.ClarionMain;

public class NewSimulator extends Simulator{

  final int MAX_RUNNING_AGENT_NUM = 100;
  final int W_GUI = 0, O_GUI = 1;
  int runningAgentNum = 1;
  int settingMode;
  GuiClarion guiClarion;
  Class taskClarionClass = Global.getTaskClarionClass();
  TaskClarion[] taskClarions = new TaskClarion[MAX_RUNNING_AGENT_NUM];{
     try{
        for( int i = 0; i < runningAgentNum; i++ )
             taskClarions[i] = (TaskClarion)(taskClarionClass.newInstance());
     }
     catch( Exception e1 ){
            System.out.println( e1 );
     }
  }
  Global[] globals = new Global[MAX_RUNNING_AGENT_NUM];{
     for( int i = 0; i < runningAgentNum; i++ ){
          globals[i] = new Global();
          taskClarions[i].setGlobal( globals[i] );
          globals[i].setTaskClarion( taskClarions[i] );
     }
  }
  JLabel runningAgentNumLabel = new JLabel();
  JTextField runningAgentNumField = new JTextField();
  JLabel modeLabel = new JLabel();
  JRadioButton[] modeButtons = new JRadioButton[2]; {
      modeButtons[0] = new JRadioButton();
      modeButtons[1] = new JRadioButton();
  }
  JButton guiButton = new JButton();
  JFrame thisFrame;

  public NewSimulator( ClarionMain cExp, SimuTask task )
  {
     super( cExp, task );
     thisFrame = this;
     runningAgentNumLabel.setText( "Number of agents running simultineously (from 1 to 100)" );
     runningAgentNumLabel.setBounds( new Rectangle(0, 5, 320, 25 ) );
     runningAgentNumField.setText( String.valueOf(runningAgentNum) );
     runningAgentNumField.setBounds( new Rectangle(320, 5, 40, 20 ) );
     runningAgentNumField.addActionListener( new ActionListener() {
               public void actionPerformed( ActionEvent e ) {
                  try{
                    int num = Integer.parseInt( String.valueOf(runningAgentNumField.getText().trim()) );
                    if( num < 0 || num > MAX_RUNNING_AGENT_NUM ){
                        JOptionPane.showMessageDialog( null, "Out of range, reset !",
                                                    "Error", JOptionPane.ERROR_MESSAGE );
                        runningAgentNumField.setText( String.valueOf( runningAgentNum ));
                    }
                    runningAgentNum = num;
                    for( int i = 0; i < runningAgentNum; i++ ){
                         try{
                           if( taskClarions[i] == null )
                               taskClarions[i] = (TaskClarion)(taskClarionClass.newInstance());
                         }
                         catch( Exception e1 ){
                                System.out.println( e1 );
                         }
                         if( globals[i] == null )
                             globals[i] = new Global();
                         taskClarions[i].setGlobal( globals[i] );
                         globals[i].setTaskClarion( taskClarions[i] );
                    }
                  }
                  catch( NumberFormatException e1 ){
                     JOptionPane.showMessageDialog( null, "Not a number, reset !",
                                                    "Error", JOptionPane.ERROR_MESSAGE );
                  }
               }
     });
     modeLabel.setText( "Task setting loading mode" );
     modeLabel.setFont( new Font( "Serif", Font.BOLD, 20 ) );
     modeLabel.setBounds( new Rectangle(0, 40, 240, 30 ) );
     ButtonGroup buttonGroup = new ButtonGroup();
     String[] modeTexts = { "WITH GUI", "WITHOUT GUI" };
     Rectangle[] modeRects = { new Rectangle(20, 80, 120, 30), new Rectangle(20, 110, 140, 30)};
     for( int i = 0; i < 2; i++ ){
          modeButtons[i].setText( modeTexts[i]);
          modeButtons[i].setBounds( modeRects[i] );
          buttonGroup.add( modeButtons[i]);
          final int focus = i;
          modeButtons[focus].addActionListener( new ActionListener() {
              public void actionPerformed(ActionEvent e) {
                     settingMode = focus;
                     guiButton.setEnabled( focus == W_GUI );
                     Global.setSettingMode( settingMode == W_GUI );
              }
          });
     }
     modeButtons[0].setSelected( true );
     Global.setSettingMode( settingMode == W_GUI );
     guiButton.setText( "GUI" );
     guiButton.setBounds(new Rectangle(140, 80, 80, 20) );
     guiButton.addActionListener( new ActionListener() {
         public void actionPerformed(ActionEvent e) {
             if( guiClarion == null ){    // initialize clarion option GUI.
                 guiClarion = new GuiClarion( Global.SUBSYS_NUM, globals );
                 guiClarion.init( thisFrame );
             }
             guiClarion.setMainFrame( thisFrame );
             guiClarion.setRunningAgentNum( runningAgentNum );
             thisFrame.setEnabled( false );
             thisFrame.setVisible( false );
             guiClarion.setEnabled( true );
             guiClarion.setVisible( true );
         }
     });
     inPanel.add( runningAgentNumLabel );
     inPanel.add( runningAgentNumField );
     inPanel.add( modeLabel );
     inPanel.add( modeButtons[0] );
     inPanel.add( modeButtons[1] );
     inPanel.add( guiButton );
  }

  protected void enterButton_actionPerformed( ActionEvent e )
  {
      if( settingMode == W_GUI ){  // with GUI mode.
          System.out.println( "run with GUI !" );
          for( int i = 0; i < runningAgentNum; i++ )
               if( globals[i] == null ){
                   String str = "Settings of the agent - " + String.valueOf(i) +
                                " haven't been initialized, stop running!";
                   JOptionPane.showMessageDialog( null, str, "WARNING", JOptionPane.WARNING_MESSAGE );
                   return;
               }
          Global.getTask().setRunningAgentNum( runningAgentNum );
          Global.getTask().setGlobals( globals );
          Global.getTask().start();
          if( guiClarion != null )
              guiClarion.setCurAgentIdx( 0 );
      }
      else{   // without GUI mode.
          Global.getTask().setRunningAgentNum( runningAgentNum );
          Global.getTask().setGlobals( globals );
          Global.getTask().init();
          Global.getTask().start();
          if( guiClarion != null )
              guiClarion.setCurAgentIdx( 0 );
      }
  }
}