package tasksimulators;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import clarion.system.*;
import clarion.common.*;
import clarion.tools.*;
import main.ClarionMain;

public class PCsimulator extends Simulator{

  public PCsimulator( ClarionMain cExp, SimuTask task )
  {
     super( cExp, task );
     String str = "Input the Number of blocks(1 to " + String.valueOf( MAX_BLOCK_NUM ) + "):";
     JLabel inputBlockLabel = new JLabel( str );
     inputBlockLabel.setFont( new Font( "Serif", Font.BOLD, 20 ) );
     inPanel.add( inputBlockLabel );
     inputBlock = new JTextField( String.valueOf( blockNum ), 10 );
     inPanel.add( inputBlock );
     JLabel inputFileLabel = new JLabel( "The selected file to save your data:" );
     inputFileLabel.setFont( new Font( "Serif", Font.BOLD, 20 ) );
     inPanel.add( inputFileLabel );
     inputFileField = new JTextField( dataFileName, 10 );
     inputFileField.setEditable( false );
     inPanel.add( inputFileField );
     inputBlock.setEnabled( true );
     inputFileField.setEnabled( true );
     inputBlock.setEditable( true );
     inputFileField.setEditable( true );
  }

  protected boolean checkInput()
  {
    try {
          String blocks = inputBlock.getText();
          if ( blocks.length() == 0 ){
             JOptionPane.showMessageDialog( this, "Please input a number of block!",
                                         "Error", JOptionPane.ERROR_MESSAGE );
             return false;
          }
          blockNum = Integer.parseInt( blocks );
          if ( blockNum < MIN_BLOCK_NUM || blockNum > MAX_BLOCK_NUM ){
               JOptionPane.showMessageDialog( this, "Block_num out of range",
                                          "Error", JOptionPane.ERROR_MESSAGE );
               return false;
          }
          else
             return true;
    }
    catch( NumberFormatException nfe ){
       JOptionPane.showMessageDialog( this, "Please input a block number!!",
                                    "WARNING", JOptionPane.WARNING_MESSAGE );
         return false;
    }
  }

  protected boolean checkFile()
  {
     String str = inputFileField.getText();
     if( str.length() == 0 ){
         JOptionPane.showMessageDialog( this, "Please select a file !",
                                        "WARNING", JOptionPane.WARNING_MESSAGE );
        return false;
     }
     else
        return true;
  }
}