package tasksimulators.newsimu.OS;
import clarion.common.*;
import clarion.tools.*;
import clarion.nacs.*;
import clarion.system.*;

/**
 *  This class is for implementing what a task subject does in a task. In order
 *  for a task subject to communicate with CLARION properly, all of the methods
 *  in this class should be overrided by user codes.
 */

public class AgentOS extends TaskAgent{

   // global settings each running agent has.
   // protected Global  global;
   // clarion model.
   /// protected Clarion clarion;
   /// protected TaskClarion taskClarion;
   /// protected Feature[] curSensoryInput;

   /// protected double reinforcements[];
   /// protected int activeAmnIdx;
   /// protected boolean learningTestOn;
   /// protected WriteFile dataFile;

   private int lastResult;

   public AgentOS()
   {
   }

   public AgentOS( Global g )
   {
      super( g );
      reinforcements = new double[1];
      if(g.getOptionName().equals("subordinate"))
        curSensoryInput = new Feature[3];
      else // supervisor
        curSensoryInput = new Feature[9];
   }

   public void setOptions(double temp, double learn, double probBL)
   {
      global.setIdnActionSelectionTemp(0, temp);
      global.setIdnBPLearningRate(0, learn);

      double probabilities [] = new double[4];
      probabilities[0] = probBL;
      probabilities[1] = 1 - probBL;
      probabilities[2] = probabilities[3] = 0;

      global.setAcsCrossCombineParas(0, probabilities);
      reinit();
   }

   public void report(String msg)
   {
      System.out.println(msg);
      System.out.println("temperature = " + global.getIdnActionSelectionTemp(0));
      System.out.println("learning rate = " + global.getIdnBPLearningRate(0));
      System.out.println("p. BL:" + global.getAcsCrossCombineParas(0)[0]);
      System.out.println("p. RER:" + global.getAcsCrossCombineParas(0)[1]);
   }

   public void setSensoryInput(short[] inputs, int actualAnswer)
   {
      short[][] values = new short[inputs.length][1];
      for(int i = 0; i < inputs.length; i++)
        values[i][0] = inputs[i];

      for(int i = 0; i < inputs.length; i++)
        curSensoryInput[i] = new Feature(global.getFeatureNames()[0][i], (short) 0, (short) i, (short) 3, values[i], global);

      ((TaskClarionOS) taskClarion).actualAnswer = actualAnswer;
   }

    public boolean isControlNacsAction( int netIdx, short[] chosenAction )
    {
      return false;
    }

   // get the output of current step.
    public void getOutput( Object arr )
    {
      ((int[])arr)[0] = lastResult;
    }

    public int determineAmnNet( int netIdx, short[] action ) {
       return 0;
    }

    public void setRetrievalResults( int netIdx, GKSChunk[] results ) {}

   // perform the chosen action.
    public void performAction( int netIdx, short[] action )
    {
       lastResult = action[0];
    }

   // simulate a subject performance by step.
    public void run()
    {
       clarion.training();
    }

}
