package tasksimulators.newsimu.OS;
import java.util.Arrays;
import clarion.common.*;
import clarion.tools.*;
import clarion.nacs.*;
import clarion.acs.net.*;
import clarion.acs.net.auxiliary.*;
import clarion.acs.gs.*;
import clarion.acs.wm.*;
import clarion.system.*;

/**
 *  This class is for task specific part of CLARION. In order for a specific task
 *  to communicate with CLARION properly, all of the methods in this class should
 *  be overrided by user codes.
 */
public class TaskClarionOS extends TaskClarion{

  public int actualAnswer;

  public TaskClarionOS()
  {
  }

  // eligibility of ACS networks, return the eligible condition of the network.
  public short[][][] getEligibility( int netIdx )
  {
    if(global.getOptionName().equals("subordinate"))
    // set the eligibility for a subordinate
    {
      short[][][] eligCondition = {
                   {
                      {0,1,2},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1}
                   },
                };
      return eligCondition;
    }
    else // set the eligibility for a supervisor
    {
      short[][][] eligCondition = {
                   {
                      {0, 1, 2, 3, 4, 5, 6, 7, 8},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1},
                      {1,1,1}
                   },
                };
      return eligCondition;
    }
  }

  // reinforcement of ACS networks.
  public double getReinforcement( int netIdx, Feature[] input, Chunk[] wmChunks, GoalChunk goal,
                        short[] action, Feature[] newInput, Chunk[] newWMChunks, GoalChunk newGoal )
  {
     /**
      * int netIdx - the network NO.
        Feature[] input - current input,
        ( see the class Feature.java in subdirectory: clarion.common )
        Chunk[] wmChunks - current working memory status.
        ( see the class WMChunk.java in subdirectory: clarion.acs.wm )
        int goal - current goal.
        short[] action - current action.
        Feature[] newInput - new input resulting from firing the action.
        Chunk[] newWMChunks - new working memory status.
        int newGoal - new goal.
     */
     if(action[0] != actualAnswer)
       return 0;
     else
       return 1;
  }
}