package tasksimulators.newsimu.PC;
import clarion.system.*;
import clarion.common.*;
import clarion.acs.net.auxiliary.*;

public class IrlRuleFormPC implements IrlRuleForm {

      final int LEVEL_NUM = 12;
      int a, b, c, target, ruleSetIdx;
      int curAction, nextAction;

      public IrlRuleFormPC(){}

      public IrlRuleFormPC( int a, int b, int c, int target, int ruleSetIdx, int curAction )
      {
            this.a = a;
            this.b = b;
            this.c = c;
            this.target = target;
            this.ruleSetIdx = ruleSetIdx;
            this.curAction = curAction;
            nextAction = ( int ) ( target - b ) / a;
      }

      public double determineAction( short[] state, short[] exState, short[] gsState, short[] wmState,
                                     short[] suggestedAction )
      {
         int p1 = 0;
         for( int i = 0; i < state.length; i++ )
              if( state[i] == 1 ){
                  p1 = i;
                  break;
              }
         int chosenAction = Math.round( ( target - c * p1 - b ) / a );
         if ( chosenAction < 0 )
              chosenAction = 0;
         else if ( chosenAction > LEVEL_NUM - 1 )
                   chosenAction = LEVEL_NUM - 1;
         switch( ruleSetIdx )
         {
             case 0:  // action should be returned for this step.
             case 1:
                  curAction = chosenAction;
                  suggestedAction[0] = (short)curAction;
                  break;
             case 2:  // action should be returned for next step.
             case 3:
                  curAction = nextAction;
                  nextAction = chosenAction;
                  suggestedAction[0] = (short)curAction;
                  break;
         }
         return 1.0;
      }

      public void generalize()
      {
      }

      public void specialize()
      {
      }
}