package tasksimulators.oldsimu;
import clarion.common.*;

public class IDNet extends BackPropNet{

  final double THRESHOLD = 0.5;

  int NET_INPUT_NUM, NET_HIDDEN_NUM, NET_OUTPUT_NUM;
  int dimNum, dimValNums[];

  public IDNet( int inputNum, int hiddenNum, int outputNum, int dNum, int[] dValNums )
  {
      super( inputNum, hiddenNum, outputNum );

      NET_INPUT_NUM = inputNum;
      NET_HIDDEN_NUM = hiddenNum;
      NET_OUTPUT_NUM = outputNum;

      dimNum = dNum;
      dimValNums = new int[ dimNum ];
      for( int i = 0; i < dimNum; i++ )
           dimValNums[ i ] = dValNums[ i ];
  }

  public void getOutput( short[] arr )
  {
     for( int i = 0; i < arr.length; i++ )
          if( Output[ i ] >= THRESHOLD )
              arr[ i ] = 1;
          else
              arr[ i ] = 0;
  }

  public void getOutput( short[][] arr )
  {
      int offset = 0;
      for( int i = 0; i < dimNum; i++ )
      {
           for( int j = 0; j <  dimValNums[ i ]; j++ )
           {
                if( Output[ offset + j ] >= THRESHOLD )
                    arr[ i ][ j ] = 1;
                else
                    arr[ i ][ j ] = 0;
           }
           offset += dimValNums[i];
      }
  }

  public void setInputByDim( short[] arr )
  {
      int offset = 0;
      for( int i = 0; i < arr.length; i++ )
      {
           Input[ offset + arr[i] ] = 1;
           offset += dimValNums[i];
      }
  }

  public void setInput( short[] arr )
  {
      for( int i = 0; i < arr.length; i++ )
           Input[ i ] = arr[ i ];
  }

  public void setInput( short[][] arr )
  {
      int offset = 0;
      for( int i = 0; i < arr.length; i++ )
      {
           for( int j = 0; j < dimValNums[i]; j++ )
                Input[ offset + j ] = arr[ i ][ j ];
           offset += dimValNums[i];
      }
  }

  public void setInput( short[][][] arr )
  {
      int offset = 0, dimOffset = 0;
      for( int i = 0; i < arr.length; i++ )
      {
           for( int j = 0; j < arr[i].length; j++ )
           {
                for( int k = 0; k < dimValNums[ dimOffset ]; k++ )
                     Input[ offset + k ] = arr[ i ][ j ][ k ];
                offset += dimValNums[ dimOffset ];
                dimOffset++;
           }
      }
  }

  public void setDesiredOutputByDim( short[] arr )
  {
      int offset = 0;
      for( int i = 0; i < arr.length; i++ )
      {
           DesiredOutput[ offset + arr[i] ] = 1;
           offset += dimValNums[i];
      }
  }

  public void setDesiredOutput( short[] arr )
  {
      for( int i = 0; i < arr.length; i++ )
           DesiredOutput[ i ] = arr[ i ];
  }

  public void setDesiredOutput( short[][] arr )
  {
      int offset = 0;
      for( int i = 0; i < arr.length; i++ )
      {
           for( int j = 0; j < dimValNums[i]; j++ )
                DesiredOutput[ offset + j ] = arr[ i ][ j ];
           offset += dimValNums[i];
      }
  }

  public void setDesiredOutput( short[][][] arr )
  {
      int offset = 0, dimOffset = 0;
      for( int i = 0; i < arr.length; i++ )
      {
           for( int j = 0; j < arr[i].length; j++ )
           {
                for( int k = 0; k < dimValNums[ dimOffset ]; k++ )
                     DesiredOutput[ offset + k ] = arr[ i ][ j ][ k ];
                offset += dimValNums[ dimOffset ];
                dimOffset++;
           }
      }
  }
}
