/* fix rules class for using rule utility, rule BLA, rule support etc. */
package tasksimulators.oldsimu;
import java.lang.*;
import java.util.Vector;
import java.awt.*;
import clarion.common.*;
import clarion.tools.*;

public class LCFixRule {

  int TOT_NUM;
  int currentTime, ruleInfoArr[];
  boolean defFlagArr[];

  ConItem[] condition, conclusion;
  RuleFeature feature;

  public LCFixRule( ConItem[] con, ConItem[] act, int tNo, int totNum, double initBLA )
  {
        TOT_NUM = totNum;
        condition = new ConItem[ con.length ];
        for( int i = 0; i < con.length; i++ )
             condition[i] = con[i];
        conclusion = new ConItem[ act.length ];
        for( int i = 0; i < act.length; i++ )
             conclusion[i] = act[i];

        initRuleFeature( initBLA );
  }

  public void initRuleFeature( double initBLA )
  {
        ruleInfoArr = new int[2];

        int len = World.MODEL_PARA_ARRAY[ World.RULE_BLA_OPT ].length;
        for( int i = 0; i < len; i++ )
          if( World.MODEL_PARA_ARRAY[ World.RULE_BLA_OPT ][i] == 1 )
          {
              ruleInfoArr[ 0 ] = i;
              break;
          }

        len = World.MODEL_PARA_ARRAY[ World.RULE_UTL_OPT ].length;
        for( int i = 0; i < len; i++ )
          if( World.MODEL_PARA_ARRAY[ World.RULE_UTL_OPT ][i] == 1 )
          {
              ruleInfoArr[ 1 ] = i;
              break;
          }

        defFlagArr = new boolean[2];
        defFlagArr[0] = true;
        defFlagArr[1] = true;

        feature = new RuleFeature( TOT_NUM, initBLA, ruleInfoArr, defFlagArr );
  }

  public void reinit()
  {
        feature.reinit();
  }

  public double getPM()
  {
        return feature.getPM();
  }

  public double getNM()
  {
        return feature.getNM();
  }

  public int getRT()
  {
        return feature.getResponseTime();
  }

  public double getBLA()
  {
        return feature.getBLA();
  }

  public double getUtility()
  {
        return feature.getUtility();
  }

  public ConItem[] getConclusion()
  {
        return conclusion;
  }

  public int getConcDimIdx( int ruleIdx )
  {
        int idx = 0;
        switch( ruleIdx )
        {
           case 2:
           case 4: idx = 3;
                   break;
           case 3:
           case 5: idx = 0;
                   break;
        }

        return idx;
  }

  public void setCurTime( int curTime )
  {
        currentTime = curTime;
  }

  public void setRuleCost( double cost )
  {
     feature.setCost( cost );
  }

  public void setRuleActionTime( double val )
  {
     feature.setActionTime( val );
  }

  public void setRulePreBLA( double val )
  {
     feature.setPreBLA( val );
  }

  public void setPreChunkBLA( double val )
  {
     feature.setPreChunkBLA( val );
  }

  public void fillConclusion( int ruleIdx, ConItem[] problem )
  {
        switch ( ruleIdx )
        {
          case 0: conclusion[1].setSlots( 1, problem[1].getSlots().elementAt(1) );
                  break;
          case 1: conclusion[1].setSlots( 1, problem[1].getSlots().elementAt(1) );
                  break;
          case 2: conclusion[1].setSlots( 1, problem[1].getSlots().elementAt(1) );
                  break;
          case 3: conclusion[4].setSlots( 1, problem[1].getSlots().elementAt(1) );
                  break;
          case 4: conclusion[1].setSlots( 1, problem[1].getSlots().elementAt(1) );
                  break;
          case 5: conclusion[4].setSlots( 1, problem[1].getSlots().elementAt(1) );
                  break;
          default:
                  break;
        }

        conclusion[3].setSlots( 1, problem[2].getSlots().elementAt(1) );
  }

  public void calcUtility( )
  {
      feature.calcUtility();
  }

  public void calcBLA ()
  {
         feature.calcBLA( currentTime );
  }

  public void calcTLDT( int num )
  {
         feature.calcTLDT( num );
  }

  public void calcTLDT( )
  {
         feature.calcTLDT();
  }

  public void calcTLAT ( double val )
  {
         feature.calcTLAT( val );
  }

  public void update( boolean succFlag )
  {
         feature.updateMatchCounts( succFlag );
         if( succFlag )
             feature.updateUsageInfo( currentTime );
  }

  public boolean patternMatch( ConItem[] con )
  {
        for( int i = 0; i < condition.length; i++ )
        {
            if( !condition[i].match( con[i] ) )
                return false;
        }
        return true;
  }
}
