// Rule reasoning part for the dynamic control task
package tasksimulators.oldsimu;
import java.lang.*;
import clarion.common.*;

public class PCFixRule
{
    private final int RULE_NUM = 12;

    int   action, P1, target;
    int[][] fixRuleArray;

    PCFixRule( int goal, int initAction, int initOutput )
    {
        target = goal;
        action = initAction;
        P1 = initOutput;

        fixRuleArray = new int[ RULE_NUM ][ 2 ];
        for( int i = 0; i < RULE_NUM; i++ )
        {
             fixRuleArray[ i ][ 0 ] =  i;
             fixRuleArray[ i ][ 1 ] = randomFixedRule( i );
        }
    }

    public int randomFixedRule( int preOutput )
    {
       int n, iRand;
       double randomVal = Math.random();
       iRand = ( int ) ( randomVal * 3 );

       switch ( iRand )
       {
          case 0:
                  n = 1;
                  break;
          case 1:
                  n = 0;
                  break;
          case 2:
                  n = -1;
                  break;
          default:
                  n = 0;
                  break;
       }

       int curInput = ( target + preOutput + n ) / 2;
       return curInput;
    }

    // set previous action and output after updating rules.
    public void setParams( int oldAction, int oldOutput )
    {
        action = oldAction;
        P1 = oldOutput;
    }

   //determine the desirabilities of all the actions by the current rule set.
    public double[] getRecommendedAction()
    {
	//zero out the FillMe array
        double[] FillMe = new double[ (int)World.TASK_PARA_ARRAY[World.NET_OUTPUT_NUM] ];

	for( int j = 0; j < (int)World.TASK_PARA_ARRAY[World.NET_OUTPUT_NUM]; j++ )
             FillMe[j] = 0;

        action =  fixRuleArray[ P1 ][ 1 ];
        FillMe[ action ] = World.MAX_ACTIVATION_VAL;
        return FillMe;
    }

    public StringBuffer getRules()
    {
        int W = fixRuleArray[ P1 ][ 1 ];
        String str = String.valueOf( P1 ) + " --> " + String.valueOf( W );
        StringBuffer ruleStr = new StringBuffer( str );
        return ruleStr;
    }
}

