package tasksimulators.oldsimu;
import clarion.acs.*;

public class RerWM extends WorkingMemory{

  final int SET_TYPE = 0, RESET_TYPE = 1, ILLEGAL_TYPE = -1;

  int wmAction, wmBLAction, wmTLAction;
  int actionType, discLocs[], nodeInfoArr[];
  double blSuccRate, tlSuccRate;
  T_RerRuleSet rerRuleSet;

  public RerWM(  int size, int dimNum, int stateLen,
                 int[] netInfoArr, int[] dimValInfo )
  {
       super( size, dimNum, stateLen, netInfoArr, dimValInfo );

       nodeInfoArr = new int[ netInfoArr.length + 1];
       nodeInfoArr[ 0 ] = netInfoArr[ 0 ];
       for( int i = 0; i < netInfoArr.length; i++ )
            nodeInfoArr[ i +1  ] = netInfoArr[ i ];

       rerRuleSet = new T_RerRuleSet( 1, 0, nodeInfoArr, true );
  }

  public void reinit()
  {
      super.reinit();
      rerRuleSet.reinit();
  }

   public void initDiscLocs( int discNum )
   {
      discLocs = new int[ discNum ];
   }

  public double getBLSuccRate()
  {
      blSuccRate = super.getSuccRate();
      return blSuccRate;
  }

  public double getTLSuccRate()
  {
      tlSuccRate = 1.0;
      return tlSuccRate;
  }

  public int getActionBL( int[] condition )
  {
      wmBLAction = getAction( condition );
      return wmBLAction;
  }

  public int getActionTL( int[] condition )
  {
       wmTLAction = rerRuleSet.getAction( condition );
       return wmTLAction;
  }

  public double getQVal( int aciton )
  {
      double qval = wmNet.getQVal( action );
      return qval;
  }

  public void setDiscLocs( int[] arr )
  {
      for( int i = 0; i < arr.length; i++ )
           discLocs[ i ] = arr[ i ];
  }

  public void setThreshold( double th )
  {
      threshold = th;
  }

  public void setThreshold( double th1, double th2 )
  {
      rerRuleSet.setThreshold( th1, th2 );
  }

  public void setValidNum( int num )
  {
      rerRuleSet.setValidDimNum( num );
  }

  public void setFullFlag( boolean flag )
  {
      rerRuleSet.setFullFlag( flag );
  }

  // check if the chosen action is legal.
  public boolean checkAction( int chosenAction )
  {
      wmAction = chosenAction;
      actionType = ILLEGAL_TYPE;

      if( chosenAction == - 1 )
      {
          actionType = ILLEGAL_TYPE;
          return false;
      }

      int size = chosenAction / 2;
      if( size > size_WM -1 && size < DIM_NUM )
      {
          actionType = ILLEGAL_TYPE;
          return false;
      }

      int type = chosenAction % 2;
      if( type == 0 )
          actionType = SET_TYPE;
      else
          actionType = RESET_TYPE;

      return true;
  }

  // get the active values of each dim.
  public void getActiveVals( )
  {
  /*
     int BLOCK_SIZE = DIM_VAL_NUM * DIM_VAL_NUM;
     for( int i = 0; i < discLocs.length; i++ )
     {
          int dSize = discLocs[ i ] % DIM_VAL_NUM;
          int idx = discLocs[ i ] / BLOCK_SIZE;
          activeValArr[ dSize ] = idx;
     }
  */
  }

  public void performAction()
  {
      getActiveVals();
      int idx = wmAction / 2;
      if( wmAction < 12 )
      {
          if( actionType == SET_TYPE )
              actionSet( idx, null );
          else
              actionReset( idx );
      }
      else if( wmAction < 14 )
           {
               if( actionType == SET_TYPE )
                   actionNo();
               else
                   actionResetAll();
           }
  }

  public void update(  boolean flag )
  {
      updateAction( wmAction );
      if( action < 0 )
          return;

      if( flag )
      {
          legalUpdate();
          // update RER rule set if the RER flag is set.
          double r = wmNet.getReinforcement();
          double d = wmNet.getDiscount();
          if( r + d * wmQValue2 - wmQValue1 > threshold )
              rerRuleSet.updateRuleSet( preState, action, true, false, true );
          else
              rerRuleSet.updateRuleSet( preState, action, false, false, true );
      }
      else
      {
          illegalUpdate();
          if( levelFlag == TOP_LEVEL )
              rerRuleSet.deleteRule( preState, action );
      }
  }

  public StringBuffer getAllRules()
  {
      return rerRuleSet.getAllRules();
  }

  public StringBuffer getMatchRules()
  {
      return rerRuleSet.getMatchRules();
  }

  public StringBuffer getChosenRules()
  {
      return rerRuleSet.getChosenRules();
  }
}