package tasksimulators.oldsimu;
import clarion.common.*;
import clarion.tools.*;

public class THFixRuleSet {

   int ruleNum, chosenRule, chosenAction;
   int matchCount, matchedRule[];

   double SUCC_C3 = 1.0, SUCC_C4 = 2.0;
   double succRate, sumPM, sumNM;

   StochasticDecider ruleDecider;  // action decider
   THFixRule thRuleSet[];

   public THFixRuleSet( int tNo, int num, THFixRule[] rSet )
   {
      sumPM = 0.0;
      sumNM = 0.0;
      succRate = ( SUCC_C3 + sumPM ) / ( SUCC_C4 + sumPM + sumNM );

      ruleNum = num;
      thRuleSet = new THFixRule[ ruleNum ];
      for( int i = 0; i < num; i++ )
           thRuleSet[ i ] = rSet[ i ];

      matchedRule = new int[ ruleNum ];
      ruleDecider = new StochasticDecider( ruleNum,
                        World.TASK_PARA_ARRAY[ World.TEMPERATURE ] );
   }

   public THFixRuleSet( int tNo, int num )
   {
      sumPM = 0.0;
      sumNM = 0.0;
      succRate = ( SUCC_C3 + sumPM ) / ( SUCC_C4 + sumPM + sumNM );

      ruleNum = num;
      thRuleSet = new THFixRule[ ruleNum ];
      for( int i = 0; i < num; i++ )
           thRuleSet[ i ] = new THFixRule( 6, 18, 6, 6, 3 );
   }

   public void reinit()
   {
      sumPM = 0.0;
      sumNM = 0.0;
      succRate = ( SUCC_C3 + sumPM ) / ( SUCC_C4 + sumPM + sumNM );

      thRuleSet[ 0 ].reinit();
   }

   public double getSuccRate()
   {
      succRate = 1.0;
      return succRate;
   }

   // used for TOH.
   public void getResult( int[] wmState, int[] exState, int[] gsState,
                          int[] result )
   {
       thRuleSet[ 0 ].setCondition( wmState, exState, gsState );
       thRuleSet[ 0 ].matchRule();
       thRuleSet[ 0 ].getResultArr( result );
   }

   public int getChosenRule()
   {
       return chosenRule;
   }

   public boolean getGoalFlag(  )
   {
      return thRuleSet[ 0 ].getGoalFlag();
   }
   public void getTopFlags( boolean[] flagArr )
   {
      thRuleSet[ 0 ].getFlags( flagArr );
   }

   public void setTopFlags()
   {
      thRuleSet[ 0 ].setFlags();
   }

   public void setCurMovedDisc( int dSize )
   {
      thRuleSet[ 0 ].setCurMovedDisc( dSize );
   }

   public StringBuffer getRules()
   {
       StringBuffer strBuf = new StringBuffer("aaaa");
       return strBuf;
   }
 }